#include "ruby.h"
#include "narray.h"


static VALUE
aptime(self)
    VALUE self;
{
    double sec1;
    VALUE sec;




    aptime_(&sec1);


    sec = rb_float_new(sec1);

    return sec;
}

static VALUE
stinit(self,mm,jm,im)
    VALUE self,mm,jm,im;
{
    int mm1;
    int jm1;
    int im1;
    struct NARRAY *q1;
    VALUE q;
    struct NARRAY *r1;
    VALUE r;
    struct NARRAY *it1;
    VALUE it;
    struct NARRAY *t1;
    VALUE t;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    shape[0] = (jm1*(mm1+1));
    q = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(q,q1);
    shape[0] = ((mm1+1)*(mm1+1));
    r = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(r,r1);
    shape[0] = (5);
    it = na_make_object( NA_LINT, rank, shape, cNArray );
    GetNArray(it,it1);
    shape[0] = (im1*2);
    t = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(t,t1);

    stinit_(&mm1,&jm1,&im1,q1->ptr,r1->ptr,it1->ptr,t1->ptr);



    return rb_ary_new3(4, q, r, it, t);
}

static VALUE
ltinit(self,mm,jm)
    VALUE self,mm,jm;
{
    int mm1;
    int jm1;
    struct NARRAY *q1;
    VALUE q;
    struct NARRAY *r1;
    VALUE r;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    shape[0] = (jm1*(mm1+1));
    q = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(q,q1);
    shape[0] = ((mm1+1)*(mm1+1));
    r = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(r,r1);

    ltinit_(&mm1,&jm1,q1->ptr,r1->ptr);



    return rb_ary_new3(2, q, r);
}

static VALUE
stogrd(self,jm,im,q)
    VALUE self,jm,im,q;
{
    int jm1;
    int im1;
    struct NARRAY *y1;
    VALUE y;
    struct NARRAY *x1;
    VALUE x;
    struct NARRAY *q1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    shape[0] = (jm1);
    y = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(y,y1);
    shape[0] = (im1);
    x = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(x,x1);
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: q : %d < jm1 = %d ", *q1->shape, jm1 );

    stogrd_(&jm1,&im1,y1->ptr,x1->ptr,q1->ptr);



    return rb_ary_new3(2, y, x);
}

static VALUE
ltogrd(self,jm,q)
    VALUE self,jm,q;
{
    int jm1;
    struct NARRAY *y1;
    VALUE y;
    struct NARRAY *q1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    jm1 = NUM2INT(jm);
    shape[0] = (jm1);
    y = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(y,y1);
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: q : %d < jm1 = %d ", *q1->shape, jm1 );

    ltogrd_(&jm1,y1->ptr,q1->ptr);



    return y;
}

static VALUE
stnm2l(self,mm,n,m)
    VALUE self,mm,n,m;
{
    int mm1;
    int n1;
    int m1;
    int l1;
    VALUE l;



    mm1 = NUM2INT(mm);
    n1 = NUM2INT(n);
    m1 = NUM2INT(m);

    stnm2l_(&mm1,&n1,&m1,&l1);


    l = INT2NUM(l1);

    return l;
}

static VALUE
stl2nm(self,mm,l)
    VALUE self,mm,l;
{
    int mm1;
    int l1;
    int n1;
    VALUE n;
    int m1;
    VALUE m;



    mm1 = NUM2INT(mm);
    l1 = NUM2INT(l);

    stl2nm_(&mm1,&l1,&n1,&m1);


    n = INT2NUM(n1);
    m = INT2NUM(m1);

    return rb_ary_new3(2, n, m);
}

static VALUE
stclfa(self,mm,a)
    VALUE self,mm,a;
{
    int mm1;
    struct NARRAY *a1;
    struct NARRAY *b1;
    VALUE b;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)) = %d ", *a1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    b = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(b,b1);

    stclfa_(&mm1,a1->ptr,b1->ptr);



    return b;
}

static VALUE
ltclfz(self,mm,a)
    VALUE self,mm,a;
{
    int mm1;
    struct NARRAY *a1;
    struct NARRAY *b1;
    VALUE b;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)) = %d ", *a1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    b = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(b,b1);

    ltclfz_(&mm1,a1->ptr,b1->ptr);



    return b;
}

static VALUE
ltclfw(self,mm,m,a)
    VALUE self,mm,m,a;
{
    int mm1;
    int m1;
    struct NARRAY *a1;
    struct NARRAY *b1;
    VALUE b;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    m1 = NUM2INT(m);
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)) = %d ", *a1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    b = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(b,b1);

    ltclfw_(&mm1,&m1,a1->ptr,b1->ptr);



    return b;
}

static VALUE
stclba(self,mm,a)
    VALUE self,mm,a;
{
    int mm1;
    struct NARRAY *a1;
    struct NARRAY *b1;
    VALUE b;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)) = %d ", *a1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    b = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(b,b1);

    stclba_(&mm1,a1->ptr,b1->ptr);



    return b;
}

static VALUE
ltclbz(self,mm,a)
    VALUE self,mm,a;
{
    int mm1;
    struct NARRAY *a1;
    struct NARRAY *b1;
    VALUE b;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)) = %d ", *a1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    b = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(b,b1);

    ltclbz_(&mm1,a1->ptr,b1->ptr);



    return b;
}

static VALUE
ltclbw(self,mm,m,a)
    VALUE self,mm,m,a;
{
    int mm1;
    int m1;
    struct NARRAY *a1;
    struct NARRAY *b1;
    VALUE b;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    m1 = NUM2INT(m);
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)) = %d ", *a1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    b = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(b,b1);

    ltclbw_(&mm1,&m1,a1->ptr,b1->ptr);



    return b;
}

static VALUE
sts2ga(self,mm,jm,im,s,p,q,r,it,t)
    VALUE self,mm,jm,im,s,p,q,r,it,t;
{
    int mm1;
    int jm1;
    int im1;
    struct NARRAY *s1;
    struct NARRAY *g1;
    VALUE g;
    struct NARRAY *p1;
    struct NARRAY *q1;
    struct NARRAY *r1;
    struct NARRAY *it1;
    struct NARRAY *t1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    s = na_cast_object(s, NA_DFLOAT);
    GetNArray(s,s1);
    if ( *s1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: s : %d != ((mm1+1)*(mm1+1)) = %d ", *s1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = (jm1*im1);
    g = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(g,g1);
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (jm1*im1) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (jm1*im1) = %d ", *p1->shape, (jm1*im1) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (jm1*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (jm1*(mm1+1)) = %d ", *q1->shape, (jm1*(mm1+1)) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != ((mm1+1)*(mm1+1)) = %d ", *r1->shape, ((mm1+1)*(mm1+1)) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );

    sts2ga_(&mm1,&jm1,&im1,s1->ptr,g1->ptr,p1->ptr,q1->ptr,r1->ptr,it1->ptr,t1->ptr);



    return g;
}

static VALUE
lts2gz(self,mm,jm,s,p,q,r,im)
    VALUE self,mm,jm,s,p,q,r,im;
{
    int mm1;
    int jm1;
    struct NARRAY *s1;
    struct NARRAY *g1;
    VALUE g;
    struct NARRAY *p1;
    struct NARRAY *q1;
    struct NARRAY *r1;
    int im1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    s = na_cast_object(s, NA_DFLOAT);
    GetNArray(s,s1);
    if ( *s1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: s : %d != ((mm1+1)*(mm1+1)) = %d ", *s1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = (jm1*im1);
    g = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(g,g1);
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: p : %d < jm1 = %d ", *p1->shape, jm1 );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (jm1*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (jm1*(mm1+1)) = %d ", *q1->shape, (jm1*(mm1+1)) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != ((mm1+1)*(mm1+1)) = %d ", *r1->shape, ((mm1+1)*(mm1+1)) );
    im1 = NUM2INT(im);

    lts2gz_(&mm1,&jm1,s1->ptr,g1->ptr,p1->ptr,q1->ptr,r1->ptr,&im1);



    return g;
}

static VALUE
lts2gw(self,mm,jm,m,s,p,q,r,im)
    VALUE self,mm,jm,m,s,p,q,r,im;
{
    int mm1;
    int jm1;
    int m1;
    struct NARRAY *s1;
    struct NARRAY *g1;
    VALUE g;
    struct NARRAY *p1;
    struct NARRAY *q1;
    struct NARRAY *r1;
    int im1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    m1 = NUM2INT(m);
    s = na_cast_object(s, NA_DFLOAT);
    GetNArray(s,s1);
    if ( *s1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: s : %d != ((mm1+1)*(mm1+1)) = %d ", *s1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = (jm1*im1);
    g = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(g,g1);
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: p : %d < jm1 = %d ", *p1->shape, jm1 );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (jm1*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (jm1*(mm1+1)) = %d ", *q1->shape, (jm1*(mm1+1)) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != ((mm1+1)*(mm1+1)) = %d ", *r1->shape, ((mm1+1)*(mm1+1)) );
    im1 = NUM2INT(im);

    lts2gw_(&mm1,&jm1,&m1,s1->ptr,g1->ptr,p1->ptr,q1->ptr,r1->ptr,&im1);



    return g;
}

static VALUE
sts2va(self,mm,jm,im,s,p,q,r,it,t)
    VALUE self,mm,jm,im,s,p,q,r,it,t;
{
    int mm1;
    int jm1;
    int im1;
    struct NARRAY *s1;
    struct NARRAY *u1;
    VALUE u;
    struct NARRAY *v1;
    VALUE v;
    struct NARRAY *p1;
    struct NARRAY *q1;
    struct NARRAY *r1;
    struct NARRAY *it1;
    struct NARRAY *t1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    s = na_cast_object(s, NA_DFLOAT);
    GetNArray(s,s1);
    if ( *s1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: s : %d != ((mm1+1)*(mm1+1)) = %d ", *s1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = (jm1*im1);
    u = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(u,u1);
    shape[0] = (jm1*im1);
    v = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(v,v1);
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (jm1*im1) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (jm1*im1) = %d ", *p1->shape, (jm1*im1) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (jm1*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (jm1*(mm1+1)) = %d ", *q1->shape, (jm1*(mm1+1)) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != ((mm1+1)*(mm1+1)) = %d ", *r1->shape, ((mm1+1)*(mm1+1)) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );

    sts2va_(&mm1,&jm1,&im1,s1->ptr,u1->ptr,v1->ptr,p1->ptr,q1->ptr,r1->ptr,it1->ptr,t1->ptr);



    return rb_ary_new3(2, u, v);
}

static VALUE
lts2vz(self,mm,jm,s,p,q,r,im)
    VALUE self,mm,jm,s,p,q,r,im;
{
    int mm1;
    int jm1;
    struct NARRAY *s1;
    struct NARRAY *v1;
    VALUE v;
    struct NARRAY *p1;
    struct NARRAY *q1;
    struct NARRAY *r1;
    int im1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    s = na_cast_object(s, NA_DFLOAT);
    GetNArray(s,s1);
    if ( *s1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: s : %d != ((mm1+1)*(mm1+1)) = %d ", *s1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = (jm1*im1);
    v = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(v,v1);
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: p : %d < jm1 = %d ", *p1->shape, jm1 );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (jm1*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (jm1*(mm1+1)) = %d ", *q1->shape, (jm1*(mm1+1)) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != ((mm1+1)*(mm1+1)) = %d ", *r1->shape, ((mm1+1)*(mm1+1)) );
    im1 = NUM2INT(im);

    lts2vz_(&mm1,&jm1,s1->ptr,v1->ptr,p1->ptr,q1->ptr,r1->ptr,&im1);



    return v;
}

static VALUE
lts2vw(self,mm,jm,m,s,p,q,r,im)
    VALUE self,mm,jm,m,s,p,q,r,im;
{
    int mm1;
    int jm1;
    int m1;
    struct NARRAY *s1;
    struct NARRAY *u1;
    VALUE u;
    struct NARRAY *v1;
    VALUE v;
    struct NARRAY *p1;
    struct NARRAY *q1;
    struct NARRAY *r1;
    int im1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    m1 = NUM2INT(m);
    s = na_cast_object(s, NA_DFLOAT);
    GetNArray(s,s1);
    if ( *s1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: s : %d != ((mm1+1)*(mm1+1)) = %d ", *s1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = (jm1*im1);
    u = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(u,u1);
    shape[0] = (jm1*im1);
    v = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(v,v1);
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: p : %d < jm1 = %d ", *p1->shape, jm1 );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (jm1*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (jm1*(mm1+1)) = %d ", *q1->shape, (jm1*(mm1+1)) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != ((mm1+1)*(mm1+1)) = %d ", *r1->shape, ((mm1+1)*(mm1+1)) );
    im1 = NUM2INT(im);

    lts2vw_(&mm1,&jm1,&m1,s1->ptr,u1->ptr,v1->ptr,p1->ptr,q1->ptr,r1->ptr,&im1);



    return rb_ary_new3(2, u, v);
}

static VALUE
stsrva(self,mm,jm,im,s,p,q,r,it,t)
    VALUE self,mm,jm,im,s,p,q,r,it,t;
{
    int mm1;
    int jm1;
    int im1;
    struct NARRAY *s1;
    struct NARRAY *u1;
    VALUE u;
    struct NARRAY *v1;
    VALUE v;
    struct NARRAY *p1;
    struct NARRAY *q1;
    struct NARRAY *r1;
    struct NARRAY *it1;
    struct NARRAY *t1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    s = na_cast_object(s, NA_DFLOAT);
    GetNArray(s,s1);
    if ( *s1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: s : %d != ((mm1+1)*(mm1+1)) = %d ", *s1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = (jm1*im1);
    u = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(u,u1);
    shape[0] = (jm1*im1);
    v = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(v,v1);
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (jm1*im1) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (jm1*im1) = %d ", *p1->shape, (jm1*im1) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (jm1*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (jm1*(mm1+1)) = %d ", *q1->shape, (jm1*(mm1+1)) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != ((mm1+1)*(mm1+1)) = %d ", *r1->shape, ((mm1+1)*(mm1+1)) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );

    stsrva_(&mm1,&jm1,&im1,s1->ptr,u1->ptr,v1->ptr,p1->ptr,q1->ptr,r1->ptr,it1->ptr,t1->ptr);



    return rb_ary_new3(2, u, v);
}

static VALUE
ltsrvz(self,mm,jm,s,p,q,r,im)
    VALUE self,mm,jm,s,p,q,r,im;
{
    int mm1;
    int jm1;
    struct NARRAY *s1;
    struct NARRAY *u1;
    VALUE u;
    struct NARRAY *p1;
    struct NARRAY *q1;
    struct NARRAY *r1;
    int im1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    s = na_cast_object(s, NA_DFLOAT);
    GetNArray(s,s1);
    if ( *s1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: s : %d != ((mm1+1)*(mm1+1)) = %d ", *s1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = (jm1*im1);
    u = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(u,u1);
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: p : %d < jm1 = %d ", *p1->shape, jm1 );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (jm1*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (jm1*(mm1+1)) = %d ", *q1->shape, (jm1*(mm1+1)) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != ((mm1+1)*(mm1+1)) = %d ", *r1->shape, ((mm1+1)*(mm1+1)) );
    im1 = NUM2INT(im);

    ltsrvz_(&mm1,&jm1,s1->ptr,u1->ptr,p1->ptr,q1->ptr,r1->ptr,&im1);



    return u;
}

static VALUE
ltsrvw(self,mm,jm,m,s,p,q,r,im)
    VALUE self,mm,jm,m,s,p,q,r,im;
{
    int mm1;
    int jm1;
    int m1;
    struct NARRAY *s1;
    struct NARRAY *u1;
    VALUE u;
    struct NARRAY *v1;
    VALUE v;
    struct NARRAY *p1;
    struct NARRAY *q1;
    struct NARRAY *r1;
    int im1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    m1 = NUM2INT(m);
    s = na_cast_object(s, NA_DFLOAT);
    GetNArray(s,s1);
    if ( *s1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: s : %d != ((mm1+1)*(mm1+1)) = %d ", *s1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = (jm1*im1);
    u = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(u,u1);
    shape[0] = (jm1*im1);
    v = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(v,v1);
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: p : %d < jm1 = %d ", *p1->shape, jm1 );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (jm1*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (jm1*(mm1+1)) = %d ", *q1->shape, (jm1*(mm1+1)) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != ((mm1+1)*(mm1+1)) = %d ", *r1->shape, ((mm1+1)*(mm1+1)) );
    im1 = NUM2INT(im);

    ltsrvw_(&mm1,&jm1,&m1,s1->ptr,u1->ptr,v1->ptr,p1->ptr,q1->ptr,r1->ptr,&im1);



    return rb_ary_new3(2, u, v);
}

static VALUE
stg2sa(self,mm,jm,im,g,p,q,r,it,t)
    VALUE self,mm,jm,im,g,p,q,r,it,t;
{
    int mm1;
    int jm1;
    int im1;
    struct NARRAY *g1;
    struct NARRAY *s1;
    VALUE s;
    struct NARRAY *p1;
    struct NARRAY *q1;
    struct NARRAY *r1;
    struct NARRAY *it1;
    struct NARRAY *t1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    g = na_cast_object(g, NA_DFLOAT);
    GetNArray(g,g1);
    if ( *g1->shape != (jm1*im1) ) rb_raise(rb_eArgError, "invalid ary size: g : %d != (jm1*im1) = %d ", *g1->shape, (jm1*im1) );
    shape[0] = ((mm1+1)*(mm1+1));
    s = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(s,s1);
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (jm1*im1) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (jm1*im1) = %d ", *p1->shape, (jm1*im1) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (jm1*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (jm1*(mm1+1)) = %d ", *q1->shape, (jm1*(mm1+1)) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != ((mm1+1)*(mm1+1)) = %d ", *r1->shape, ((mm1+1)*(mm1+1)) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );

    stg2sa_(&mm1,&jm1,&im1,g1->ptr,s1->ptr,p1->ptr,q1->ptr,r1->ptr,it1->ptr,t1->ptr);



    return s;
}

static VALUE
ltg2sz(self,mm,jm,g,p,q,r)
    VALUE self,mm,jm,g,p,q,r;
{
    int mm1;
    int jm1;
    struct NARRAY *g1;
    struct NARRAY *s1;
    VALUE s;
    struct NARRAY *p1;
    struct NARRAY *q1;
    struct NARRAY *r1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    g = na_cast_object(g, NA_DFLOAT);
    GetNArray(g,g1);
    if ( *g1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: g : %d < jm1 = %d ", *g1->shape, jm1 );
    shape[0] = ((mm1+1)*(mm1+1));
    s = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(s,s1);
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: p : %d < jm1 = %d ", *p1->shape, jm1 );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (jm1*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (jm1*(mm1+1)) = %d ", *q1->shape, (jm1*(mm1+1)) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != ((mm1+1)*(mm1+1)) = %d ", *r1->shape, ((mm1+1)*(mm1+1)) );

    ltg2sz_(&mm1,&jm1,g1->ptr,s1->ptr,p1->ptr,q1->ptr,r1->ptr);



    return s;
}

static VALUE
ltg2sw(self,mm,jm,m,g,p,q,r)
    VALUE self,mm,jm,m,g,p,q,r;
{
    int mm1;
    int jm1;
    int m1;
    struct NARRAY *g1;
    struct NARRAY *s1;
    VALUE s;
    struct NARRAY *p1;
    struct NARRAY *q1;
    struct NARRAY *r1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    m1 = NUM2INT(m);
    g = na_cast_object(g, NA_DFLOAT);
    GetNArray(g,g1);
    if ( *g1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: g : %d < jm1 = %d ", *g1->shape, jm1 );
    shape[0] = ((mm1+1)*(mm1+1));
    s = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(s,s1);
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: p : %d < jm1 = %d ", *p1->shape, jm1 );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (jm1*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (jm1*(mm1+1)) = %d ", *q1->shape, (jm1*(mm1+1)) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != ((mm1+1)*(mm1+1)) = %d ", *r1->shape, ((mm1+1)*(mm1+1)) );

    ltg2sw_(&mm1,&jm1,&m1,g1->ptr,s1->ptr,p1->ptr,q1->ptr,r1->ptr);



    return s;
}

static VALUE
stv2sa(self,mm,jm,im,u,v,p,q,r,it,t)
    VALUE self,mm,jm,im,u,v,p,q,r,it,t;
{
    int mm1;
    int jm1;
    int im1;
    struct NARRAY *u1;
    struct NARRAY *v1;
    struct NARRAY *s1;
    VALUE s;
    struct NARRAY *p1;
    struct NARRAY *q1;
    struct NARRAY *r1;
    struct NARRAY *it1;
    struct NARRAY *t1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    u = na_cast_object(u, NA_DFLOAT);
    GetNArray(u,u1);
    if ( *u1->shape != (jm1*im1) ) rb_raise(rb_eArgError, "invalid ary size: u : %d != (jm1*im1) = %d ", *u1->shape, (jm1*im1) );
    v = na_cast_object(v, NA_DFLOAT);
    GetNArray(v,v1);
    if ( *v1->shape != (jm1*im1) ) rb_raise(rb_eArgError, "invalid ary size: v : %d != (jm1*im1) = %d ", *v1->shape, (jm1*im1) );
    shape[0] = ((mm1+1)*(mm1+1));
    s = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(s,s1);
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (jm1*im1) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (jm1*im1) = %d ", *p1->shape, (jm1*im1) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (jm1*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (jm1*(mm1+1)) = %d ", *q1->shape, (jm1*(mm1+1)) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != ((mm1+1)*(mm1+1)) = %d ", *r1->shape, ((mm1+1)*(mm1+1)) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );

    stv2sa_(&mm1,&jm1,&im1,u1->ptr,v1->ptr,s1->ptr,p1->ptr,q1->ptr,r1->ptr,it1->ptr,t1->ptr);



    return s;
}

static VALUE
ltv2sz(self,mm,jm,v,p,q,r)
    VALUE self,mm,jm,v,p,q,r;
{
    int mm1;
    int jm1;
    struct NARRAY *v1;
    struct NARRAY *s1;
    VALUE s;
    struct NARRAY *p1;
    struct NARRAY *q1;
    struct NARRAY *r1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    v = na_cast_object(v, NA_DFLOAT);
    GetNArray(v,v1);
    if ( *v1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: v : %d < jm1 = %d ", *v1->shape, jm1 );
    shape[0] = ((mm1+1)*(mm1+1));
    s = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(s,s1);
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: p : %d < jm1 = %d ", *p1->shape, jm1 );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (jm1*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (jm1*(mm1+1)) = %d ", *q1->shape, (jm1*(mm1+1)) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != ((mm1+1)*(mm1+1)) = %d ", *r1->shape, ((mm1+1)*(mm1+1)) );

    ltv2sz_(&mm1,&jm1,v1->ptr,s1->ptr,p1->ptr,q1->ptr,r1->ptr);



    return s;
}

static VALUE
ltv2sw(self,mm,jm,m,u,v,p,q,r)
    VALUE self,mm,jm,m,u,v,p,q,r;
{
    int mm1;
    int jm1;
    int m1;
    struct NARRAY *u1;
    struct NARRAY *v1;
    struct NARRAY *s1;
    VALUE s;
    struct NARRAY *p1;
    struct NARRAY *q1;
    struct NARRAY *r1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    m1 = NUM2INT(m);
    u = na_cast_object(u, NA_DFLOAT);
    GetNArray(u,u1);
    if ( *u1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: u : %d < jm1 = %d ", *u1->shape, jm1 );
    v = na_cast_object(v, NA_DFLOAT);
    GetNArray(v,v1);
    if ( *v1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: v : %d < jm1 = %d ", *v1->shape, jm1 );
    shape[0] = ((mm1+1)*(mm1+1));
    s = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(s,s1);
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: p : %d < jm1 = %d ", *p1->shape, jm1 );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (jm1*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (jm1*(mm1+1)) = %d ", *q1->shape, (jm1*(mm1+1)) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != ((mm1+1)*(mm1+1)) = %d ", *r1->shape, ((mm1+1)*(mm1+1)) );

    ltv2sw_(&mm1,&jm1,&m1,u1->ptr,v1->ptr,s1->ptr,p1->ptr,q1->ptr,r1->ptr);



    return s;
}

static VALUE
stvrsa(self,mm,jm,im,u,v,p,q,r,it,t)
    VALUE self,mm,jm,im,u,v,p,q,r,it,t;
{
    int mm1;
    int jm1;
    int im1;
    struct NARRAY *u1;
    struct NARRAY *v1;
    struct NARRAY *s1;
    VALUE s;
    struct NARRAY *p1;
    struct NARRAY *q1;
    struct NARRAY *r1;
    struct NARRAY *it1;
    struct NARRAY *t1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    u = na_cast_object(u, NA_DFLOAT);
    GetNArray(u,u1);
    if ( *u1->shape != (jm1*im1) ) rb_raise(rb_eArgError, "invalid ary size: u : %d != (jm1*im1) = %d ", *u1->shape, (jm1*im1) );
    v = na_cast_object(v, NA_DFLOAT);
    GetNArray(v,v1);
    if ( *v1->shape != (jm1*im1) ) rb_raise(rb_eArgError, "invalid ary size: v : %d != (jm1*im1) = %d ", *v1->shape, (jm1*im1) );
    shape[0] = ((mm1+1)*(mm1+1));
    s = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(s,s1);
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (jm1*im1) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (jm1*im1) = %d ", *p1->shape, (jm1*im1) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (jm1*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (jm1*(mm1+1)) = %d ", *q1->shape, (jm1*(mm1+1)) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != ((mm1+1)*(mm1+1)) = %d ", *r1->shape, ((mm1+1)*(mm1+1)) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );

    stvrsa_(&mm1,&jm1,&im1,u1->ptr,v1->ptr,s1->ptr,p1->ptr,q1->ptr,r1->ptr,it1->ptr,t1->ptr);



    return s;
}

static VALUE
ltvrsz(self,mm,jm,u,p,q,r)
    VALUE self,mm,jm,u,p,q,r;
{
    int mm1;
    int jm1;
    struct NARRAY *u1;
    struct NARRAY *s1;
    VALUE s;
    struct NARRAY *p1;
    struct NARRAY *q1;
    struct NARRAY *r1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    u = na_cast_object(u, NA_DFLOAT);
    GetNArray(u,u1);
    if ( *u1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: u : %d < jm1 = %d ", *u1->shape, jm1 );
    shape[0] = ((mm1+1)*(mm1+1));
    s = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(s,s1);
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: p : %d < jm1 = %d ", *p1->shape, jm1 );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (jm1*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (jm1*(mm1+1)) = %d ", *q1->shape, (jm1*(mm1+1)) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != ((mm1+1)*(mm1+1)) = %d ", *r1->shape, ((mm1+1)*(mm1+1)) );

    ltvrsz_(&mm1,&jm1,u1->ptr,s1->ptr,p1->ptr,q1->ptr,r1->ptr);



    return s;
}

static VALUE
ltvrsw(self,mm,jm,m,u,v,p,q,r)
    VALUE self,mm,jm,m,u,v,p,q,r;
{
    int mm1;
    int jm1;
    int m1;
    struct NARRAY *u1;
    struct NARRAY *v1;
    struct NARRAY *s1;
    VALUE s;
    struct NARRAY *p1;
    struct NARRAY *q1;
    struct NARRAY *r1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    m1 = NUM2INT(m);
    u = na_cast_object(u, NA_DFLOAT);
    GetNArray(u,u1);
    if ( *u1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: u : %d < jm1 = %d ", *u1->shape, jm1 );
    v = na_cast_object(v, NA_DFLOAT);
    GetNArray(v,v1);
    if ( *v1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: v : %d < jm1 = %d ", *v1->shape, jm1 );
    shape[0] = ((mm1+1)*(mm1+1));
    s = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(s,s1);
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape < jm1 ) rb_raise(rb_eArgError, "invalid ary size: p : %d < jm1 = %d ", *p1->shape, jm1 );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (jm1*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (jm1*(mm1+1)) = %d ", *q1->shape, (jm1*(mm1+1)) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != ((mm1+1)*(mm1+1)) = %d ", *r1->shape, ((mm1+1)*(mm1+1)) );

    ltvrsw_(&mm1,&jm1,&m1,u1->ptr,v1->ptr,s1->ptr,p1->ptr,q1->ptr,r1->ptr);



    return s;
}

static VALUE
stajba(self,mm,jm,im,a,b,p,q,r,it,t)
    VALUE self,mm,jm,im,a,b,p,q,r,it,t;
{
    int mm1;
    int jm1;
    int im1;
    struct NARRAY *a1;
    struct NARRAY *b1;
    struct NARRAY *c1;
    VALUE c;
    struct NARRAY *p1;
    struct NARRAY *q1;
    struct NARRAY *r1;
    struct NARRAY *it1;
    struct NARRAY *t1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)) = %d ", *a1->shape, ((mm1+1)*(mm1+1)) );
    b = na_cast_object(b, NA_DFLOAT);
    GetNArray(b,b1);
    if ( *b1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: b : %d != ((mm1+1)*(mm1+1)) = %d ", *b1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    c = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(c,c1);
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (jm1*im1*4) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (jm1*im1*4) = %d ", *p1->shape, (jm1*im1*4) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (jm1*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (jm1*(mm1+1)) = %d ", *q1->shape, (jm1*(mm1+1)) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != ((mm1+1)*(mm1+1)) = %d ", *r1->shape, ((mm1+1)*(mm1+1)) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );

    stajba_(&mm1,&jm1,&im1,a1->ptr,b1->ptr,c1->ptr,p1->ptr,q1->ptr,r1->ptr,it1->ptr,t1->ptr);



    return c;
}

static VALUE
sminit(self,mm,im,jm,km)
    VALUE self,mm,im,jm,km;
{
    int mm1;
    int im1;
    int jm1;
    int km1;
    struct NARRAY *x1;
    VALUE x;
    struct NARRAY *y1;
    VALUE y;
    struct NARRAY *w1;
    VALUE w;
    struct NARRAY *it1;
    VALUE it;
    struct NARRAY *t1;
    VALUE t;
    struct NARRAY *ip1;
    VALUE ip;
    struct NARRAY *p1;
    VALUE p;
    struct NARRAY *qsg1;
    VALUE qsg;
    struct NARRAY *qgs1;
    VALUE qgs;
    struct NARRAY *qsv1;
    VALUE qsv;
    struct NARRAY *qvs1;
    VALUE qvs;
    struct NARRAY *qsu1;
    VALUE qsu;
    struct NARRAY *qus1;
    VALUE qus;
    struct NARRAY *rf1;
    VALUE rf;
    struct NARRAY *rb1;
    VALUE rb;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    jm1 = NUM2INT(jm);
    km1 = NUM2INT(km);
    shape[0] = (im1);
    x = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(x,x1);
    shape[0] = (jm1);
    y = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(y,y1);
    shape[0] = (jm1);
    w = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(w,w1);
    shape[0] = (5);
    it = na_make_object( NA_LINT, rank, shape, cNArray );
    GetNArray(it,it1);
    shape[0] = (im1*2);
    t = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(t,t1);
    shape[0] = (km1*(2*mm1+1));
    ip = na_make_object( NA_LINT, rank, shape, cNArray );
    GetNArray(ip,ip1);
    shape[0] = (km1*(mm1+1)*(mm1+3)*jm1/2);
    p = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(p,p1);
    shape[0] = (jm1/2);
    qsg = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(qsg,qsg1);
    shape[0] = (jm1/2);
    qgs = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(qgs,qgs1);
    shape[0] = (jm1/2);
    qsv = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(qsv,qsv1);
    shape[0] = (jm1/2);
    qvs = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(qvs,qvs1);
    shape[0] = (jm1/2);
    qsu = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(qsu,qsu1);
    shape[0] = (jm1/2);
    qus = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(qus,qus1);
    shape[0] = ((mm1+1)*(mm1+1));
    rf = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(rf,rf1);
    shape[0] = ((mm1+1)*(mm1+1));
    rb = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(rb,rb1);

    sminit_(&mm1,&im1,&jm1,&km1,x1->ptr,y1->ptr,w1->ptr,it1->ptr,t1->ptr,ip1->ptr,p1->ptr,qsg1->ptr,qgs1->ptr,qsv1->ptr,qvs1->ptr,qsu1->ptr,qus1->ptr,rf1->ptr,rb1->ptr);



    return rb_ary_new3(15, x, y, w, it, t, ip, p, qsg, qgs, qsv, qvs, qsu, qus, rf, rb);
}

static VALUE
smnm2l(self,mm,n,m)
    VALUE self,mm,n,m;
{
    int mm1;
    int n1;
    int m1;
    int l1;
    VALUE l;



    mm1 = NUM2INT(mm);
    n1 = NUM2INT(n);
    m1 = NUM2INT(m);

    smnm2l_(&mm1,&n1,&m1,&l1);


    l = INT2NUM(l1);

    return l;
}

static VALUE
sml2nm(self,mm,l)
    VALUE self,mm,l;
{
    int mm1;
    int l1;
    int n1;
    VALUE n;
    int m1;
    VALUE m;



    mm1 = NUM2INT(mm);
    l1 = NUM2INT(l);

    sml2nm_(&mm1,&l1,&n1,&m1);


    n = INT2NUM(n1);
    m = INT2NUM(m1);

    return rb_ary_new3(2, n, m);
}

static VALUE
smclap(self,mm,km,a,rf)
    VALUE self,mm,km,a,rf;
{
    int mm1;
    int km1;
    struct NARRAY *a1;
    struct NARRAY *b1;
    VALUE b;
    struct NARRAY *rf1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    km1 = NUM2INT(km);
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1),km1) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1),km1) = %d ", *a1->shape, ((mm1+1)*(mm1+1),km1) );
    shape[0] = ((mm1+1)*(mm1+1),km1);
    b = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(b,b1);
    rf = na_cast_object(rf, NA_DFLOAT);
    GetNArray(rf,rf1);
    if ( *rf1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: rf : %d != ((mm1+1)*(mm1+1)) = %d ", *rf1->shape, ((mm1+1)*(mm1+1)) );

    smclap_(&mm1,&km1,a1->ptr,b1->ptr,rf1->ptr);



    return b;
}

static VALUE
smts2g(self,mm,im,id,jm,jd,km,s,work,it,t,ip,p,qsg)
    VALUE self,mm,im,id,jm,jd,km,s,work,it,t,ip,p,qsg;
{
    int mm1;
    int im1;
    int id1;
    int jm1;
    int jd1;
    int km1;
    struct NARRAY *s1;
    struct NARRAY *g1;
    VALUE g;
    struct NARRAY *work1;
    struct NARRAY *it1;
    struct NARRAY *t1;
    struct NARRAY *ip1;
    struct NARRAY *p1;
    struct NARRAY *qsg1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    id1 = NUM2INT(id);
    jm1 = NUM2INT(jm);
    jd1 = NUM2INT(jd);
    km1 = NUM2INT(km);
    s = na_cast_object(s, NA_DFLOAT);
    GetNArray(s,s1);
    if ( *s1->shape != ((mm1+1)*(mm1+1),km1) ) rb_raise(rb_eArgError, "invalid ary size: s : %d != ((mm1+1)*(mm1+1),km1) = %d ", *s1->shape, ((mm1+1)*(mm1+1),km1) );
    shape[0] = (id1,jd1,km1);
    g = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(g,g1);
    work = na_cast_object(work, NA_DFLOAT);
    GetNArray(work,work1);
    if ( *work1->shape != (id1*jd1*km1) ) rb_raise(rb_eArgError, "invalid ary size: work : %d != (id1*jd1*km1) = %d ", *work1->shape, (id1*jd1*km1) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );
    ip = na_cast_object(ip, NA_LINT);
    GetNArray(ip,ip1);
    if ( *ip1->shape != (km1*(2*mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip1->shape );
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (km1*(mm1+1)*(mm1+3)*jm1/2) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (km1*(mm1+1)*(mm1+3)*jm1/2) = %d ", *p1->shape, (km1*(mm1+1)*(mm1+3)*jm1/2) );
    qsg = na_cast_object(qsg, NA_DFLOAT);
    GetNArray(qsg,qsg1);
    if ( *qsg1->shape != (jm1/2) ) rb_raise(rb_eArgError, "invalid ary size: qsg : %d != (jm1/2) = %d ", *qsg1->shape, (jm1/2) );

    smts2g_(&mm1,&im1,&id1,&jm1,&jd1,&km1,s1->ptr,g1->ptr,work1->ptr,it1->ptr,t1->ptr,ip1->ptr,p1->ptr,qsg1->ptr);



    return g;
}

static VALUE
smtg2s(self,mm,im,id,jm,jd,km,g,work,it,t,ip,p,qgs)
    VALUE self,mm,im,id,jm,jd,km,g,work,it,t,ip,p,qgs;
{
    int mm1;
    int im1;
    int id1;
    int jm1;
    int jd1;
    int km1;
    struct NARRAY *g1;
    struct NARRAY *s1;
    VALUE s;
    struct NARRAY *work1;
    struct NARRAY *it1;
    struct NARRAY *t1;
    struct NARRAY *ip1;
    struct NARRAY *p1;
    struct NARRAY *qgs1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    id1 = NUM2INT(id);
    jm1 = NUM2INT(jm);
    jd1 = NUM2INT(jd);
    km1 = NUM2INT(km);
    g = na_cast_object(g, NA_DFLOAT);
    GetNArray(g,g1);
    if ( *g1->shape != (id1,jd1,km1) ) rb_raise(rb_eArgError, "invalid ary size: g : %d != (id1,jd1,km1) = %d ", *g1->shape, (id1,jd1,km1) );
    shape[0] = ((mm1+1)*(mm1+1),km1);
    s = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(s,s1);
    work = na_cast_object(work, NA_DFLOAT);
    GetNArray(work,work1);
    if ( *work1->shape != (id1*jd1*km1*2) ) rb_raise(rb_eArgError, "invalid ary size: work : %d != (id1*jd1*km1*2) = %d ", *work1->shape, (id1*jd1*km1*2) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );
    ip = na_cast_object(ip, NA_LINT);
    GetNArray(ip,ip1);
    if ( *ip1->shape != (km1*(2*mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip1->shape );
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (km1*(mm1+1)*(mm1+3)*jm1/2) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (km1*(mm1+1)*(mm1+3)*jm1/2) = %d ", *p1->shape, (km1*(mm1+1)*(mm1+3)*jm1/2) );
    qgs = na_cast_object(qgs, NA_DFLOAT);
    GetNArray(qgs,qgs1);
    if ( *qgs1->shape != (jm1/2) ) rb_raise(rb_eArgError, "invalid ary size: qgs : %d != (jm1/2) = %d ", *qgs1->shape, (jm1/2) );

    smtg2s_(&mm1,&im1,&id1,&jm1,&jd1,&km1,g1->ptr,s1->ptr,work1->ptr,it1->ptr,t1->ptr,ip1->ptr,p1->ptr,qgs1->ptr);



    return s;
}

static VALUE
smts2v(self,mm,im,id,jm,jd,km,a,b,work,it,t,ip,p,qsv)
    VALUE self,mm,im,id,jm,jd,km,a,b,work,it,t,ip,p,qsv;
{
    int mm1;
    int im1;
    int id1;
    int jm1;
    int jd1;
    int km1;
    struct NARRAY *a1;
    struct NARRAY *b1;
    struct NARRAY *u1;
    VALUE u;
    struct NARRAY *v1;
    VALUE v;
    struct NARRAY *work1;
    struct NARRAY *it1;
    struct NARRAY *t1;
    struct NARRAY *ip1;
    struct NARRAY *p1;
    struct NARRAY *qsv1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    id1 = NUM2INT(id);
    jm1 = NUM2INT(jm);
    jd1 = NUM2INT(jd);
    km1 = NUM2INT(km);
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1),km1) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1),km1) = %d ", *a1->shape, ((mm1+1)*(mm1+1),km1) );
    b = na_cast_object(b, NA_DFLOAT);
    GetNArray(b,b1);
    if ( *b1->shape != ((mm1+1)*(mm1+1),km1) ) rb_raise(rb_eArgError, "invalid ary size: b : %d != ((mm1+1)*(mm1+1),km1) = %d ", *b1->shape, ((mm1+1)*(mm1+1),km1) );
    shape[0] = (id1,jd1,km1);
    u = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(u,u1);
    shape[0] = (id1,jd1,km1);
    v = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(v,v1);
    work = na_cast_object(work, NA_DFLOAT);
    GetNArray(work,work1);
    if ( *work1->shape != (id1*jd1*km1*2) ) rb_raise(rb_eArgError, "invalid ary size: work : %d != (id1*jd1*km1*2) = %d ", *work1->shape, (id1*jd1*km1*2) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );
    ip = na_cast_object(ip, NA_LINT);
    GetNArray(ip,ip1);
    if ( *ip1->shape != (km1*(2*mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip1->shape );
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (km1*(mm1+1)*(mm1+3)*jm1/2) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (km1*(mm1+1)*(mm1+3)*jm1/2) = %d ", *p1->shape, (km1*(mm1+1)*(mm1+3)*jm1/2) );
    qsv = na_cast_object(qsv, NA_DFLOAT);
    GetNArray(qsv,qsv1);
    if ( *qsv1->shape != (jm1/2) ) rb_raise(rb_eArgError, "invalid ary size: qsv : %d != (jm1/2) = %d ", *qsv1->shape, (jm1/2) );

    smts2v_(&mm1,&im1,&id1,&jm1,&jd1,&km1,a1->ptr,b1->ptr,u1->ptr,v1->ptr,work1->ptr,it1->ptr,t1->ptr,ip1->ptr,p1->ptr,qsv1->ptr);



    return rb_ary_new3(2, u, v);
}

static VALUE
smtv2s(self,mm,im,id,jm,jd,km,u,v,work,it,t,ip,p,qvs)
    VALUE self,mm,im,id,jm,jd,km,u,v,work,it,t,ip,p,qvs;
{
    int mm1;
    int im1;
    int id1;
    int jm1;
    int jd1;
    int km1;
    struct NARRAY *u1;
    struct NARRAY *v1;
    struct NARRAY *a1;
    VALUE a;
    struct NARRAY *b1;
    VALUE b;
    struct NARRAY *work1;
    struct NARRAY *it1;
    struct NARRAY *t1;
    struct NARRAY *ip1;
    struct NARRAY *p1;
    struct NARRAY *qvs1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    id1 = NUM2INT(id);
    jm1 = NUM2INT(jm);
    jd1 = NUM2INT(jd);
    km1 = NUM2INT(km);
    u = na_cast_object(u, NA_DFLOAT);
    GetNArray(u,u1);
    if ( *u1->shape != (id1,jd1,km1) ) rb_raise(rb_eArgError, "invalid ary size: u : %d != (id1,jd1,km1) = %d ", *u1->shape, (id1,jd1,km1) );
    v = na_cast_object(v, NA_DFLOAT);
    GetNArray(v,v1);
    if ( *v1->shape != (id1,jd1,km1) ) rb_raise(rb_eArgError, "invalid ary size: v : %d != (id1,jd1,km1) = %d ", *v1->shape, (id1,jd1,km1) );
    shape[0] = ((mm1+1)*(mm1+1),km1);
    a = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(a,a1);
    shape[0] = ((mm1+1)*(mm1+1),km1);
    b = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(b,b1);
    work = na_cast_object(work, NA_DFLOAT);
    GetNArray(work,work1);
    if ( *work1->shape != (id1*jd1*km1*3) ) rb_raise(rb_eArgError, "invalid ary size: work : %d != (id1*jd1*km1*3) = %d ", *work1->shape, (id1*jd1*km1*3) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );
    ip = na_cast_object(ip, NA_LINT);
    GetNArray(ip,ip1);
    if ( *ip1->shape != (km1*(2*mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip1->shape );
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (km1*(mm1+1)*(mm1+3)*jm1/2) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (km1*(mm1+1)*(mm1+3)*jm1/2) = %d ", *p1->shape, (km1*(mm1+1)*(mm1+3)*jm1/2) );
    qvs = na_cast_object(qvs, NA_DFLOAT);
    GetNArray(qvs,qvs1);
    if ( *qvs1->shape != (jm1/2) ) rb_raise(rb_eArgError, "invalid ary size: qvs : %d != (jm1/2) = %d ", *qvs1->shape, (jm1/2) );

    smtv2s_(&mm1,&im1,&id1,&jm1,&jd1,&km1,u1->ptr,v1->ptr,a1->ptr,b1->ptr,work1->ptr,it1->ptr,t1->ptr,ip1->ptr,p1->ptr,qvs1->ptr);



    return rb_ary_new3(2, a, b);
}

static VALUE
smts1v(self,mm,im,id,jm,jd,km,a,work,it,t,ip,p,qsv)
    VALUE self,mm,im,id,jm,jd,km,a,work,it,t,ip,p,qsv;
{
    int mm1;
    int im1;
    int id1;
    int jm1;
    int jd1;
    int km1;
    struct NARRAY *a1;
    struct NARRAY *u1;
    VALUE u;
    struct NARRAY *v1;
    VALUE v;
    struct NARRAY *work1;
    struct NARRAY *it1;
    struct NARRAY *t1;
    struct NARRAY *ip1;
    struct NARRAY *p1;
    struct NARRAY *qsv1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    id1 = NUM2INT(id);
    jm1 = NUM2INT(jm);
    jd1 = NUM2INT(jd);
    km1 = NUM2INT(km);
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1),km1) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1),km1) = %d ", *a1->shape, ((mm1+1)*(mm1+1),km1) );
    shape[0] = (id1,jd1,km1);
    u = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(u,u1);
    shape[0] = (id1,jd1,km1);
    v = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(v,v1);
    work = na_cast_object(work, NA_DFLOAT);
    GetNArray(work,work1);
    if ( *work1->shape != (id1*jd1*km1*2) ) rb_raise(rb_eArgError, "invalid ary size: work : %d != (id1*jd1*km1*2) = %d ", *work1->shape, (id1*jd1*km1*2) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );
    ip = na_cast_object(ip, NA_LINT);
    GetNArray(ip,ip1);
    if ( *ip1->shape != (km1*(2*mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip1->shape );
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (km1*(mm1+1)*(mm1+3)*jm1/2) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (km1*(mm1+1)*(mm1+3)*jm1/2) = %d ", *p1->shape, (km1*(mm1+1)*(mm1+3)*jm1/2) );
    qsv = na_cast_object(qsv, NA_DFLOAT);
    GetNArray(qsv,qsv1);
    if ( *qsv1->shape != (jm1/2) ) rb_raise(rb_eArgError, "invalid ary size: qsv : %d != (jm1/2) = %d ", *qsv1->shape, (jm1/2) );

    smts1v_(&mm1,&im1,&id1,&jm1,&jd1,&km1,a1->ptr,u1->ptr,v1->ptr,work1->ptr,it1->ptr,t1->ptr,ip1->ptr,p1->ptr,qsv1->ptr);



    return rb_ary_new3(2, u, v);
}

static VALUE
smtv1s(self,mm,im,id,jm,jd,km,u,v,work,it,t,ip,p,qvs)
    VALUE self,mm,im,id,jm,jd,km,u,v,work,it,t,ip,p,qvs;
{
    int mm1;
    int im1;
    int id1;
    int jm1;
    int jd1;
    int km1;
    struct NARRAY *u1;
    struct NARRAY *v1;
    struct NARRAY *a1;
    VALUE a;
    struct NARRAY *work1;
    struct NARRAY *it1;
    struct NARRAY *t1;
    struct NARRAY *ip1;
    struct NARRAY *p1;
    struct NARRAY *qvs1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    id1 = NUM2INT(id);
    jm1 = NUM2INT(jm);
    jd1 = NUM2INT(jd);
    km1 = NUM2INT(km);
    u = na_cast_object(u, NA_DFLOAT);
    GetNArray(u,u1);
    if ( *u1->shape != (id1,jd1,km1) ) rb_raise(rb_eArgError, "invalid ary size: u : %d != (id1,jd1,km1) = %d ", *u1->shape, (id1,jd1,km1) );
    v = na_cast_object(v, NA_DFLOAT);
    GetNArray(v,v1);
    if ( *v1->shape != (id1,jd1,km1) ) rb_raise(rb_eArgError, "invalid ary size: v : %d != (id1,jd1,km1) = %d ", *v1->shape, (id1,jd1,km1) );
    shape[0] = ((mm1+1)*(mm1+1),km1);
    a = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(a,a1);
    work = na_cast_object(work, NA_DFLOAT);
    GetNArray(work,work1);
    if ( *work1->shape != (id1*jd1*km1*3) ) rb_raise(rb_eArgError, "invalid ary size: work : %d != (id1*jd1*km1*3) = %d ", *work1->shape, (id1*jd1*km1*3) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );
    ip = na_cast_object(ip, NA_LINT);
    GetNArray(ip,ip1);
    if ( *ip1->shape != (km1*(2*mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip1->shape );
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (km1*(mm1+1)*(mm1+3)*jm1/2) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (km1*(mm1+1)*(mm1+3)*jm1/2) = %d ", *p1->shape, (km1*(mm1+1)*(mm1+3)*jm1/2) );
    qvs = na_cast_object(qvs, NA_DFLOAT);
    GetNArray(qvs,qvs1);
    if ( *qvs1->shape != (jm1/2) ) rb_raise(rb_eArgError, "invalid ary size: qvs : %d != (jm1/2) = %d ", *qvs1->shape, (jm1/2) );

    smtv1s_(&mm1,&im1,&id1,&jm1,&jd1,&km1,u1->ptr,v1->ptr,a1->ptr,work1->ptr,it1->ptr,t1->ptr,ip1->ptr,p1->ptr,qvs1->ptr);



    return a;
}

static VALUE
snnm2l(self,n,m)
    VALUE self,n,m;
{
    int n1;
    int m1;
    int l1;
    VALUE l;



    n1 = NUM2INT(n);
    m1 = NUM2INT(m);

    snnm2l_(&n1,&m1,&l1);


    l = INT2NUM(l1);

    return l;
}

static VALUE
snl2nm(self,l)
    VALUE self,l;
{
    int l1;
    int n1;
    VALUE n;
    int m1;
    VALUE m;



    l1 = NUM2INT(l);

    snl2nm_(&l1,&n1,&m1);


    n = INT2NUM(n1);
    m = INT2NUM(m1);

    return rb_ary_new3(2, n, m);
}

static VALUE
sninit(self,mm,im,jm)
    VALUE self,mm,im,jm;
{
    int mm1;
    int im1;
    int jm1;
    struct NARRAY *it1;
    VALUE it;
    struct NARRAY *t1;
    VALUE t;
    struct NARRAY *y1;
    VALUE y;
    struct NARRAY *ip1;
    VALUE ip;
    struct NARRAY *p1;
    VALUE p;
    struct NARRAY *r1;
    VALUE r;
    struct NARRAY *ia1;
    VALUE ia;
    struct NARRAY *a1;
    VALUE a;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    jm1 = NUM2INT(jm);
    shape[0] = (5);
    it = na_make_object( NA_LINT, rank, shape, cNArray );
    GetNArray(it,it1);
    shape[0] = (im1*2);
    t = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(t,t1);
    shape[0] = (jm1*2);
    y = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(y,y1);
    shape[0] = (((mm1+1)/2+mm1+1)*2);
    ip = na_make_object( NA_LINT, rank, shape, cNArray );
    GetNArray(ip,ip1);
    shape[0] = (((mm1+1)/2+mm1+1)*jm1);
    p = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(p,p1);
    shape[0] = (((mm1+1)/2*2+3)*(mm1/2+1));
    r = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(r,r1);
    shape[0] = ((mm1+1)*(mm1+1)*4);
    ia = na_make_object( NA_LINT, rank, shape, cNArray );
    GetNArray(ia,ia1);
    shape[0] = ((mm1+1)*(mm1+1)*6);
    a = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(a,a1);

    sninit_(&mm1,&im1,&jm1,it1->ptr,t1->ptr,y1->ptr,ip1->ptr,p1->ptr,r1->ptr,ia1->ptr,a1->ptr);



    return rb_ary_new3(8, it, t, y, ip, p, r, ia, a);
}

static VALUE
snkini(self,mm,jm,km,ip,p,r)
    VALUE self,mm,jm,km,ip,p,r;
{
    int mm1;
    int jm1;
    int km1;
    struct NARRAY *ip1;
    struct NARRAY *p1;
    struct NARRAY *r1;
    struct NARRAY *ipk1;
    VALUE ipk;
    struct NARRAY *pk1;
    VALUE pk;
    struct NARRAY *rk1;
    VALUE rk;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    jm1 = NUM2INT(jm);
    km1 = NUM2INT(km);
    ip = na_cast_object(ip, NA_LINT);
    GetNArray(ip,ip1);
    if ( *ip1->shape != (((mm1+1)/2+mm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip1->shape );
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (((mm1+1)/2+mm1+1)*jm1) = %d ", *p1->shape, (((mm1+1)/2+mm1+1)*jm1) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != (((mm1+1)/2*2+3)*(mm1/2+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != (((mm1+1)/2*2+3)*(mm1/2+1)) = %d ", *r1->shape, (((mm1+1)/2*2+3)*(mm1/2+1)) );
    shape[0] = (km1*((mm1+1)/2+mm1+1)*2);
    ipk = na_make_object( NA_LINT, rank, shape, cNArray );
    GetNArray(ipk,ipk1);
    shape[0] = (km1*((mm1+1)/2+mm1+1)*jm1);
    pk = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(pk,pk1);
    shape[0] = (km1*((mm1+1)/2*2+3)*(mm1/2+1));
    rk = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(rk,rk1);

    snkini_(&mm1,&jm1,&km1,ip1->ptr,p1->ptr,r1->ptr,ipk1->ptr,pk1->ptr,rk1->ptr);



    return rb_ary_new3(3, ipk, pk, rk);
}

static VALUE
snts2g(self,mm,im,id,jm,jd,km,s,it,t,ipk,pk,rk,ia,a,q,ws,ww,ipow,iflag)
    VALUE self,mm,im,id,jm,jd,km,s,it,t,ipk,pk,rk,ia,a,q,ws,ww,ipow,iflag;
{
    int mm1;
    int im1;
    int id1;
    int jm1;
    int jd1;
    int km1;
    struct NARRAY *s1;
    struct NARRAY *g1;
    VALUE g;
    struct NARRAY *it1;
    struct NARRAY *t1;
    struct NARRAY *ipk1;
    struct NARRAY *pk1;
    struct NARRAY *rk1;
    struct NARRAY *ia1;
    struct NARRAY *a1;
    struct NARRAY *q1;
    struct NARRAY *ws1;
    struct NARRAY *ww1;
    int ipow1;
    int iflag1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    id1 = NUM2INT(id);
    jm1 = NUM2INT(jm);
    jd1 = NUM2INT(jd);
    km1 = NUM2INT(km);
    s = na_cast_object(s, NA_DFLOAT);
    GetNArray(s,s1);
    if ( *s1->shape != ((mm1+1)*(mm1+1),km1) ) rb_raise(rb_eArgError, "invalid ary size: s : %d != ((mm1+1)*(mm1+1),km1) = %d ", *s1->shape, ((mm1+1)*(mm1+1),km1) );
    shape[0] = (id1,jd1,km1);
    g = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(g,g1);
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );
    ipk = na_cast_object(ipk, NA_LINT);
    GetNArray(ipk,ipk1);
    if ( *ipk1->shape != (km1*((mm1+1)/2+mm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ipk1->shape );
    pk = na_cast_object(pk, NA_DFLOAT);
    GetNArray(pk,pk1);
    if ( *pk1->shape != (km1*((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: pk : %d != (km1*((mm1+1)/2+mm1+1)*jm1) = %d ", *pk1->shape, (km1*((mm1+1)/2+mm1+1)*jm1) );
    rk = na_cast_object(rk, NA_DFLOAT);
    GetNArray(rk,rk1);
    if ( *rk1->shape != (km1*((mm1+1)/2*2+3)*(mm1/2+1)) ) rb_raise(rb_eArgError, "invalid ary size: rk : %d != (km1*((mm1+1)/2*2+3)*(mm1/2+1)) = %d ", *rk1->shape, (km1*((mm1+1)/2*2+3)*(mm1/2+1)) );
    ia = na_cast_object(ia, NA_LINT);
    GetNArray(ia,ia1);
    if ( *ia1->shape != ((mm1+1)*(mm1+1)*4) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ia1->shape );
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)*6) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)*6) = %d ", *a1->shape, ((mm1+1)*(mm1+1)*6) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (km1*((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (km1*((mm1+1)/2+mm1+1)*jm1) = %d ", *q1->shape, (km1*((mm1+1)/2+mm1+1)*jm1) );
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape < km1*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d < km1*(jd1*im1) = %d ", *ws1->shape, km1*(jd1*im1) );
    ww = na_cast_object(ww, NA_DFLOAT);
    GetNArray(ww,ww1);
    if ( *ww1->shape < km1*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ww : %d < km1*(jd1*im1) = %d ", *ww1->shape, km1*(jd1*im1) );
    ipow1 = NUM2INT(ipow);
    iflag1 = NUM2INT(iflag);

    snts2g_(&mm1,&im1,&id1,&jm1,&jd1,&km1,s1->ptr,g1->ptr,it1->ptr,t1->ptr,ipk1->ptr,pk1->ptr,rk1->ptr,ia1->ptr,a1->ptr,q1->ptr,ws1->ptr,ww1->ptr,&ipow1,&iflag1);



    return g;
}

static VALUE
sntg2s(self,mm,im,id,jm,jd,km,g,it,t,ipk,pk,rk,ia,a,q,ws,ww,ipow,iflag)
    VALUE self,mm,im,id,jm,jd,km,g,it,t,ipk,pk,rk,ia,a,q,ws,ww,ipow,iflag;
{
    int mm1;
    int im1;
    int id1;
    int jm1;
    int jd1;
    int km1;
    struct NARRAY *g1;
    struct NARRAY *s1;
    VALUE s;
    struct NARRAY *it1;
    struct NARRAY *t1;
    struct NARRAY *ipk1;
    struct NARRAY *pk1;
    struct NARRAY *rk1;
    struct NARRAY *ia1;
    struct NARRAY *a1;
    struct NARRAY *q1;
    struct NARRAY *ws1;
    struct NARRAY *ww1;
    int ipow1;
    int iflag1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    id1 = NUM2INT(id);
    jm1 = NUM2INT(jm);
    jd1 = NUM2INT(jd);
    km1 = NUM2INT(km);
    g = na_cast_object(g, NA_DFLOAT);
    GetNArray(g,g1);
    if ( *g1->shape != (id1,jd1,km1) ) rb_raise(rb_eArgError, "invalid ary size: g : %d != (id1,jd1,km1) = %d ", *g1->shape, (id1,jd1,km1) );
    shape[0] = ((mm1+1)*(mm1+1),km1);
    s = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(s,s1);
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );
    ipk = na_cast_object(ipk, NA_LINT);
    GetNArray(ipk,ipk1);
    if ( *ipk1->shape != (km1*((mm1+1)/2+mm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ipk1->shape );
    pk = na_cast_object(pk, NA_DFLOAT);
    GetNArray(pk,pk1);
    if ( *pk1->shape != (km1*((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: pk : %d != (km1*((mm1+1)/2+mm1+1)*jm1) = %d ", *pk1->shape, (km1*((mm1+1)/2+mm1+1)*jm1) );
    rk = na_cast_object(rk, NA_DFLOAT);
    GetNArray(rk,rk1);
    if ( *rk1->shape != (km1*((mm1+1)/2*2+3)*(mm1/2+1)) ) rb_raise(rb_eArgError, "invalid ary size: rk : %d != (km1*((mm1+1)/2*2+3)*(mm1/2+1)) = %d ", *rk1->shape, (km1*((mm1+1)/2*2+3)*(mm1/2+1)) );
    ia = na_cast_object(ia, NA_LINT);
    GetNArray(ia,ia1);
    if ( *ia1->shape != ((mm1+1)*(mm1+1)*4) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ia1->shape );
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)*6) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)*6) = %d ", *a1->shape, ((mm1+1)*(mm1+1)*6) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != ((km1*(mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != ((km1*(mm1+1)/2+mm1+1)*jm1) = %d ", *q1->shape, ((km1*(mm1+1)/2+mm1+1)*jm1) );
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape < km1*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d < km1*(jd1*im1) = %d ", *ws1->shape, km1*(jd1*im1) );
    ww = na_cast_object(ww, NA_DFLOAT);
    GetNArray(ww,ww1);
    if ( *ww1->shape < km1*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ww : %d < km1*(jd1*im1) = %d ", *ww1->shape, km1*(jd1*im1) );
    ipow1 = NUM2INT(ipow);
    iflag1 = NUM2INT(iflag);

    sntg2s_(&mm1,&im1,&id1,&jm1,&jd1,&km1,g1->ptr,s1->ptr,it1->ptr,t1->ptr,ipk1->ptr,pk1->ptr,rk1->ptr,ia1->ptr,a1->ptr,q1->ptr,ws1->ptr,ww1->ptr,&ipow1,&iflag1);



    return s;
}

static VALUE
soinit(self,mm)
    VALUE self,mm;
{
    int mm1;
    struct NARRAY *ib1;
    VALUE ib;
    struct NARRAY *b1;
    VALUE b;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    shape[0] = ((mm1+1)*(mm1+1)*3);
    ib = na_make_object( NA_LINT, rank, shape, cNArray );
    GetNArray(ib,ib1);
    shape[0] = ((mm1+1)*(mm1+1)*3);
    b = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(b,b1);

    soinit_(&mm1,ib1->ptr,b1->ptr);



    return rb_ary_new3(2, ib, b);
}

static VALUE
sondnl(self,mm,im,id,jm,jd,s,it,t,ip2,p2,r2,ia,a,ib,b,q,ws,ww)
    VALUE self,mm,im,id,jm,jd,s,it,t,ip2,p2,r2,ia,a,ib,b,q,ws,ww;
{
    int mm1;
    int im1;
    int id1;
    int jm1;
    int jd1;
    struct NARRAY *s1;
    struct NARRAY *sout1;
    VALUE sout;
    struct NARRAY *it1;
    struct NARRAY *t1;
    struct NARRAY *ip21;
    struct NARRAY *p21;
    struct NARRAY *r21;
    struct NARRAY *ia1;
    struct NARRAY *a1;
    struct NARRAY *ib1;
    struct NARRAY *b1;
    struct NARRAY *q1;
    struct NARRAY *ws1;
    struct NARRAY *ww1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    id1 = NUM2INT(id);
    jm1 = NUM2INT(jm);
    jd1 = NUM2INT(jd);
    s = na_cast_object(s, NA_DFLOAT);
    GetNArray(s,s1);
    if ( *s1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: s : %d != ((mm1+1)*(mm1+1)) = %d ", *s1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    sout = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(sout,sout1);
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );
    ip2 = na_cast_object(ip2, NA_LINT);
    GetNArray(ip2,ip21);
    if ( *ip21->shape != (2*((mm1+2)/2+mm1+2)*2) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip21->shape );
    p2 = na_cast_object(p2, NA_DFLOAT);
    GetNArray(p2,p21);
    if ( *p21->shape != (2*((mm1+2)/2+mm1+2)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: p2 : %d != (2*((mm1+2)/2+mm1+2)*jm1) = %d ", *p21->shape, (2*((mm1+2)/2+mm1+2)*jm1) );
    r2 = na_cast_object(r2, NA_DFLOAT);
    GetNArray(r2,r21);
    if ( *r21->shape != (2*((mm1+2)/2*2+3)*((mm1+1)/2+1)) ) rb_raise(rb_eArgError, "invalid ary size: r2 : %d != (2*((mm1+2)/2*2+3)*((mm1+1)/2+1)) = %d ", *r21->shape, (2*((mm1+2)/2*2+3)*((mm1+1)/2+1)) );
    ia = na_cast_object(ia, NA_LINT);
    GetNArray(ia,ia1);
    if ( *ia1->shape != ((mm1+2)*(mm1+2)*4) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ia1->shape );
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+2)*(mm1+2)*6) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+2)*(mm1+2)*6) = %d ", *a1->shape, ((mm1+2)*(mm1+2)*6) );
    ib = na_cast_object(ib, NA_LINT);
    GetNArray(ib,ib1);
    if ( *ib1->shape != ((mm1+1)*(mm1+1)*3) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ib1->shape );
    b = na_cast_object(b, NA_DFLOAT);
    GetNArray(b,b1);
    if ( *b1->shape != ((mm1+1)*(mm1+1)*3) ) rb_raise(rb_eArgError, "invalid ary size: b : %d != ((mm1+1)*(mm1+1)*3) = %d ", *b1->shape, ((mm1+1)*(mm1+1)*3) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (2*((mm1+2)/2+mm1+2)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (2*((mm1+2)/2+mm1+2)*jm1) = %d ", *q1->shape, (2*((mm1+2)/2+mm1+2)*jm1) );
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape < 2*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d < 2*(jd1*im1) = %d ", *ws1->shape, 2*(jd1*im1) );
    ww = na_cast_object(ww, NA_DFLOAT);
    GetNArray(ww,ww1);
    if ( *ww1->shape < 2*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ww : %d < 2*(jd1*im1) = %d ", *ww1->shape, 2*(jd1*im1) );

    sondnl_(&mm1,&im1,&id1,&jm1,&jd1,s1->ptr,sout1->ptr,it1->ptr,t1->ptr,ip21->ptr,p21->ptr,r21->ptr,ia1->ptr,a1->ptr,ib1->ptr,b1->ptr,q1->ptr,ws1->ptr,ww1->ptr);



    return sout;
}

static VALUE
c2init(self,jm,im)
    VALUE self,jm,im;
{
    int jm1;
    int im1;
    struct NARRAY *itj1;
    VALUE itj;
    struct NARRAY *tj1;
    VALUE tj;
    struct NARRAY *iti1;
    VALUE iti;
    struct NARRAY *ti1;
    VALUE ti;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    shape[0] = (5);
    itj = na_make_object( NA_LINT, rank, shape, cNArray );
    GetNArray(itj,itj1);
    shape[0] = (jm1*6);
    tj = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(tj,tj1);
    shape[0] = (5);
    iti = na_make_object( NA_LINT, rank, shape, cNArray );
    GetNArray(iti,iti1);
    shape[0] = (jm1*2);
    ti = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(ti,ti1);

    c2init_(&jm1,&im1,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return rb_ary_new3(4, itj, tj, iti, ti);
}

static VALUE
c2s2ga(self,lm,km,jm,im,w,itj,tj,iti,ti,isw)
    VALUE self,lm,km,jm,im,w,itj,tj,iti,ti,isw;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    struct NARRAY *g1;
    VALUE g;
    struct NARRAY *w1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;
    int isw1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    shape[0] = ((jm1+1)*im1);
    g = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(g,g1);
    w = na_cast_object(w, NA_DFLOAT);
    GetNArray(w,w1);
    if ( *w1->shape != ((jm1+1)*im1) ) rb_raise(rb_eArgError, "invalid ary size: w : %d != ((jm1+1)*im1) = %d ", *w1->shape, ((jm1+1)*im1) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*6) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*6) = %d ", *tj1->shape, (jm1*6) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );
    isw1 = NUM2INT(isw);

    c2s2ga_(&lm1,&km1,&jm1,&im1,g1->ptr,w1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr,&isw1);



    return g;
}

static VALUE
c2s2gt(self,jm,im,g)
    VALUE self,jm,im,g;
{
    int jm1;
    int im1;
    struct NARRAY *g1;
    struct NARRAY *gg1;
    VALUE gg;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    g = na_cast_object(g, NA_DFLOAT);
    GetNArray(g,g1);
    if ( *g1->shape != ((jm1*1)*im1) ) rb_raise(rb_eArgError, "invalid ary size: g : %d != ((jm1*1)*im1) = %d ", *g1->shape, ((jm1*1)*im1) );
    shape[0] = ((jm1*1)*im1);
    gg = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(gg,gg1);

    c2s2gt_(&jm1,&im1,g1->ptr,gg1->ptr);



    return gg;
}

static VALUE
c2g2sa(self,lm,km,jm,im,g,w,itj,tj,iti,ti,isw)
    VALUE self,lm,km,jm,im,g,w,itj,tj,iti,ti,isw;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    struct NARRAY *g1;
    struct NARRAY *w1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;
    int isw1;



    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    g = na_cast_object(g, NA_DFLOAT);
    GetNArray(g,g1);
    if ( *g1->shape != ((jm1+1)*im1) ) rb_raise(rb_eArgError, "invalid ary size: g : %d != ((jm1+1)*im1) = %d ", *g1->shape, ((jm1+1)*im1) );
    w = na_cast_object(w, NA_DFLOAT);
    GetNArray(w,w1);
    if ( *w1->shape != ((jm1+1)*im1) ) rb_raise(rb_eArgError, "invalid ary size: w : %d != ((jm1+1)*im1) = %d ", *w1->shape, ((jm1+1)*im1) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*6) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*6) = %d ", *tj1->shape, (jm1*6) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );
    isw1 = NUM2INT(isw);

    c2g2sa_(&lm1,&km1,&jm1,&im1,g1->ptr,w1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr,&isw1);



    return 0;
}

static VALUE
c2g2st(self,jm,im,gg)
    VALUE self,jm,im,gg;
{
    int jm1;
    int im1;
    struct NARRAY *gg1;
    struct NARRAY *g1;
    VALUE g;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    gg = na_cast_object(gg, NA_DFLOAT);
    GetNArray(gg,gg1);
    if ( *gg1->shape != ((jm1*1)*im1) ) rb_raise(rb_eArgError, "invalid ary size: gg : %d != ((jm1*1)*im1) = %d ", *gg1->shape, ((jm1*1)*im1) );
    shape[0] = ((jm1*1)*im1);
    g = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(g,g1);

    c2g2st_(&jm1,&im1,gg1->ptr,g1->ptr);



    return g;
}

static VALUE
c2ajcb(self,lm,km,jm,im,sa,sb,ws,wg,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,sa,sb,ws,wg,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    struct NARRAY *sa1;
    struct NARRAY *sb1;
    struct NARRAY *sc1;
    VALUE sc;
    struct NARRAY *ws1;
    struct NARRAY *wg1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    sa = na_cast_object(sa, NA_DFLOAT);
    GetNArray(sa,sa1);
    if ( *sa1->shape != ((2*km1+1)*lm1) ) rb_raise(rb_eArgError, "invalid ary size: sa : %d != ((2*km1+1)*lm1) = %d ", *sa1->shape, ((2*km1+1)*lm1) );
    sb = na_cast_object(sb, NA_DFLOAT);
    GetNArray(sb,sb1);
    if ( *sb1->shape != ((2*km1+1)*lm1) ) rb_raise(rb_eArgError, "invalid ary size: sb : %d != ((2*km1+1)*lm1) = %d ", *sb1->shape, ((2*km1+1)*lm1) );
    shape[0] = ((2*km1+1)*lm1);
    sc = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(sc,sc1);
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape != ((2*km1+1)*(lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d != ((2*km1+1)*(lm1+1)) = %d ", *ws1->shape, ((2*km1+1)*(lm1+1)) );
    wg = na_cast_object(wg, NA_DFLOAT);
    GetNArray(wg,wg1);
    if ( *wg1->shape != ((jm1+1)*im1*3) ) rb_raise(rb_eArgError, "invalid ary size: wg : %d != ((jm1+1)*im1*3) = %d ", *wg1->shape, ((jm1+1)*im1*3) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*6) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*6) = %d ", *tj1->shape, (jm1*6) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    c2ajcb_(&lm1,&km1,&jm1,&im1,sa1->ptr,sb1->ptr,sc1->ptr,ws1->ptr,wg1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return sc;
}

static VALUE
c2ajc2(self,lm,km,jm,im,sa,sb1,sb2,ws,wg,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,sa,sb1,sb2,ws,wg,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    struct NARRAY *sa1;
    struct NARRAY *sb11;
    struct NARRAY *sb21;
    struct NARRAY *sc11;
    VALUE sc1;
    struct NARRAY *sc21;
    VALUE sc2;
    struct NARRAY *ws1;
    struct NARRAY *wg1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    sa = na_cast_object(sa, NA_DFLOAT);
    GetNArray(sa,sa1);
    if ( *sa1->shape != ((2*km1+1)*lm1) ) rb_raise(rb_eArgError, "invalid ary size: sa : %d != ((2*km1+1)*lm1) = %d ", *sa1->shape, ((2*km1+1)*lm1) );
    sb1 = na_cast_object(sb1, NA_DFLOAT);
    GetNArray(sb1,sb11);
    if ( *sb11->shape != ((2*km1+1)*lm1) ) rb_raise(rb_eArgError, "invalid ary size: sb1 : %d != ((2*km1+1)*lm1) = %d ", *sb11->shape, ((2*km1+1)*lm1) );
    sb2 = na_cast_object(sb2, NA_DFLOAT);
    GetNArray(sb2,sb21);
    if ( *sb21->shape != ((2*km1+1)*lm1) ) rb_raise(rb_eArgError, "invalid ary size: sb2 : %d != ((2*km1+1)*lm1) = %d ", *sb21->shape, ((2*km1+1)*lm1) );
    shape[0] = ((2*km1+1)*lm1);
    sc1 = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(sc1,sc11);
    shape[0] = ((2*km1+1)*lm1);
    sc2 = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(sc2,sc21);
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape != ((2*km1+1)*(lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d != ((2*km1+1)*(lm1+1)) = %d ", *ws1->shape, ((2*km1+1)*(lm1+1)) );
    wg = na_cast_object(wg, NA_DFLOAT);
    GetNArray(wg,wg1);
    if ( *wg1->shape != ((jm1+1)*im1*4) ) rb_raise(rb_eArgError, "invalid ary size: wg : %d != ((jm1+1)*im1*4) = %d ", *wg1->shape, ((jm1+1)*im1*4) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*6) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*6) = %d ", *tj1->shape, (jm1*6) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    c2ajc2_(&lm1,&km1,&jm1,&im1,sa1->ptr,sb11->ptr,sb21->ptr,sc11->ptr,sc21->ptr,ws1->ptr,wg1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return rb_ary_new3(2, sc1, sc2);
}

static VALUE
c2ajbs(self,lm,km,jm,im,r,z,ws,wg,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,r,z,ws,wg,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    double r1;
    struct NARRAY *z1;
    struct NARRAY *dz1;
    VALUE dz;
    struct NARRAY *ws1;
    struct NARRAY *wg1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    r1 = NUM2DBL(r);
    z = na_cast_object(z, NA_DFLOAT);
    GetNArray(z,z1);
    if ( *z1->shape != ((2*km1+1)*lm1) ) rb_raise(rb_eArgError, "invalid ary size: z : %d != ((2*km1+1)*lm1) = %d ", *z1->shape, ((2*km1+1)*lm1) );
    shape[0] = ((2*km1+1)*lm1);
    dz = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(dz,dz1);
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape != ((2*km1+1)*(lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d != ((2*km1+1)*(lm1+1)) = %d ", *ws1->shape, ((2*km1+1)*(lm1+1)) );
    wg = na_cast_object(wg, NA_DFLOAT);
    GetNArray(wg,wg1);
    if ( *wg1->shape != ((jm1+1)*im1*3) ) rb_raise(rb_eArgError, "invalid ary size: wg : %d != ((jm1+1)*im1*3) = %d ", *wg1->shape, ((jm1+1)*im1*3) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*6) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*6) = %d ", *tj1->shape, (jm1*6) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    c2ajbs_(&lm1,&km1,&jm1,&im1,&r1,z1->ptr,dz1->ptr,ws1->ptr,wg1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return dz;
}

static VALUE
c2ajb2(self,lm,km,jm,im,r,z,s,ws,wg,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,r,z,s,ws,wg,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    double r1;
    struct NARRAY *z1;
    struct NARRAY *dz1;
    VALUE dz;
    struct NARRAY *s1;
    struct NARRAY *ds1;
    VALUE ds;
    struct NARRAY *ws1;
    struct NARRAY *wg1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    r1 = NUM2DBL(r);
    z = na_cast_object(z, NA_DFLOAT);
    GetNArray(z,z1);
    if ( *z1->shape != ((2*km1+1)*lm1) ) rb_raise(rb_eArgError, "invalid ary size: z : %d != ((2*km1+1)*lm1) = %d ", *z1->shape, ((2*km1+1)*lm1) );
    shape[0] = ((2*km1+1)*lm1);
    dz = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(dz,dz1);
    s = na_cast_object(s, NA_DFLOAT);
    GetNArray(s,s1);
    if ( *s1->shape != ((2*km1+1)*lm1) ) rb_raise(rb_eArgError, "invalid ary size: s : %d != ((2*km1+1)*lm1) = %d ", *s1->shape, ((2*km1+1)*lm1) );
    shape[0] = ((2*km1+1)*lm1);
    ds = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(ds,ds1);
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape != ((2*km1+1)*(lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d != ((2*km1+1)*(lm1+1)) = %d ", *ws1->shape, ((2*km1+1)*(lm1+1)) );
    wg = na_cast_object(wg, NA_DFLOAT);
    GetNArray(wg,wg1);
    if ( *wg1->shape != ((jm1+1)*im1*4) ) rb_raise(rb_eArgError, "invalid ary size: wg : %d != ((jm1+1)*im1*4) = %d ", *wg1->shape, ((jm1+1)*im1*4) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*6) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*6) = %d ", *tj1->shape, (jm1*6) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    c2ajb2_(&lm1,&km1,&jm1,&im1,&r1,z1->ptr,dz1->ptr,s1->ptr,ds1->ptr,ws1->ptr,wg1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return rb_ary_new3(2, dz, ds);
}

static VALUE
c2swnl(self,lm,km,jm,im,r,avt,div,phi,ws,wg,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,r,avt,div,phi,ws,wg,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    double r1;
    struct NARRAY *avt1;
    struct NARRAY *div1;
    struct NARRAY *phi1;
    struct NARRAY *davt1;
    VALUE davt;
    struct NARRAY *ddiv1;
    VALUE ddiv;
    struct NARRAY *dphi1;
    VALUE dphi;
    struct NARRAY *ws1;
    struct NARRAY *wg1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    r1 = NUM2DBL(r);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((2*km1+1)*lm1) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((2*km1+1)*lm1) = %d ", *avt1->shape, ((2*km1+1)*lm1) );
    div = na_cast_object(div, NA_DFLOAT);
    GetNArray(div,div1);
    if ( *div1->shape != ((2*km1+1)*(lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: div : %d != ((2*km1+1)*(lm1+1)) = %d ", *div1->shape, ((2*km1+1)*(lm1+1)) );
    phi = na_cast_object(phi, NA_DFLOAT);
    GetNArray(phi,phi1);
    if ( *phi1->shape != ((2*km1+1)*(lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: phi : %d != ((2*km1+1)*(lm1+1)) = %d ", *phi1->shape, ((2*km1+1)*(lm1+1)) );
    shape[0] = ((2*km1+1)*lm1);
    davt = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(davt,davt1);
    shape[0] = ((2*km1+1)*(lm1+1));
    ddiv = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(ddiv,ddiv1);
    shape[0] = ((2*km1+1)*(lm1+1));
    dphi = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(dphi,dphi1);
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape != ((2*km1+1)*(lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d != ((2*km1+1)*(lm1+1)) = %d ", *ws1->shape, ((2*km1+1)*(lm1+1)) );
    wg = na_cast_object(wg, NA_DFLOAT);
    GetNArray(wg,wg1);
    if ( *wg1->shape != ((jm1+1)*im1*4) ) rb_raise(rb_eArgError, "invalid ary size: wg : %d != ((jm1+1)*im1*4) = %d ", *wg1->shape, ((jm1+1)*im1*4) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*6) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*6) = %d ", *tj1->shape, (jm1*6) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    c2swnl_(&lm1,&km1,&jm1,&im1,&r1,avt1->ptr,div1->ptr,phi1->ptr,davt1->ptr,ddiv1->ptr,dphi1->ptr,ws1->ptr,wg1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return rb_ary_new3(3, davt, ddiv, dphi);
}

static VALUE
c2swnn(self,lm,km,jm,im,r,barphi,avt,div,ws,wg,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,r,barphi,avt,div,ws,wg,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    double r1;
    double barphi1;
    struct NARRAY *avt1;
    struct NARRAY *div1;
    struct NARRAY *phi1;
    VALUE phi;
    struct NARRAY *davt1;
    VALUE davt;
    struct NARRAY *ddiv1;
    VALUE ddiv;
    struct NARRAY *dphi1;
    VALUE dphi;
    struct NARRAY *ws1;
    struct NARRAY *wg1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    r1 = NUM2DBL(r);
    barphi1 = NUM2DBL(barphi);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((2*km1+1)*lm1) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((2*km1+1)*lm1) = %d ", *avt1->shape, ((2*km1+1)*lm1) );
    div = na_cast_object(div, NA_DFLOAT);
    GetNArray(div,div1);
    if ( *div1->shape != ((2*km1+1)*(lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: div : %d != ((2*km1+1)*(lm1+1)) = %d ", *div1->shape, ((2*km1+1)*(lm1+1)) );
    shape[0] = ((2*km1+1)*(lm1+1));
    phi = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(phi,phi1);
    shape[0] = ((2*km1+1)*lm1);
    davt = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(davt,davt1);
    shape[0] = ((2*km1+1)*(lm1+1));
    ddiv = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(ddiv,ddiv1);
    shape[0] = ((2*km1+1)*(lm1+1));
    dphi = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(dphi,dphi1);
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape != ((2*km1+1)*(lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d != ((2*km1+1)*(lm1+1)) = %d ", *ws1->shape, ((2*km1+1)*(lm1+1)) );
    wg = na_cast_object(wg, NA_DFLOAT);
    GetNArray(wg,wg1);
    if ( *wg1->shape != ((jm1+1)*im1*4) ) rb_raise(rb_eArgError, "invalid ary size: wg : %d != ((jm1+1)*im1*4) = %d ", *wg1->shape, ((jm1+1)*im1*4) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*6) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*6) = %d ", *tj1->shape, (jm1*6) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    c2swnn_(&lm1,&km1,&jm1,&im1,&r1,&barphi1,avt1->ptr,div1->ptr,phi1->ptr,davt1->ptr,ddiv1->ptr,dphi1->ptr,ws1->ptr,wg1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return rb_ary_new3(4, phi, davt, ddiv, dphi);
}

static VALUE
c2swck(self,lm,km,jm,r,im,avt,div,phi,ws,wg,itj,tj,iti,ti)
    VALUE self,lm,km,jm,r,im,avt,div,phi,ws,wg,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    double r1;
    int im1;
    struct NARRAY *avt1;
    struct NARRAY *div1;
    struct NARRAY *phi1;
    double amom1;
    VALUE amom;
    double aene1;
    VALUE aene;
    double aens1;
    VALUE aens;
    struct NARRAY *ws1;
    struct NARRAY *wg1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;



    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    r1 = NUM2DBL(r);
    im1 = NUM2INT(im);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((2*km1+1)*lm1) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((2*km1+1)*lm1) = %d ", *avt1->shape, ((2*km1+1)*lm1) );
    div = na_cast_object(div, NA_DFLOAT);
    GetNArray(div,div1);
    if ( *div1->shape != ((2*km1+1)*(lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: div : %d != ((2*km1+1)*(lm1+1)) = %d ", *div1->shape, ((2*km1+1)*(lm1+1)) );
    phi = na_cast_object(phi, NA_DFLOAT);
    GetNArray(phi,phi1);
    if ( *phi1->shape != ((2*km1+1)*(lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: phi : %d != ((2*km1+1)*(lm1+1)) = %d ", *phi1->shape, ((2*km1+1)*(lm1+1)) );
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape != ((2*km1+1)*(lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d != ((2*km1+1)*(lm1+1)) = %d ", *ws1->shape, ((2*km1+1)*(lm1+1)) );
    wg = na_cast_object(wg, NA_DFLOAT);
    GetNArray(wg,wg1);
    if ( *wg1->shape != ((jm1+1)*im1*4) ) rb_raise(rb_eArgError, "invalid ary size: wg : %d != ((jm1+1)*im1*4) = %d ", *wg1->shape, ((jm1+1)*im1*4) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*6) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*6) = %d ", *tj1->shape, (jm1*6) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    c2swck_(&lm1,&km1,&jm1,&r1,&im1,avt1->ptr,div1->ptr,phi1->ptr,&amom1,&aene1,&aens1,ws1->ptr,wg1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);


    amom = rb_float_new(amom1);
    aene = rb_float_new(aene1);
    aens = rb_float_new(aens1);

    return rb_ary_new3(3, amom, aene, aens);
}

static VALUE
c2swbl(self,lm,km,jm,im,r,barphi,avt,phi,ws,wg,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,r,barphi,avt,phi,ws,wg,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    double r1;
    double barphi1;
    struct NARRAY *avt1;
    struct NARRAY *phi1;
    struct NARRAY *ws1;
    struct NARRAY *wg1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;



    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    r1 = NUM2DBL(r);
    barphi1 = NUM2DBL(barphi);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((2*km1+1)*lm1) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((2*km1+1)*lm1) = %d ", *avt1->shape, ((2*km1+1)*lm1) );
    phi = na_cast_object(phi, NA_DFLOAT);
    GetNArray(phi,phi1);
    if ( *phi1->shape != ((2*km1+1)*(lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: phi : %d != ((2*km1+1)*(lm1+1)) = %d ", *phi1->shape, ((2*km1+1)*(lm1+1)) );
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape != ((2*km1+1)*(lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d != ((2*km1+1)*(lm1+1)) = %d ", *ws1->shape, ((2*km1+1)*(lm1+1)) );
    wg = na_cast_object(wg, NA_DFLOAT);
    GetNArray(wg,wg1);
    if ( *wg1->shape != ((jm1+1)*im1*4) ) rb_raise(rb_eArgError, "invalid ary size: wg : %d != ((jm1+1)*im1*4) = %d ", *wg1->shape, ((jm1+1)*im1*4) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*6) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*6) = %d ", *tj1->shape, (jm1*6) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    c2swbl_(&lm1,&km1,&jm1,&im1,&r1,&barphi1,avt1->ptr,phi1->ptr,ws1->ptr,wg1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return 0;
}

static VALUE
fttzli(self,n,it,t)
    VALUE self,n,it,t;
{
    int n1;
    struct NARRAY *it1;
    struct NARRAY *t1;



    n1 = NUM2INT(n);
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (n1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (n1*2) = %d ", *t1->shape, (n1*2) );

    fttzli_(&n1,it1->ptr,t1->ptr);



    return 0;
}

static VALUE
fttzlm(self,m,n,x,y,it,t)
    VALUE self,m,n,x,y,it,t;
{
    int m1;
    int n1;
    double x1;
    double y1;
    struct NARRAY *it1;
    struct NARRAY *t1;



    m1 = NUM2INT(m);
    n1 = NUM2INT(n);
    x1 = NUM2DBL(x);
    y1 = NUM2DBL(y);
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (n1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (n1*2) = %d ", *t1->shape, (n1*2) );

    fttzlm_(&m1,&n1,&x1,&y1,it1->ptr,t1->ptr);



    return x;
}

static VALUE
fttzui(self,n,it,t)
    VALUE self,n,it,t;
{
    int n1;
    struct NARRAY *it1;
    struct NARRAY *t1;



    n1 = NUM2INT(n);
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (n1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (n1*2) = %d ", *t1->shape, (n1*2) );

    fttzui_(&n1,it1->ptr,t1->ptr);



    return 0;
}

static VALUE
fttzuf(self,m,n,x,y,it,t)
    VALUE self,m,n,x,y,it,t;
{
    int m1;
    int n1;
    double x1;
    double y1;
    struct NARRAY *it1;
    struct NARRAY *t1;



    m1 = NUM2INT(m);
    n1 = NUM2INT(n);
    x1 = NUM2DBL(x);
    y1 = NUM2DBL(y);
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (n1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (n1*2) = %d ", *t1->shape, (n1*2) );

    fttzuf_(&m1,&n1,&x1,&y1,it1->ptr,t1->ptr);



    return x;
}

static VALUE
fttzub(self,m,n,x,y,it,t)
    VALUE self,m,n,x,y,it,t;
{
    int m1;
    int n1;
    double x1;
    double y1;
    struct NARRAY *it1;
    struct NARRAY *t1;



    m1 = NUM2INT(m);
    n1 = NUM2INT(n);
    x1 = NUM2DBL(x);
    y1 = NUM2DBL(y);
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (n1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (n1*2) = %d ", *t1->shape, (n1*2) );

    fttzub_(&m1,&n1,&x1,&y1,it1->ptr,t1->ptr);



    return x;
}

static VALUE
fttrui(self,n,it,t)
    VALUE self,n,it,t;
{
    int n1;
    struct NARRAY *it1;
    struct NARRAY *t1;



    n1 = NUM2INT(n);
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (n1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (n1*2) = %d ", *t1->shape, (n1*2) );

    fttrui_(&n1,it1->ptr,t1->ptr);



    return 0;
}

static VALUE
fttruf(self,m,n,x,y,it,t)
    VALUE self,m,n,x,y,it,t;
{
    int m1;
    int n1;
    double x1;
    struct NARRAY *y1;
    struct NARRAY *it1;
    struct NARRAY *t1;



    m1 = NUM2INT(m);
    n1 = NUM2INT(n);
    x1 = NUM2DBL(x);
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (m1*n1 ) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (m1*n1 ) = %d ", *y1->shape, (m1*n1 ) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (n1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (n1*2) = %d ", *t1->shape, (n1*2) );

    fttruf_(&m1,&n1,&x1,y1->ptr,it1->ptr,t1->ptr);



    return x;
}

static VALUE
fttrub(self,m,n,x,y,it,t)
    VALUE self,m,n,x,y,it,t;
{
    int m1;
    int n1;
    double x1;
    struct NARRAY *y1;
    struct NARRAY *it1;
    struct NARRAY *t1;



    m1 = NUM2INT(m);
    n1 = NUM2INT(n);
    x1 = NUM2DBL(x);
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (m1*n1 ) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (m1*n1 ) = %d ", *y1->shape, (m1*n1 ) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (n1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (n1*2) = %d ", *t1->shape, (n1*2) );

    fttrub_(&m1,&n1,&x1,y1->ptr,it1->ptr,t1->ptr);



    return x;
}

static VALUE
fttcti(self,n,it,t)
    VALUE self,n,it,t;
{
    int n1;
    struct NARRAY *it1;
    struct NARRAY *t1;



    n1 = NUM2INT(n);
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (3*n1 ) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (3*n1 ) = %d ", *t1->shape, (3*n1 ) );

    fttcti_(&n1,it1->ptr,t1->ptr);



    return 0;
}

static VALUE
fttctf(self,m,n,x,y,it,t)
    VALUE self,m,n,x,y,it,t;
{
    int m1;
    int n1;
    double x1;
    struct NARRAY *y1;
    struct NARRAY *it1;
    struct NARRAY *t1;



    m1 = NUM2INT(m);
    n1 = NUM2INT(n);
    x1 = NUM2DBL(x);
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (m1*n1 ) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (m1*n1 ) = %d ", *y1->shape, (m1*n1 ) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (3*n1 ) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (3*n1 ) = %d ", *t1->shape, (3*n1 ) );

    fttctf_(&m1,&n1,&x1,y1->ptr,it1->ptr,t1->ptr);



    return x;
}

static VALUE
fttctb(self,m,n,x,y,it,t)
    VALUE self,m,n,x,y,it,t;
{
    int m1;
    int n1;
    double x1;
    struct NARRAY *y1;
    struct NARRAY *it1;
    struct NARRAY *t1;



    m1 = NUM2INT(m);
    n1 = NUM2INT(n);
    x1 = NUM2DBL(x);
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (m1*n1 ) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (m1*n1 ) = %d ", *y1->shape, (m1*n1 ) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (3*n1 ) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (3*n1 ) = %d ", *t1->shape, (3*n1 ) );

    fttctb_(&m1,&n1,&x1,y1->ptr,it1->ptr,t1->ptr);



    return x;
}

static VALUE
fttsti(self,n,it,t)
    VALUE self,n,it,t;
{
    int n1;
    struct NARRAY *it1;
    struct NARRAY *t1;



    n1 = NUM2INT(n);
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (5*n1/2 ) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (5*n1/2 ) = %d ", *t1->shape, (5*n1/2 ) );

    fttsti_(&n1,it1->ptr,t1->ptr);



    return 0;
}

static VALUE
fttstf(self,m,n,x,y,it,t)
    VALUE self,m,n,x,y,it,t;
{
    int m1;
    int n1;
    double x1;
    struct NARRAY *y1;
    struct NARRAY *it1;
    struct NARRAY *t1;



    m1 = NUM2INT(m);
    n1 = NUM2INT(n);
    x1 = NUM2DBL(x);
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (m1*n1 ) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (m1*n1 ) = %d ", *y1->shape, (m1*n1 ) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (5*n1/2 ) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (5*n1/2 ) = %d ", *t1->shape, (5*n1/2 ) );

    fttstf_(&m1,&n1,&x1,y1->ptr,it1->ptr,t1->ptr);



    return x;
}

static VALUE
fttstb(self,m,n,x,y,it,t)
    VALUE self,m,n,x,y,it,t;
{
    int m1;
    int n1;
    double x1;
    struct NARRAY *y1;
    struct NARRAY *it1;
    struct NARRAY *t1;



    m1 = NUM2INT(m);
    n1 = NUM2INT(n);
    x1 = NUM2DBL(x);
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (m1*n1 ) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (m1*n1 ) = %d ", *y1->shape, (m1*n1 ) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (5*n1/2 ) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (5*n1/2 ) = %d ", *t1->shape, (5*n1/2 ) );

    fttstb_(&m1,&n1,&x1,y1->ptr,it1->ptr,t1->ptr);



    return x;
}

static VALUE
fttcmi(self,n,it,t)
    VALUE self,n,it,t;
{
    int n1;
    struct NARRAY *it1;
    struct NARRAY *t1;



    n1 = NUM2INT(n);
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (6*n1 ) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (6*n1 ) = %d ", *t1->shape, (6*n1 ) );

    fttcmi_(&n1,it1->ptr,t1->ptr);



    return 0;
}

static VALUE
fttcmf(self,m,n,x,y,it,t)
    VALUE self,m,n,x,y,it,t;
{
    int m1;
    int n1;
    double x1;
    struct NARRAY *y1;
    struct NARRAY *it1;
    struct NARRAY *t1;



    m1 = NUM2INT(m);
    n1 = NUM2INT(n);
    x1 = NUM2DBL(x);
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (m1*n1 ) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (m1*n1 ) = %d ", *y1->shape, (m1*n1 ) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (6*n1 ) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (6*n1 ) = %d ", *t1->shape, (6*n1 ) );

    fttcmf_(&m1,&n1,&x1,y1->ptr,it1->ptr,t1->ptr);



    return x;
}

static VALUE
fttcmb(self,m,n,x,y,it,t)
    VALUE self,m,n,x,y,it,t;
{
    int m1;
    int n1;
    double x1;
    struct NARRAY *y1;
    struct NARRAY *it1;
    struct NARRAY *t1;



    m1 = NUM2INT(m);
    n1 = NUM2INT(n);
    x1 = NUM2DBL(x);
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (m1*n1 ) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (m1*n1 ) = %d ", *y1->shape, (m1*n1 ) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (6*n1 ) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (6*n1 ) = %d ", *t1->shape, (6*n1 ) );

    fttcmb_(&m1,&n1,&x1,y1->ptr,it1->ptr,t1->ptr);



    return x;
}

static VALUE
fttsmi(self,n,it,t)
    VALUE self,n,it,t;
{
    int n1;
    struct NARRAY *it1;
    struct NARRAY *t1;



    n1 = NUM2INT(n);
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (6*n1 ) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (6*n1 ) = %d ", *t1->shape, (6*n1 ) );

    fttsmi_(&n1,it1->ptr,t1->ptr);



    return 0;
}

static VALUE
fttsmf(self,m,n,x,y,it,t)
    VALUE self,m,n,x,y,it,t;
{
    int m1;
    int n1;
    double x1;
    struct NARRAY *y1;
    struct NARRAY *it1;
    struct NARRAY *t1;



    m1 = NUM2INT(m);
    n1 = NUM2INT(n);
    x1 = NUM2DBL(x);
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (m1*n1 ) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (m1*n1 ) = %d ", *y1->shape, (m1*n1 ) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (6*n1 ) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (6*n1 ) = %d ", *t1->shape, (6*n1 ) );

    fttsmf_(&m1,&n1,&x1,y1->ptr,it1->ptr,t1->ptr);



    return x;
}

static VALUE
fttsmb(self,m,n,x,y,it,t)
    VALUE self,m,n,x,y,it,t;
{
    int m1;
    int n1;
    double x1;
    struct NARRAY *y1;
    struct NARRAY *it1;
    struct NARRAY *t1;



    m1 = NUM2INT(m);
    n1 = NUM2INT(n);
    x1 = NUM2DBL(x);
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (m1*n1 ) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (m1*n1 ) = %d ", *y1->shape, (m1*n1 ) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (6*n1 ) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (6*n1 ) = %d ", *t1->shape, (6*n1 ) );

    fttsmb_(&m1,&n1,&x1,y1->ptr,it1->ptr,t1->ptr);



    return x;
}

static VALUE
n2init(self,jm,im)
    VALUE self,jm,im;
{
    int jm1;
    int im1;
    struct NARRAY *itj1;
    VALUE itj;
    struct NARRAY *tj1;
    VALUE tj;
    struct NARRAY *iti1;
    VALUE iti;
    struct NARRAY *ti1;
    VALUE ti;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    shape[0] = (5);
    itj = na_make_object( NA_LINT, rank, shape, cNArray );
    GetNArray(itj,itj1);
    shape[0] = (jm1*2);
    tj = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(tj,tj1);
    shape[0] = (5);
    iti = na_make_object( NA_LINT, rank, shape, cNArray );
    GetNArray(iti,iti1);
    shape[0] = (jm1*2);
    ti = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(ti,ti1);

    n2init_(&jm1,&im1,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return rb_ary_new3(4, itj, tj, iti, ti);
}

static VALUE
n2s2ga(self,lm,km,jm,im,s,w,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,s,w,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    struct NARRAY *s1;
    struct NARRAY *g1;
    VALUE g;
    struct NARRAY *w1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    s = na_cast_object(s, NA_DFLOAT);
    GetNArray(s,s1);
    if ( *s1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: s : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *s1->shape, ((2*km1+1)*(2*lm1+1)) );
    shape[0] = (jm1*im1);
    g = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(g,g1);
    w = na_cast_object(w, NA_DFLOAT);
    GetNArray(w,w1);
    if ( *w1->shape != (jm1*im1) ) rb_raise(rb_eArgError, "invalid ary size: w : %d != (jm1*im1) = %d ", *w1->shape, (jm1*im1) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*2) = %d ", *tj1->shape, (jm1*2) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    n2s2ga_(&lm1,&km1,&jm1,&im1,s1->ptr,g1->ptr,w1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return g;
}

static VALUE
n2g2sa(self,lm,km,jm,im,g,w,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,g,w,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    struct NARRAY *g1;
    struct NARRAY *s1;
    VALUE s;
    struct NARRAY *w1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    g = na_cast_object(g, NA_DFLOAT);
    GetNArray(g,g1);
    if ( *g1->shape != (jm1*im1) ) rb_raise(rb_eArgError, "invalid ary size: g : %d != (jm1*im1) = %d ", *g1->shape, (jm1*im1) );
    shape[0] = ((2*km1+1)*(2*lm1+1));
    s = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(s,s1);
    w = na_cast_object(w, NA_DFLOAT);
    GetNArray(w,w1);
    if ( *w1->shape != (jm1*im1) ) rb_raise(rb_eArgError, "invalid ary size: w : %d != (jm1*im1) = %d ", *w1->shape, (jm1*im1) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*2) = %d ", *tj1->shape, (jm1*2) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    n2g2sa_(&lm1,&km1,&jm1,&im1,g1->ptr,s1->ptr,w1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return s;
}

static VALUE
n2ajbs(self,lm,km,jm,im,z,ws,wg,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,z,ws,wg,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    struct NARRAY *z1;
    struct NARRAY *dz1;
    VALUE dz;
    struct NARRAY *ws1;
    struct NARRAY *wg1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    z = na_cast_object(z, NA_DFLOAT);
    GetNArray(z,z1);
    if ( *z1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: z : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *z1->shape, ((2*km1+1)*(2*lm1+1)) );
    shape[0] = ((2*km1+1)*(2*lm1+1));
    dz = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(dz,dz1);
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *ws1->shape, ((2*km1+1)*(2*lm1+1)) );
    wg = na_cast_object(wg, NA_DFLOAT);
    GetNArray(wg,wg1);
    if ( *wg1->shape != (jm1*im1*3) ) rb_raise(rb_eArgError, "invalid ary size: wg : %d != (jm1*im1*3) = %d ", *wg1->shape, (jm1*im1*3) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*2) = %d ", *tj1->shape, (jm1*2) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    n2ajbs_(&lm1,&km1,&jm1,&im1,z1->ptr,dz1->ptr,ws1->ptr,wg1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return dz;
}

static VALUE
n2swnl(self,lm,km,jm,im,avt,div,phi,ws,wg,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,avt,div,phi,ws,wg,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    struct NARRAY *avt1;
    struct NARRAY *div1;
    struct NARRAY *phi1;
    struct NARRAY *davt1;
    VALUE davt;
    struct NARRAY *ddiv1;
    VALUE ddiv;
    struct NARRAY *dphi1;
    VALUE dphi;
    struct NARRAY *ws1;
    struct NARRAY *wg1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *avt1->shape, ((2*km1+1)*(2*lm1+1)) );
    div = na_cast_object(div, NA_DFLOAT);
    GetNArray(div,div1);
    if ( *div1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: div : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *div1->shape, ((2*km1+1)*(2*lm1+1)) );
    phi = na_cast_object(phi, NA_DFLOAT);
    GetNArray(phi,phi1);
    if ( *phi1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: phi : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *phi1->shape, ((2*km1+1)*(2*lm1+1)) );
    shape[0] = ((2*km1+1)*(2*lm1+1));
    davt = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(davt,davt1);
    shape[0] = ((2*km1+1)*(2*lm1+1));
    ddiv = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(ddiv,ddiv1);
    shape[0] = ((2*km1+1)*(2*lm1+1));
    dphi = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(dphi,dphi1);
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape != ((2*km1+1)*(2*lm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d != ((2*km1+1)*(2*lm1+1)*2) = %d ", *ws1->shape, ((2*km1+1)*(2*lm1+1)*2) );
    wg = na_cast_object(wg, NA_DFLOAT);
    GetNArray(wg,wg1);
    if ( *wg1->shape != (jm1*im1*5) ) rb_raise(rb_eArgError, "invalid ary size: wg : %d != (jm1*im1*5) = %d ", *wg1->shape, (jm1*im1*5) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*2) = %d ", *tj1->shape, (jm1*2) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    n2swnl_(&lm1,&km1,&jm1,&im1,avt1->ptr,div1->ptr,phi1->ptr,davt1->ptr,ddiv1->ptr,dphi1->ptr,ws1->ptr,wg1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return rb_ary_new3(3, davt, ddiv, dphi);
}

static VALUE
n2swnn(self,lm,km,jm,im,barphi,f,avt,div,phi,ws,wg,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,barphi,f,avt,div,phi,ws,wg,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    double barphi1;
    double f1;
    struct NARRAY *avt1;
    struct NARRAY *div1;
    struct NARRAY *phi1;
    struct NARRAY *davt1;
    VALUE davt;
    struct NARRAY *ddiv1;
    VALUE ddiv;
    struct NARRAY *dphi1;
    VALUE dphi;
    struct NARRAY *ws1;
    struct NARRAY *wg1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    barphi1 = NUM2DBL(barphi);
    f1 = NUM2DBL(f);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *avt1->shape, ((2*km1+1)*(2*lm1+1)) );
    div = na_cast_object(div, NA_DFLOAT);
    GetNArray(div,div1);
    if ( *div1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: div : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *div1->shape, ((2*km1+1)*(2*lm1+1)) );
    phi = na_cast_object(phi, NA_DFLOAT);
    GetNArray(phi,phi1);
    if ( *phi1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: phi : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *phi1->shape, ((2*km1+1)*(2*lm1+1)) );
    shape[0] = ((2*km1+1)*(2*lm1+1));
    davt = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(davt,davt1);
    shape[0] = ((2*km1+1)*(2*lm1+1));
    ddiv = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(ddiv,ddiv1);
    shape[0] = ((2*km1+1)*(2*lm1+1));
    dphi = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(dphi,dphi1);
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape != ((2*km1+1)*(2*lm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d != ((2*km1+1)*(2*lm1+1)*2) = %d ", *ws1->shape, ((2*km1+1)*(2*lm1+1)*2) );
    wg = na_cast_object(wg, NA_DFLOAT);
    GetNArray(wg,wg1);
    if ( *wg1->shape != (jm1*im1*5) ) rb_raise(rb_eArgError, "invalid ary size: wg : %d != (jm1*im1*5) = %d ", *wg1->shape, (jm1*im1*5) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*2) = %d ", *tj1->shape, (jm1*2) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    n2swnn_(&lm1,&km1,&jm1,&im1,&barphi1,&f1,avt1->ptr,div1->ptr,phi1->ptr,davt1->ptr,ddiv1->ptr,dphi1->ptr,ws1->ptr,wg1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return rb_ary_new3(3, davt, ddiv, dphi);
}

static VALUE
n2swck(self,lm,km,jm,im,avt,div,phi,ws,wg,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,avt,div,phi,ws,wg,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    struct NARRAY *avt1;
    struct NARRAY *div1;
    struct NARRAY *phi1;
    double aene1;
    VALUE aene;
    double aens1;
    VALUE aens;
    struct NARRAY *ws1;
    struct NARRAY *wg1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;



    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *avt1->shape, ((2*km1+1)*(2*lm1+1)) );
    div = na_cast_object(div, NA_DFLOAT);
    GetNArray(div,div1);
    if ( *div1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: div : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *div1->shape, ((2*km1+1)*(2*lm1+1)) );
    phi = na_cast_object(phi, NA_DFLOAT);
    GetNArray(phi,phi1);
    if ( *phi1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: phi : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *phi1->shape, ((2*km1+1)*(2*lm1+1)) );
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape != ((2*km1+1)*(2*lm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d != ((2*km1+1)*(2*lm1+1)*2) = %d ", *ws1->shape, ((2*km1+1)*(2*lm1+1)*2) );
    wg = na_cast_object(wg, NA_DFLOAT);
    GetNArray(wg,wg1);
    if ( *wg1->shape != (jm1*im1*5) ) rb_raise(rb_eArgError, "invalid ary size: wg : %d != (jm1*im1*5) = %d ", *wg1->shape, (jm1*im1*5) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*2) = %d ", *tj1->shape, (jm1*2) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    n2swck_(&lm1,&km1,&jm1,&im1,avt1->ptr,div1->ptr,phi1->ptr,&aene1,&aens1,ws1->ptr,wg1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);


    aene = rb_float_new(aene1);
    aens = rb_float_new(aens1);

    return rb_ary_new3(2, aene, aens);
}

static VALUE
n2swbl(self,lm,km,jm,im,barphi,avt,ws,wg,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,barphi,avt,ws,wg,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    double barphi1;
    struct NARRAY *avt1;
    struct NARRAY *phi1;
    VALUE phi;
    struct NARRAY *ws1;
    struct NARRAY *wg1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    barphi1 = NUM2DBL(barphi);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *avt1->shape, ((2*km1+1)*(2*lm1+1)) );
    shape[0] = ((2*km1+1)*(2*lm1+1));
    phi = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(phi,phi1);
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape != ((2*km1+1)*(2*lm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d != ((2*km1+1)*(2*lm1+1)*2) = %d ", *ws1->shape, ((2*km1+1)*(2*lm1+1)*2) );
    wg = na_cast_object(wg, NA_DFLOAT);
    GetNArray(wg,wg1);
    if ( *wg1->shape != (jm1*im1*5) ) rb_raise(rb_eArgError, "invalid ary size: wg : %d != (jm1*im1*5) = %d ", *wg1->shape, (jm1*im1*5) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*2) = %d ", *tj1->shape, (jm1*2) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    n2swbl_(&lm1,&km1,&jm1,&im1,&barphi1,avt1->ptr,phi1->ptr,ws1->ptr,wg1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return phi;
}

static VALUE
spnjcb(self,mm,im,id,jm,jd,sa,sb,it,t,y,ip2,p2,r2,ip3,p3,r3,ia,a,q,ws,ww)
    VALUE self,mm,im,id,jm,jd,sa,sb,it,t,y,ip2,p2,r2,ip3,p3,r3,ia,a,q,ws,ww;
{
    int mm1;
    int im1;
    int id1;
    int jm1;
    int jd1;
    struct NARRAY *sa1;
    struct NARRAY *sb1;
    struct NARRAY *sc1;
    VALUE sc;
    struct NARRAY *it1;
    struct NARRAY *t1;
    struct NARRAY *y1;
    struct NARRAY *ip21;
    struct NARRAY *p21;
    struct NARRAY *r21;
    struct NARRAY *ip31;
    struct NARRAY *p31;
    struct NARRAY *r31;
    struct NARRAY *ia1;
    struct NARRAY *a1;
    struct NARRAY *q1;
    struct NARRAY *ws1;
    struct NARRAY *ww1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    id1 = NUM2INT(id);
    jm1 = NUM2INT(jm);
    jd1 = NUM2INT(jd);
    sa = na_cast_object(sa, NA_DFLOAT);
    GetNArray(sa,sa1);
    if ( *sa1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: sa : %d != ((mm1+1)*(mm1+1)) = %d ", *sa1->shape, ((mm1+1)*(mm1+1)) );
    sb = na_cast_object(sb, NA_DFLOAT);
    GetNArray(sb,sb1);
    if ( *sb1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: sb : %d != ((mm1+1)*(mm1+1)) = %d ", *sb1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    sc = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(sc,sc1);
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (jm1*2) = %d ", *y1->shape, (jm1*2) );
    ip2 = na_cast_object(ip2, NA_LINT);
    GetNArray(ip2,ip21);
    if ( *ip21->shape != (2*(mm1+1)/2+mm1+1)*2 ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip21->shape );
    p2 = na_cast_object(p2, NA_DFLOAT);
    GetNArray(p2,p21);
    if ( *p21->shape != (2*((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: p2 : %d != (2*((mm1+1)/2+mm1+1)*jm1) = %d ", *p21->shape, (2*((mm1+1)/2+mm1+1)*jm1) );
    r2 = na_cast_object(r2, NA_DFLOAT);
    GetNArray(r2,r21);
    if ( *r21->shape != (2*((mm1+1)/2*2+3)*(mm1/2+1)) ) rb_raise(rb_eArgError, "invalid ary size: r2 : %d != (2*((mm1+1)/2*2+3)*(mm1/2+1)) = %d ", *r21->shape, (2*((mm1+1)/2*2+3)*(mm1/2+1)) );
    ip3 = na_cast_object(ip3, NA_LINT);
    GetNArray(ip3,ip31);
    if ( *ip31->shape != (3*(mm1+1)/2+mm1+1)*2 ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip31->shape );
    p3 = na_cast_object(p3, NA_DFLOAT);
    GetNArray(p3,p31);
    if ( *p31->shape != (3*((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: p3 : %d != (3*((mm1+1)/2+mm1+1)*jm1) = %d ", *p31->shape, (3*((mm1+1)/2+mm1+1)*jm1) );
    r3 = na_cast_object(r3, NA_DFLOAT);
    GetNArray(r3,r31);
    if ( *r31->shape != (3*((mm1+1)/2*2+3)*(mm1/2+1)) ) rb_raise(rb_eArgError, "invalid ary size: r3 : %d != (3*((mm1+1)/2*2+3)*(mm1/2+1)) = %d ", *r31->shape, (3*((mm1+1)/2*2+3)*(mm1/2+1)) );
    ia = na_cast_object(ia, NA_LINT);
    GetNArray(ia,ia1);
    if ( *ia1->shape != ((mm1+1)*(mm1+1)*4) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ia1->shape );
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)*6) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)*6) = %d ", *a1->shape, ((mm1+1)*(mm1+1)*6) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != ((3*(mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != ((3*(mm1+1)/2+mm1+1)*jm1) = %d ", *q1->shape, ((3*(mm1+1)/2+mm1+1)*jm1) );
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape < 3*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d < 3*(jd1*im1) = %d ", *ws1->shape, 3*(jd1*im1) );
    ww = na_cast_object(ww, NA_DFLOAT);
    GetNArray(ww,ww1);
    if ( *ww1->shape < 3*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ww : %d < 3*(jd1*im1) = %d ", *ww1->shape, 3*(jd1*im1) );

    spnjcb_(&mm1,&im1,&id1,&jm1,&jd1,sa1->ptr,sb1->ptr,sc1->ptr,it1->ptr,t1->ptr,y1->ptr,ip21->ptr,p21->ptr,r21->ptr,ip31->ptr,p31->ptr,r31->ptr,ia1->ptr,a1->ptr,q1->ptr,ws1->ptr,ww1->ptr);



    return sc;
}

static VALUE
spnini(self,mm)
    VALUE self,mm;
{
    int mm1;
    struct NARRAY *rn1;
    VALUE rn;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    shape[0] = ((mm1+1)*(mm1+1)*2);
    rn = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(rn,rn1);

    spnini_(&mm1,rn1->ptr);



    return rn;
}

static VALUE
spmini(self,mm)
    VALUE self,mm;
{
    int mm1;
    struct NARRAY *irm1;
    VALUE irm;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    shape[0] = ((mm1+1)*(mm1+1)*2);
    irm = na_make_object( NA_LINT, rank, shape, cNArray );
    GetNArray(irm,irm1);

    spmini_(&mm1,irm1->ptr);



    return irm;
}

static VALUE
spclap(self,mm,a,rn)
    VALUE self,mm,a,rn;
{
    int mm1;
    struct NARRAY *a1;
    struct NARRAY *b1;
    VALUE b;
    struct NARRAY *rn1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)) = %d ", *a1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    b = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(b,b1);
    rn = na_cast_object(rn, NA_DFLOAT);
    GetNArray(rn,rn1);
    if ( *rn1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: rn : %d != ((mm1+1)*(mm1+1)) = %d ", *rn1->shape, ((mm1+1)*(mm1+1)) );

    spclap_(&mm1,a1->ptr,b1->ptr,rn1->ptr);



    return b;
}

static VALUE
spclam(self,mm,a,irm)
    VALUE self,mm,a,irm;
{
    int mm1;
    struct NARRAY *a1;
    struct NARRAY *b1;
    VALUE b;
    struct NARRAY *irm1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)) = %d ", *a1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    b = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(b,b1);
    irm = na_cast_object(irm, NA_LINT);
    GetNArray(irm,irm1);
    if ( *irm1->shape != ((mm1+1)*(mm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *irm1->shape );

    spclam_(&mm1,a1->ptr,b1->ptr,irm1->ptr);



    return b;
}

static VALUE
spswnl(self,mm,im,id,jm,jd,omega,avt,div,phi,rn,it,t,y,ip4,p4,r4,ip5,p5,r5,ia,a,q,ws,ww)
    VALUE self,mm,im,id,jm,jd,omega,avt,div,phi,rn,it,t,y,ip4,p4,r4,ip5,p5,r5,ia,a,q,ws,ww;
{
    int mm1;
    int im1;
    int id1;
    int jm1;
    int jd1;
    double omega1;
    struct NARRAY *avt1;
    struct NARRAY *div1;
    struct NARRAY *phi1;
    struct NARRAY *davt1;
    VALUE davt;
    struct NARRAY *ddiv1;
    VALUE ddiv;
    struct NARRAY *dphi1;
    VALUE dphi;
    struct NARRAY *rn1;
    struct NARRAY *it1;
    struct NARRAY *t1;
    struct NARRAY *y1;
    struct NARRAY *ip41;
    struct NARRAY *p41;
    struct NARRAY *r41;
    struct NARRAY *ip51;
    struct NARRAY *p51;
    struct NARRAY *r51;
    struct NARRAY *ia1;
    struct NARRAY *a1;
    struct NARRAY *q1;
    struct NARRAY *ws1;
    struct NARRAY *ww1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    id1 = NUM2INT(id);
    jm1 = NUM2INT(jm);
    jd1 = NUM2INT(jd);
    omega1 = NUM2DBL(omega);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((mm1+1)*(mm1+1)) = %d ", *avt1->shape, ((mm1+1)*(mm1+1)) );
    div = na_cast_object(div, NA_DFLOAT);
    GetNArray(div,div1);
    if ( *div1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: div : %d != ((mm1+1)*(mm1+1)) = %d ", *div1->shape, ((mm1+1)*(mm1+1)) );
    phi = na_cast_object(phi, NA_DFLOAT);
    GetNArray(phi,phi1);
    if ( *phi1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: phi : %d != ((mm1+1)*(mm1+1)) = %d ", *phi1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    davt = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(davt,davt1);
    shape[0] = ((mm1+1)*(mm1+1));
    ddiv = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(ddiv,ddiv1);
    shape[0] = ((mm1+1)*(mm1+1));
    dphi = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(dphi,dphi1);
    rn = na_cast_object(rn, NA_DFLOAT);
    GetNArray(rn,rn1);
    if ( *rn1->shape != ((mm1+1)*(mm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: rn : %d != ((mm1+1)*(mm1+1)*2) = %d ", *rn1->shape, ((mm1+1)*(mm1+1)*2) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (jm1*2) = %d ", *y1->shape, (jm1*2) );
    ip4 = na_cast_object(ip4, NA_LINT);
    GetNArray(ip4,ip41);
    if ( *ip41->shape != (4*(mm1+1)/2+mm1+1)*2 ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip41->shape );
    p4 = na_cast_object(p4, NA_DFLOAT);
    GetNArray(p4,p41);
    if ( *p41->shape != (4*((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: p4 : %d != (4*((mm1+1)/2+mm1+1)*jm1) = %d ", *p41->shape, (4*((mm1+1)/2+mm1+1)*jm1) );
    r4 = na_cast_object(r4, NA_DFLOAT);
    GetNArray(r4,r41);
    if ( *r41->shape != (4*((mm1+1)/2*2+3)*(mm1/2+1)) ) rb_raise(rb_eArgError, "invalid ary size: r4 : %d != (4*((mm1+1)/2*2+3)*(mm1/2+1)) = %d ", *r41->shape, (4*((mm1+1)/2*2+3)*(mm1/2+1)) );
    ip5 = na_cast_object(ip5, NA_LINT);
    GetNArray(ip5,ip51);
    if ( *ip51->shape != (5*(mm1+1)/2+mm1+1)*2 ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip51->shape );
    p5 = na_cast_object(p5, NA_DFLOAT);
    GetNArray(p5,p51);
    if ( *p51->shape != (5*((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: p5 : %d != (5*((mm1+1)/2+mm1+1)*jm1) = %d ", *p51->shape, (5*((mm1+1)/2+mm1+1)*jm1) );
    r5 = na_cast_object(r5, NA_DFLOAT);
    GetNArray(r5,r51);
    if ( *r51->shape != (5*((mm1+1)/2*2+3)*(mm1/2+1)) ) rb_raise(rb_eArgError, "invalid ary size: r5 : %d != (5*((mm1+1)/2*2+3)*(mm1/2+1)) = %d ", *r51->shape, (5*((mm1+1)/2*2+3)*(mm1/2+1)) );
    ia = na_cast_object(ia, NA_LINT);
    GetNArray(ia,ia1);
    if ( *ia1->shape != ((mm1+1)*(mm1+1)*4) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ia1->shape );
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)*6) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)*6) = %d ", *a1->shape, ((mm1+1)*(mm1+1)*6) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != ((5*(mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != ((5*(mm1+1)/2+mm1+1)*jm1) = %d ", *q1->shape, ((5*(mm1+1)/2+mm1+1)*jm1) );
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape < 5*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d < 5*(jd1*im1) = %d ", *ws1->shape, 5*(jd1*im1) );
    ww = na_cast_object(ww, NA_DFLOAT);
    GetNArray(ww,ww1);
    if ( *ww1->shape < 5*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ww : %d < 5*(jd1*im1) = %d ", *ww1->shape, 5*(jd1*im1) );

    spswnl_(&mm1,&im1,&id1,&jm1,&jd1,&omega1,avt1->ptr,div1->ptr,phi1->ptr,davt1->ptr,ddiv1->ptr,dphi1->ptr,rn1->ptr,it1->ptr,t1->ptr,y1->ptr,ip41->ptr,p41->ptr,r41->ptr,ip51->ptr,p51->ptr,r51->ptr,ia1->ptr,a1->ptr,q1->ptr,ws1->ptr,ww1->ptr);



    return rb_ary_new3(3, davt, ddiv, dphi);
}

static VALUE
spswck(self,mm,im,id,jm,jd,omega,avt,div,phi,rn,it,t,y,ip4,p4,r4,ia,a,q,ws,ww)
    VALUE self,mm,im,id,jm,jd,omega,avt,div,phi,rn,it,t,y,ip4,p4,r4,ia,a,q,ws,ww;
{
    int mm1;
    int im1;
    int id1;
    int jm1;
    int jd1;
    double omega1;
    struct NARRAY *avt1;
    struct NARRAY *div1;
    struct NARRAY *phi1;
    double amom1;
    VALUE amom;
    double aene1;
    VALUE aene;
    double aens1;
    VALUE aens;
    struct NARRAY *rn1;
    struct NARRAY *it1;
    struct NARRAY *t1;
    struct NARRAY *y1;
    struct NARRAY *ip41;
    struct NARRAY *p41;
    struct NARRAY *r41;
    struct NARRAY *ia1;
    struct NARRAY *a1;
    struct NARRAY *q1;
    struct NARRAY *ws1;
    struct NARRAY *ww1;



    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    id1 = NUM2INT(id);
    jm1 = NUM2INT(jm);
    jd1 = NUM2INT(jd);
    omega1 = NUM2DBL(omega);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((mm1+1)*(mm1+1)) = %d ", *avt1->shape, ((mm1+1)*(mm1+1)) );
    div = na_cast_object(div, NA_DFLOAT);
    GetNArray(div,div1);
    if ( *div1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: div : %d != ((mm1+1)*(mm1+1)) = %d ", *div1->shape, ((mm1+1)*(mm1+1)) );
    phi = na_cast_object(phi, NA_DFLOAT);
    GetNArray(phi,phi1);
    if ( *phi1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: phi : %d != ((mm1+1)*(mm1+1)) = %d ", *phi1->shape, ((mm1+1)*(mm1+1)) );
    rn = na_cast_object(rn, NA_DFLOAT);
    GetNArray(rn,rn1);
    if ( *rn1->shape != ((mm1+1)*(mm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: rn : %d != ((mm1+1)*(mm1+1)*2) = %d ", *rn1->shape, ((mm1+1)*(mm1+1)*2) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (jm1*2) = %d ", *y1->shape, (jm1*2) );
    ip4 = na_cast_object(ip4, NA_LINT);
    GetNArray(ip4,ip41);
    if ( *ip41->shape != (4*(mm1+1)/2+mm1+1)*2 ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip41->shape );
    p4 = na_cast_object(p4, NA_DFLOAT);
    GetNArray(p4,p41);
    if ( *p41->shape != (4*((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: p4 : %d != (4*((mm1+1)/2+mm1+1)*jm1) = %d ", *p41->shape, (4*((mm1+1)/2+mm1+1)*jm1) );
    r4 = na_cast_object(r4, NA_DFLOAT);
    GetNArray(r4,r41);
    if ( *r41->shape != (4*((mm1+1)/2*2+3)*(mm1/2+1)) ) rb_raise(rb_eArgError, "invalid ary size: r4 : %d != (4*((mm1+1)/2*2+3)*(mm1/2+1)) = %d ", *r41->shape, (4*((mm1+1)/2*2+3)*(mm1/2+1)) );
    ia = na_cast_object(ia, NA_LINT);
    GetNArray(ia,ia1);
    if ( *ia1->shape != ((mm1+1)*(mm1+1)*4) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ia1->shape );
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)*6) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)*6) = %d ", *a1->shape, ((mm1+1)*(mm1+1)*6) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != ((4*(mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != ((4*(mm1+1)/2+mm1+1)*jm1) = %d ", *q1->shape, ((4*(mm1+1)/2+mm1+1)*jm1) );
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape < 4*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d < 4*(jd1*im1) = %d ", *ws1->shape, 4*(jd1*im1) );
    ww = na_cast_object(ww, NA_DFLOAT);
    GetNArray(ww,ww1);
    if ( *ww1->shape < 4*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ww : %d < 4*(jd1*im1) = %d ", *ww1->shape, 4*(jd1*im1) );

    spswck_(&mm1,&im1,&id1,&jm1,&jd1,&omega1,avt1->ptr,div1->ptr,phi1->ptr,&amom1,&aene1,&aens1,rn1->ptr,it1->ptr,t1->ptr,y1->ptr,ip41->ptr,p41->ptr,r41->ptr,ia1->ptr,a1->ptr,q1->ptr,ws1->ptr,ww1->ptr);


    amom = rb_float_new(amom1);
    aene = rb_float_new(aene1);
    aens = rb_float_new(aens1);

    return rb_ary_new3(3, amom, aene, aens);
}

static VALUE
spswnv(self,mm,im,id,jm,jd,omega,barphi,dnu,alpha,avt,div,phi,rn,irm,it,t,y,ip,p,r,ia,a,q,ws,ww)
    VALUE self,mm,im,id,jm,jd,omega,barphi,dnu,alpha,avt,div,phi,rn,irm,it,t,y,ip,p,r,ia,a,q,ws,ww;
{
    int mm1;
    int im1;
    int id1;
    int jm1;
    int jd1;
    double omega1;
    double barphi1;
    double dnu1;
    double alpha1;
    struct NARRAY *avt1;
    struct NARRAY *div1;
    struct NARRAY *phi1;
    struct NARRAY *davt1;
    VALUE davt;
    struct NARRAY *ddiv1;
    VALUE ddiv;
    struct NARRAY *dphi1;
    VALUE dphi;
    struct NARRAY *rn1;
    struct NARRAY *irm1;
    struct NARRAY *it1;
    struct NARRAY *t1;
    struct NARRAY *y1;
    struct NARRAY *ip1;
    struct NARRAY *p1;
    struct NARRAY *r1;
    struct NARRAY *ia1;
    struct NARRAY *a1;
    struct NARRAY *q1;
    struct NARRAY *ws1;
    struct NARRAY *ww1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    id1 = NUM2INT(id);
    jm1 = NUM2INT(jm);
    jd1 = NUM2INT(jd);
    omega1 = NUM2DBL(omega);
    barphi1 = NUM2DBL(barphi);
    dnu1 = NUM2DBL(dnu);
    alpha1 = NUM2DBL(alpha);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((mm1+1)*(mm1+1)) = %d ", *avt1->shape, ((mm1+1)*(mm1+1)) );
    div = na_cast_object(div, NA_DFLOAT);
    GetNArray(div,div1);
    if ( *div1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: div : %d != ((mm1+1)*(mm1+1)) = %d ", *div1->shape, ((mm1+1)*(mm1+1)) );
    phi = na_cast_object(phi, NA_DFLOAT);
    GetNArray(phi,phi1);
    if ( *phi1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: phi : %d != ((mm1+1)*(mm1+1)) = %d ", *phi1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    davt = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(davt,davt1);
    shape[0] = ((mm1+1)*(mm1+1));
    ddiv = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(ddiv,ddiv1);
    shape[0] = ((mm1+1)*(mm1+1));
    dphi = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(dphi,dphi1);
    rn = na_cast_object(rn, NA_DFLOAT);
    GetNArray(rn,rn1);
    if ( *rn1->shape != ((mm1+1)*(mm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: rn : %d != ((mm1+1)*(mm1+1)*2) = %d ", *rn1->shape, ((mm1+1)*(mm1+1)*2) );
    irm = na_cast_object(irm, NA_LINT);
    GetNArray(irm,irm1);
    if ( *irm1->shape != ((mm1+1)*(mm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *irm1->shape );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (jm1*2) = %d ", *y1->shape, (jm1*2) );
    ip = na_cast_object(ip, NA_LINT);
    GetNArray(ip,ip1);
    if ( *ip1->shape != ((mm1+1)/2+mm1+1)*2 ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip1->shape );
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (((mm1+1)/2+mm1+1)*jm1) = %d ", *p1->shape, (((mm1+1)/2+mm1+1)*jm1) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != (((mm1+1)/2*2+3)*(mm1/2+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != (((mm1+1)/2*2+3)*(mm1/2+1)) = %d ", *r1->shape, (((mm1+1)/2*2+3)*(mm1/2+1)) );
    ia = na_cast_object(ia, NA_LINT);
    GetNArray(ia,ia1);
    if ( *ia1->shape != ((mm1+1)*(mm1+1)*4) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ia1->shape );
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)*6) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)*6) = %d ", *a1->shape, ((mm1+1)*(mm1+1)*6) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (((mm1+1)/2+mm1+1)*jm1) = %d ", *q1->shape, (((mm1+1)/2+mm1+1)*jm1) );
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape < 8*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d < 8*(jd1*im1) = %d ", *ws1->shape, 8*(jd1*im1) );
    ww = na_cast_object(ww, NA_DFLOAT);
    GetNArray(ww,ww1);
    if ( *ww1->shape < (jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ww : %d < (jd1*im1) = %d ", *ww1->shape, (jd1*im1) );

    spswnv_(&mm1,&im1,&id1,&jm1,&jd1,&omega1,&barphi1,&dnu1,&alpha1,avt1->ptr,div1->ptr,phi1->ptr,davt1->ptr,ddiv1->ptr,dphi1->ptr,rn1->ptr,irm1->ptr,it1->ptr,t1->ptr,y1->ptr,ip1->ptr,p1->ptr,r1->ptr,ia1->ptr,a1->ptr,q1->ptr,ws1->ptr,ww1->ptr);



    return rb_ary_new3(3, davt, ddiv, dphi);
}

static VALUE
spswli(self,mm,barphi,dnu,alpha,dt)
    VALUE self,mm,barphi,dnu,alpha,dt;
{
    int mm1;
    double barphi1;
    double dnu1;
    double alpha1;
    double dt1;
    struct NARRAY *cl1;
    VALUE cl;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    barphi1 = NUM2DBL(barphi);
    dnu1 = NUM2DBL(dnu);
    alpha1 = NUM2DBL(alpha);
    dt1 = NUM2DBL(dt);
    shape[0] = ((mm1+1)*(mm1+1)*5);
    cl = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(cl,cl1);

    spswli_(&mm1,&barphi1,&dnu1,&alpha1,&dt1,cl1->ptr);



    return cl;
}

static VALUE
spswlv(self,mm,avt,div,phi,cl)
    VALUE self,mm,avt,div,phi,cl;
{
    int mm1;
    struct NARRAY *avt1;
    struct NARRAY *div1;
    struct NARRAY *phi1;
    struct NARRAY *cl1;



    mm1 = NUM2INT(mm);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((mm1+1)*(mm1+1)) = %d ", *avt1->shape, ((mm1+1)*(mm1+1)) );
    div = na_cast_object(div, NA_DFLOAT);
    GetNArray(div,div1);
    if ( *div1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: div : %d != ((mm1+1)*(mm1+1)) = %d ", *div1->shape, ((mm1+1)*(mm1+1)) );
    phi = na_cast_object(phi, NA_DFLOAT);
    GetNArray(phi,phi1);
    if ( *phi1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: phi : %d != ((mm1+1)*(mm1+1)) = %d ", *phi1->shape, ((mm1+1)*(mm1+1)) );
    cl = na_cast_object(cl, NA_DFLOAT);
    GetNArray(cl,cl1);
    if ( *cl1->shape != ((mm1+1)*(mm1+1)*5) ) rb_raise(rb_eArgError, "invalid ary size: cl : %d != ((mm1+1)*(mm1+1)*5) = %d ", *cl1->shape, ((mm1+1)*(mm1+1)*5) );

    spswlv_(&mm1,avt1->ptr,div1->ptr,phi1->ptr,cl1->ptr);



    return 0;
}

static VALUE
spswcv(self,mm,im,id,jm,jd,omega,avt,div,phi,rn,it,t,y,ip,p,r,ia,a,q,ws,ww)
    VALUE self,mm,im,id,jm,jd,omega,avt,div,phi,rn,it,t,y,ip,p,r,ia,a,q,ws,ww;
{
    int mm1;
    int im1;
    int id1;
    int jm1;
    int jd1;
    double omega1;
    struct NARRAY *avt1;
    struct NARRAY *div1;
    struct NARRAY *phi1;
    double amom1;
    VALUE amom;
    double aene1;
    VALUE aene;
    double aens1;
    VALUE aens;
    struct NARRAY *rn1;
    struct NARRAY *it1;
    struct NARRAY *t1;
    struct NARRAY *y1;
    struct NARRAY *ip1;
    struct NARRAY *p1;
    struct NARRAY *r1;
    struct NARRAY *ia1;
    struct NARRAY *a1;
    struct NARRAY *q1;
    struct NARRAY *ws1;
    struct NARRAY *ww1;



    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    id1 = NUM2INT(id);
    jm1 = NUM2INT(jm);
    jd1 = NUM2INT(jd);
    omega1 = NUM2DBL(omega);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((mm1+1)*(mm1+1)) = %d ", *avt1->shape, ((mm1+1)*(mm1+1)) );
    div = na_cast_object(div, NA_DFLOAT);
    GetNArray(div,div1);
    if ( *div1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: div : %d != ((mm1+1)*(mm1+1)) = %d ", *div1->shape, ((mm1+1)*(mm1+1)) );
    phi = na_cast_object(phi, NA_DFLOAT);
    GetNArray(phi,phi1);
    if ( *phi1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: phi : %d != ((mm1+1)*(mm1+1)) = %d ", *phi1->shape, ((mm1+1)*(mm1+1)) );
    rn = na_cast_object(rn, NA_DFLOAT);
    GetNArray(rn,rn1);
    if ( *rn1->shape != ((mm1+1)*(mm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: rn : %d != ((mm1+1)*(mm1+1)*2) = %d ", *rn1->shape, ((mm1+1)*(mm1+1)*2) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (jm1*2) = %d ", *y1->shape, (jm1*2) );
    ip = na_cast_object(ip, NA_LINT);
    GetNArray(ip,ip1);
    if ( *ip1->shape != ((mm1+1)/2+mm1+1)*2 ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip1->shape );
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (((mm1+1)/2+mm1+1)*jm1) = %d ", *p1->shape, (((mm1+1)/2+mm1+1)*jm1) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != (((mm1+1)/2*2+3)*(mm1/2+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != (((mm1+1)/2*2+3)*(mm1/2+1)) = %d ", *r1->shape, (((mm1+1)/2*2+3)*(mm1/2+1)) );
    ia = na_cast_object(ia, NA_LINT);
    GetNArray(ia,ia1);
    if ( *ia1->shape != ((mm1+1)*(mm1+1)*4) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ia1->shape );
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)*6) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)*6) = %d ", *a1->shape, ((mm1+1)*(mm1+1)*6) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != ((4*(mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != ((4*(mm1+1)/2+mm1+1)*jm1) = %d ", *q1->shape, ((4*(mm1+1)/2+mm1+1)*jm1) );
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape < 4*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d < 4*(jd1*im1) = %d ", *ws1->shape, 4*(jd1*im1) );
    ww = na_cast_object(ww, NA_DFLOAT);
    GetNArray(ww,ww1);
    if ( *ww1->shape < (jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ww : %d < (jd1*im1) = %d ", *ww1->shape, (jd1*im1) );

    spswcv_(&mm1,&im1,&id1,&jm1,&jd1,&omega1,avt1->ptr,div1->ptr,phi1->ptr,&amom1,&aene1,&aens1,rn1->ptr,it1->ptr,t1->ptr,y1->ptr,ip1->ptr,p1->ptr,r1->ptr,ia1->ptr,a1->ptr,q1->ptr,ws1->ptr,ww1->ptr);


    amom = rb_float_new(amom1);
    aene = rb_float_new(aene1);
    aens = rb_float_new(aens1);

    return rb_ary_new3(3, amom, aene, aens);
}

static VALUE
spswcx(self,mm,im,id,jm,jd,omega,avt,div,phi,rn,it,t,y,ip,p,r,ia,a,q,ws,ww)
    VALUE self,mm,im,id,jm,jd,omega,avt,div,phi,rn,it,t,y,ip,p,r,ia,a,q,ws,ww;
{
    int mm1;
    int im1;
    int id1;
    int jm1;
    int jd1;
    double omega1;
    struct NARRAY *avt1;
    struct NARRAY *div1;
    struct NARRAY *phi1;
    double amom11;
    VALUE amom1;
    double amom21;
    VALUE amom2;
    double amom31;
    VALUE amom3;
    double aene1;
    VALUE aene;
    double aens1;
    VALUE aens;
    struct NARRAY *rn1;
    struct NARRAY *it1;
    struct NARRAY *t1;
    struct NARRAY *y1;
    struct NARRAY *ip1;
    struct NARRAY *p1;
    struct NARRAY *r1;
    struct NARRAY *ia1;
    struct NARRAY *a1;
    struct NARRAY *q1;
    struct NARRAY *ws1;
    struct NARRAY *ww1;



    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    id1 = NUM2INT(id);
    jm1 = NUM2INT(jm);
    jd1 = NUM2INT(jd);
    omega1 = NUM2DBL(omega);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((mm1+1)*(mm1+1)) = %d ", *avt1->shape, ((mm1+1)*(mm1+1)) );
    div = na_cast_object(div, NA_DFLOAT);
    GetNArray(div,div1);
    if ( *div1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: div : %d != ((mm1+1)*(mm1+1)) = %d ", *div1->shape, ((mm1+1)*(mm1+1)) );
    phi = na_cast_object(phi, NA_DFLOAT);
    GetNArray(phi,phi1);
    if ( *phi1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: phi : %d != ((mm1+1)*(mm1+1)) = %d ", *phi1->shape, ((mm1+1)*(mm1+1)) );
    rn = na_cast_object(rn, NA_DFLOAT);
    GetNArray(rn,rn1);
    if ( *rn1->shape != ((mm1+1)*(mm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: rn : %d != ((mm1+1)*(mm1+1)*2) = %d ", *rn1->shape, ((mm1+1)*(mm1+1)*2) );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (jm1*2) = %d ", *y1->shape, (jm1*2) );
    ip = na_cast_object(ip, NA_LINT);
    GetNArray(ip,ip1);
    if ( *ip1->shape != ((mm1+1)/2+mm1+1)*2 ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip1->shape );
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (((mm1+1)/2+mm1+1)*jm1) = %d ", *p1->shape, (((mm1+1)/2+mm1+1)*jm1) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != (((mm1+1)/2*2+3)*(mm1/2+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != (((mm1+1)/2*2+3)*(mm1/2+1)) = %d ", *r1->shape, (((mm1+1)/2*2+3)*(mm1/2+1)) );
    ia = na_cast_object(ia, NA_LINT);
    GetNArray(ia,ia1);
    if ( *ia1->shape != ((mm1+1)*(mm1+1)*4) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ia1->shape );
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)*6) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)*6) = %d ", *a1->shape, ((mm1+1)*(mm1+1)*6) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != ((4*(mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != ((4*(mm1+1)/2+mm1+1)*jm1) = %d ", *q1->shape, ((4*(mm1+1)/2+mm1+1)*jm1) );
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape < 4*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d < 4*(jd1*im1) = %d ", *ws1->shape, 4*(jd1*im1) );
    ww = na_cast_object(ww, NA_DFLOAT);
    GetNArray(ww,ww1);
    if ( *ww1->shape < (jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ww : %d < (jd1*im1) = %d ", *ww1->shape, (jd1*im1) );

    spswcx_(&mm1,&im1,&id1,&jm1,&jd1,&omega1,avt1->ptr,div1->ptr,phi1->ptr,&amom11,&amom21,&amom31,&aene1,&aens1,rn1->ptr,it1->ptr,t1->ptr,y1->ptr,ip1->ptr,p1->ptr,r1->ptr,ia1->ptr,a1->ptr,q1->ptr,ws1->ptr,ww1->ptr);


    amom1 = rb_float_new(amom11);
    amom2 = rb_float_new(amom21);
    amom3 = rb_float_new(amom31);
    aene = rb_float_new(aene1);
    aens = rb_float_new(aens1);

    return rb_ary_new3(5, amom1, amom2, amom3, aene, aens);
}

static VALUE
spswnw(self,mm,im,id,jm,jd,omega,barphi,dnu,alpha,avt,div,phi,rn,irm,it,t,y,ip,p,r,ia,a,q,ws,ww)
    VALUE self,mm,im,id,jm,jd,omega,barphi,dnu,alpha,avt,div,phi,rn,irm,it,t,y,ip,p,r,ia,a,q,ws,ww;
{
    int mm1;
    int im1;
    int id1;
    int jm1;
    int jd1;
    double omega1;
    double barphi1;
    double dnu1;
    double alpha1;
    struct NARRAY *avt1;
    struct NARRAY *div1;
    struct NARRAY *phi1;
    struct NARRAY *davt1;
    VALUE davt;
    struct NARRAY *ddiv1;
    VALUE ddiv;
    struct NARRAY *dphi1;
    VALUE dphi;
    struct NARRAY *rn1;
    struct NARRAY *irm1;
    struct NARRAY *it1;
    struct NARRAY *t1;
    struct NARRAY *y1;
    struct NARRAY *ip1;
    struct NARRAY *p1;
    struct NARRAY *r1;
    struct NARRAY *ia1;
    struct NARRAY *a1;
    struct NARRAY *q1;
    struct NARRAY *ws1;
    struct NARRAY *ww1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    id1 = NUM2INT(id);
    jm1 = NUM2INT(jm);
    jd1 = NUM2INT(jd);
    omega1 = NUM2DBL(omega);
    barphi1 = NUM2DBL(barphi);
    dnu1 = NUM2DBL(dnu);
    alpha1 = NUM2DBL(alpha);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((mm1+1)*(mm1+1)) = %d ", *avt1->shape, ((mm1+1)*(mm1+1)) );
    div = na_cast_object(div, NA_DFLOAT);
    GetNArray(div,div1);
    if ( *div1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: div : %d != ((mm1+1)*(mm1+1)) = %d ", *div1->shape, ((mm1+1)*(mm1+1)) );
    phi = na_cast_object(phi, NA_DFLOAT);
    GetNArray(phi,phi1);
    if ( *phi1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: phi : %d != ((mm1+1)*(mm1+1)) = %d ", *phi1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    davt = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(davt,davt1);
    shape[0] = ((mm1+1)*(mm1+1));
    ddiv = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(ddiv,ddiv1);
    shape[0] = ((mm1+1)*(mm1+1));
    dphi = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(dphi,dphi1);
    rn = na_cast_object(rn, NA_DFLOAT);
    GetNArray(rn,rn1);
    if ( *rn1->shape != ((mm1+1)*(mm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: rn : %d != ((mm1+1)*(mm1+1)*2) = %d ", *rn1->shape, ((mm1+1)*(mm1+1)*2) );
    irm = na_cast_object(irm, NA_LINT);
    GetNArray(irm,irm1);
    if ( *irm1->shape != ((mm1+1)*(mm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *irm1->shape );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (jm1*2) = %d ", *y1->shape, (jm1*2) );
    ip = na_cast_object(ip, NA_LINT);
    GetNArray(ip,ip1);
    if ( *ip1->shape != ((mm1+1)/2+mm1+1)*2 ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip1->shape );
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (((mm1+1)/2+mm1+1)*jm1) = %d ", *p1->shape, (((mm1+1)/2+mm1+1)*jm1) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != (((mm1+1)/2*2+3)*(mm1/2+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != (((mm1+1)/2*2+3)*(mm1/2+1)) = %d ", *r1->shape, (((mm1+1)/2*2+3)*(mm1/2+1)) );
    ia = na_cast_object(ia, NA_LINT);
    GetNArray(ia,ia1);
    if ( *ia1->shape != ((mm1+1)*(mm1+1)*4) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ia1->shape );
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)*6) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)*6) = %d ", *a1->shape, ((mm1+1)*(mm1+1)*6) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (((mm1+1)/2+mm1+1)*jm1) = %d ", *q1->shape, (((mm1+1)/2+mm1+1)*jm1) );
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape < 8*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d < 8*(jd1*im1) = %d ", *ws1->shape, 8*(jd1*im1) );
    ww = na_cast_object(ww, NA_DFLOAT);
    GetNArray(ww,ww1);
    if ( *ww1->shape < 8*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ww : %d < 8*(jd1*im1) = %d ", *ww1->shape, 8*(jd1*im1) );

    spswnw_(&mm1,&im1,&id1,&jm1,&jd1,&omega1,&barphi1,&dnu1,&alpha1,avt1->ptr,div1->ptr,phi1->ptr,davt1->ptr,ddiv1->ptr,dphi1->ptr,rn1->ptr,irm1->ptr,it1->ptr,t1->ptr,y1->ptr,ip1->ptr,p1->ptr,r1->ptr,ia1->ptr,a1->ptr,q1->ptr,ws1->ptr,ww1->ptr);



    return rb_ary_new3(3, davt, ddiv, dphi);
}

static VALUE
spswnx(self,mm,im,id,jm,jd,omega,barphi,dnu,alpha,avt,div,phi,rn,irm,it,t,y,ip,p,r,ia,a,q,ws,ww)
    VALUE self,mm,im,id,jm,jd,omega,barphi,dnu,alpha,avt,div,phi,rn,irm,it,t,y,ip,p,r,ia,a,q,ws,ww;
{
    int mm1;
    int im1;
    int id1;
    int jm1;
    int jd1;
    double omega1;
    double barphi1;
    double dnu1;
    double alpha1;
    struct NARRAY *avt1;
    struct NARRAY *div1;
    struct NARRAY *phi1;
    struct NARRAY *davt1;
    VALUE davt;
    struct NARRAY *ddiv1;
    VALUE ddiv;
    struct NARRAY *dphi1;
    VALUE dphi;
    struct NARRAY *rn1;
    struct NARRAY *irm1;
    struct NARRAY *it1;
    struct NARRAY *t1;
    struct NARRAY *y1;
    struct NARRAY *ip1;
    struct NARRAY *p1;
    struct NARRAY *r1;
    struct NARRAY *ia1;
    struct NARRAY *a1;
    struct NARRAY *q1;
    struct NARRAY *ws1;
    struct NARRAY *ww1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    id1 = NUM2INT(id);
    jm1 = NUM2INT(jm);
    jd1 = NUM2INT(jd);
    omega1 = NUM2DBL(omega);
    barphi1 = NUM2DBL(barphi);
    dnu1 = NUM2DBL(dnu);
    alpha1 = NUM2DBL(alpha);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((mm1+1)*(mm1+1)) = %d ", *avt1->shape, ((mm1+1)*(mm1+1)) );
    div = na_cast_object(div, NA_DFLOAT);
    GetNArray(div,div1);
    if ( *div1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: div : %d != ((mm1+1)*(mm1+1)) = %d ", *div1->shape, ((mm1+1)*(mm1+1)) );
    phi = na_cast_object(phi, NA_DFLOAT);
    GetNArray(phi,phi1);
    if ( *phi1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: phi : %d != ((mm1+1)*(mm1+1)) = %d ", *phi1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    davt = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(davt,davt1);
    shape[0] = ((mm1+1)*(mm1+1));
    ddiv = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(ddiv,ddiv1);
    shape[0] = ((mm1+1)*(mm1+1));
    dphi = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(dphi,dphi1);
    rn = na_cast_object(rn, NA_DFLOAT);
    GetNArray(rn,rn1);
    if ( *rn1->shape != ((mm1+1)*(mm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: rn : %d != ((mm1+1)*(mm1+1)*2) = %d ", *rn1->shape, ((mm1+1)*(mm1+1)*2) );
    irm = na_cast_object(irm, NA_LINT);
    GetNArray(irm,irm1);
    if ( *irm1->shape != ((mm1+1)*(mm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *irm1->shape );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (jm1*2) = %d ", *y1->shape, (jm1*2) );
    ip = na_cast_object(ip, NA_LINT);
    GetNArray(ip,ip1);
    if ( *ip1->shape != ((mm1+1)/2+mm1+1)*2 ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip1->shape );
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (((mm1+1)/2+mm1+1)*jm1) = %d ", *p1->shape, (((mm1+1)/2+mm1+1)*jm1) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != (((mm1+1)/2*2+3)*(mm1/2+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != (((mm1+1)/2*2+3)*(mm1/2+1)) = %d ", *r1->shape, (((mm1+1)/2*2+3)*(mm1/2+1)) );
    ia = na_cast_object(ia, NA_LINT);
    GetNArray(ia,ia1);
    if ( *ia1->shape != ((mm1+1)*(mm1+1)*4) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ia1->shape );
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)*6) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)*6) = %d ", *a1->shape, ((mm1+1)*(mm1+1)*6) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (((mm1+1)/2+mm1+1)*jm1) = %d ", *q1->shape, (((mm1+1)/2+mm1+1)*jm1) );
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape < 7*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d < 7*(jd1*im1) = %d ", *ws1->shape, 7*(jd1*im1) );
    ww = na_cast_object(ww, NA_DFLOAT);
    GetNArray(ww,ww1);
    if ( *ww1->shape < 7*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ww : %d < 7*(jd1*im1) = %d ", *ww1->shape, 7*(jd1*im1) );

    spswnx_(&mm1,&im1,&id1,&jm1,&jd1,&omega1,&barphi1,&dnu1,&alpha1,avt1->ptr,div1->ptr,phi1->ptr,davt1->ptr,ddiv1->ptr,dphi1->ptr,rn1->ptr,irm1->ptr,it1->ptr,t1->ptr,y1->ptr,ip1->ptr,p1->ptr,r1->ptr,ia1->ptr,a1->ptr,q1->ptr,ws1->ptr,ww1->ptr);



    return rb_ary_new3(3, davt, ddiv, dphi);
}

static VALUE
spswhv(self,mm,im,id,jm,jd,omega,barphi,dnu,alpha,lev,avt,div,phi,rn,irm,it,t,y,ip,p,r,ia,a,q,ws,ww)
    VALUE self,mm,im,id,jm,jd,omega,barphi,dnu,alpha,lev,avt,div,phi,rn,irm,it,t,y,ip,p,r,ia,a,q,ws,ww;
{
    int mm1;
    int im1;
    int id1;
    int jm1;
    int jd1;
    double omega1;
    double barphi1;
    double dnu1;
    double alpha1;
    int lev1;
    struct NARRAY *avt1;
    struct NARRAY *div1;
    struct NARRAY *phi1;
    struct NARRAY *davt1;
    VALUE davt;
    struct NARRAY *ddiv1;
    VALUE ddiv;
    struct NARRAY *dphi1;
    VALUE dphi;
    struct NARRAY *rn1;
    struct NARRAY *irm1;
    struct NARRAY *it1;
    struct NARRAY *t1;
    struct NARRAY *y1;
    struct NARRAY *ip1;
    struct NARRAY *p1;
    struct NARRAY *r1;
    struct NARRAY *ia1;
    struct NARRAY *a1;
    struct NARRAY *q1;
    struct NARRAY *ws1;
    struct NARRAY *ww1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    id1 = NUM2INT(id);
    jm1 = NUM2INT(jm);
    jd1 = NUM2INT(jd);
    omega1 = NUM2DBL(omega);
    barphi1 = NUM2DBL(barphi);
    dnu1 = NUM2DBL(dnu);
    alpha1 = NUM2DBL(alpha);
    lev1 = NUM2INT(lev);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((mm1+1)*(mm1+1)) = %d ", *avt1->shape, ((mm1+1)*(mm1+1)) );
    div = na_cast_object(div, NA_DFLOAT);
    GetNArray(div,div1);
    if ( *div1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: div : %d != ((mm1+1)*(mm1+1)) = %d ", *div1->shape, ((mm1+1)*(mm1+1)) );
    phi = na_cast_object(phi, NA_DFLOAT);
    GetNArray(phi,phi1);
    if ( *phi1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: phi : %d != ((mm1+1)*(mm1+1)) = %d ", *phi1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    davt = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(davt,davt1);
    shape[0] = ((mm1+1)*(mm1+1));
    ddiv = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(ddiv,ddiv1);
    shape[0] = ((mm1+1)*(mm1+1));
    dphi = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(dphi,dphi1);
    rn = na_cast_object(rn, NA_DFLOAT);
    GetNArray(rn,rn1);
    if ( *rn1->shape != ((mm1+1)*(mm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: rn : %d != ((mm1+1)*(mm1+1)*2) = %d ", *rn1->shape, ((mm1+1)*(mm1+1)*2) );
    irm = na_cast_object(irm, NA_LINT);
    GetNArray(irm,irm1);
    if ( *irm1->shape != ((mm1+1)*(mm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *irm1->shape );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (jm1*2) = %d ", *y1->shape, (jm1*2) );
    ip = na_cast_object(ip, NA_LINT);
    GetNArray(ip,ip1);
    if ( *ip1->shape != ((mm1+1)/2+mm1+1)*2 ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip1->shape );
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (((mm1+1)/2+mm1+1)*jm1) = %d ", *p1->shape, (((mm1+1)/2+mm1+1)*jm1) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != (((mm1+1)/2*2+3)*(mm1/2+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != (((mm1+1)/2*2+3)*(mm1/2+1)) = %d ", *r1->shape, (((mm1+1)/2*2+3)*(mm1/2+1)) );
    ia = na_cast_object(ia, NA_LINT);
    GetNArray(ia,ia1);
    if ( *ia1->shape != ((mm1+1)*(mm1+1)*4) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ia1->shape );
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)*6) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)*6) = %d ", *a1->shape, ((mm1+1)*(mm1+1)*6) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (((mm1+1)/2+mm1+1)*jm1) = %d ", *q1->shape, (((mm1+1)/2+mm1+1)*jm1) );
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape < 11*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d < 11*(jd1*im1) = %d ", *ws1->shape, 11*(jd1*im1) );
    ww = na_cast_object(ww, NA_DFLOAT);
    GetNArray(ww,ww1);
    if ( *ww1->shape < (jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ww : %d < (jd1*im1) = %d ", *ww1->shape, (jd1*im1) );

    spswhv_(&mm1,&im1,&id1,&jm1,&jd1,&omega1,&barphi1,&dnu1,&alpha1,&lev1,avt1->ptr,div1->ptr,phi1->ptr,davt1->ptr,ddiv1->ptr,dphi1->ptr,rn1->ptr,irm1->ptr,it1->ptr,t1->ptr,y1->ptr,ip1->ptr,p1->ptr,r1->ptr,ia1->ptr,a1->ptr,q1->ptr,ws1->ptr,ww1->ptr);



    return rb_ary_new3(3, davt, ddiv, dphi);
}

static VALUE
spswhw(self,mm,im,id,jm,jd,omega,barphi,dnu,alpha,lev,avt,div,phi,rn,irm,it,t,y,ip,p,r,ia,a,q,ws,ww)
    VALUE self,mm,im,id,jm,jd,omega,barphi,dnu,alpha,lev,avt,div,phi,rn,irm,it,t,y,ip,p,r,ia,a,q,ws,ww;
{
    int mm1;
    int im1;
    int id1;
    int jm1;
    int jd1;
    double omega1;
    double barphi1;
    double dnu1;
    double alpha1;
    int lev1;
    struct NARRAY *avt1;
    struct NARRAY *div1;
    struct NARRAY *phi1;
    struct NARRAY *davt1;
    VALUE davt;
    struct NARRAY *ddiv1;
    VALUE ddiv;
    struct NARRAY *dphi1;
    VALUE dphi;
    struct NARRAY *rn1;
    struct NARRAY *irm1;
    struct NARRAY *it1;
    struct NARRAY *t1;
    struct NARRAY *y1;
    struct NARRAY *ip1;
    struct NARRAY *p1;
    struct NARRAY *r1;
    struct NARRAY *ia1;
    struct NARRAY *a1;
    struct NARRAY *q1;
    struct NARRAY *ws1;
    struct NARRAY *ww1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    id1 = NUM2INT(id);
    jm1 = NUM2INT(jm);
    jd1 = NUM2INT(jd);
    omega1 = NUM2DBL(omega);
    barphi1 = NUM2DBL(barphi);
    dnu1 = NUM2DBL(dnu);
    alpha1 = NUM2DBL(alpha);
    lev1 = NUM2INT(lev);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((mm1+1)*(mm1+1)) = %d ", *avt1->shape, ((mm1+1)*(mm1+1)) );
    div = na_cast_object(div, NA_DFLOAT);
    GetNArray(div,div1);
    if ( *div1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: div : %d != ((mm1+1)*(mm1+1)) = %d ", *div1->shape, ((mm1+1)*(mm1+1)) );
    phi = na_cast_object(phi, NA_DFLOAT);
    GetNArray(phi,phi1);
    if ( *phi1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: phi : %d != ((mm1+1)*(mm1+1)) = %d ", *phi1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    davt = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(davt,davt1);
    shape[0] = ((mm1+1)*(mm1+1));
    ddiv = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(ddiv,ddiv1);
    shape[0] = ((mm1+1)*(mm1+1));
    dphi = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(dphi,dphi1);
    rn = na_cast_object(rn, NA_DFLOAT);
    GetNArray(rn,rn1);
    if ( *rn1->shape != ((mm1+1)*(mm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: rn : %d != ((mm1+1)*(mm1+1)*2) = %d ", *rn1->shape, ((mm1+1)*(mm1+1)*2) );
    irm = na_cast_object(irm, NA_LINT);
    GetNArray(irm,irm1);
    if ( *irm1->shape != ((mm1+1)*(mm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *irm1->shape );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (jm1*2) = %d ", *y1->shape, (jm1*2) );
    ip = na_cast_object(ip, NA_LINT);
    GetNArray(ip,ip1);
    if ( *ip1->shape != ((mm1+1)/2+mm1+1)*2 ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip1->shape );
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (((mm1+1)/2+mm1+1)*jm1) = %d ", *p1->shape, (((mm1+1)/2+mm1+1)*jm1) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != (((mm1+1)/2*2+3)*(mm1/2+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != (((mm1+1)/2*2+3)*(mm1/2+1)) = %d ", *r1->shape, (((mm1+1)/2*2+3)*(mm1/2+1)) );
    ia = na_cast_object(ia, NA_LINT);
    GetNArray(ia,ia1);
    if ( *ia1->shape != ((mm1+1)*(mm1+1)*4) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ia1->shape );
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)*6) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)*6) = %d ", *a1->shape, ((mm1+1)*(mm1+1)*6) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (((mm1+1)/2+mm1+1)*jm1) = %d ", *q1->shape, (((mm1+1)/2+mm1+1)*jm1) );
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape < 11*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d < 11*(jd1*im1) = %d ", *ws1->shape, 11*(jd1*im1) );
    ww = na_cast_object(ww, NA_DFLOAT);
    GetNArray(ww,ww1);
    if ( *ww1->shape < 11*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ww : %d < 11*(jd1*im1) = %d ", *ww1->shape, 11*(jd1*im1) );

    spswhw_(&mm1,&im1,&id1,&jm1,&jd1,&omega1,&barphi1,&dnu1,&alpha1,&lev1,avt1->ptr,div1->ptr,phi1->ptr,davt1->ptr,ddiv1->ptr,dphi1->ptr,rn1->ptr,irm1->ptr,it1->ptr,t1->ptr,y1->ptr,ip1->ptr,p1->ptr,r1->ptr,ia1->ptr,a1->ptr,q1->ptr,ws1->ptr,ww1->ptr);



    return rb_ary_new3(3, davt, ddiv, dphi);
}

static VALUE
spswhx(self,mm,im,id,jm,jd,omega,barphi,dnu,alpha,lev,avt,div,phi,rn,irm,it,t,y,ip,p,r,ia,a,q,ws,ww)
    VALUE self,mm,im,id,jm,jd,omega,barphi,dnu,alpha,lev,avt,div,phi,rn,irm,it,t,y,ip,p,r,ia,a,q,ws,ww;
{
    int mm1;
    int im1;
    int id1;
    int jm1;
    int jd1;
    double omega1;
    double barphi1;
    double dnu1;
    double alpha1;
    int lev1;
    struct NARRAY *avt1;
    struct NARRAY *div1;
    struct NARRAY *phi1;
    struct NARRAY *davt1;
    VALUE davt;
    struct NARRAY *ddiv1;
    VALUE ddiv;
    struct NARRAY *dphi1;
    VALUE dphi;
    struct NARRAY *rn1;
    struct NARRAY *irm1;
    struct NARRAY *it1;
    struct NARRAY *t1;
    struct NARRAY *y1;
    struct NARRAY *ip1;
    struct NARRAY *p1;
    struct NARRAY *r1;
    struct NARRAY *ia1;
    struct NARRAY *a1;
    struct NARRAY *q1;
    struct NARRAY *ws1;
    struct NARRAY *ww1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    im1 = NUM2INT(im);
    id1 = NUM2INT(id);
    jm1 = NUM2INT(jm);
    jd1 = NUM2INT(jd);
    omega1 = NUM2DBL(omega);
    barphi1 = NUM2DBL(barphi);
    dnu1 = NUM2DBL(dnu);
    alpha1 = NUM2DBL(alpha);
    lev1 = NUM2INT(lev);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((mm1+1)*(mm1+1)) = %d ", *avt1->shape, ((mm1+1)*(mm1+1)) );
    div = na_cast_object(div, NA_DFLOAT);
    GetNArray(div,div1);
    if ( *div1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: div : %d != ((mm1+1)*(mm1+1)) = %d ", *div1->shape, ((mm1+1)*(mm1+1)) );
    phi = na_cast_object(phi, NA_DFLOAT);
    GetNArray(phi,phi1);
    if ( *phi1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: phi : %d != ((mm1+1)*(mm1+1)) = %d ", *phi1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    davt = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(davt,davt1);
    shape[0] = ((mm1+1)*(mm1+1));
    ddiv = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(ddiv,ddiv1);
    shape[0] = ((mm1+1)*(mm1+1));
    dphi = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(dphi,dphi1);
    rn = na_cast_object(rn, NA_DFLOAT);
    GetNArray(rn,rn1);
    if ( *rn1->shape != ((mm1+1)*(mm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: rn : %d != ((mm1+1)*(mm1+1)*2) = %d ", *rn1->shape, ((mm1+1)*(mm1+1)*2) );
    irm = na_cast_object(irm, NA_LINT);
    GetNArray(irm,irm1);
    if ( *irm1->shape != ((mm1+1)*(mm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *irm1->shape );
    it = na_cast_object(it, NA_LINT);
    GetNArray(it,it1);
    if ( *it1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *it1->shape );
    t = na_cast_object(t, NA_DFLOAT);
    GetNArray(t,t1);
    if ( *t1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: t : %d != (im1*2) = %d ", *t1->shape, (im1*2) );
    y = na_cast_object(y, NA_DFLOAT);
    GetNArray(y,y1);
    if ( *y1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: y : %d != (jm1*2) = %d ", *y1->shape, (jm1*2) );
    ip = na_cast_object(ip, NA_LINT);
    GetNArray(ip,ip1);
    if ( *ip1->shape != ((mm1+1)/2+mm1+1)*2 ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ip1->shape );
    p = na_cast_object(p, NA_DFLOAT);
    GetNArray(p,p1);
    if ( *p1->shape != (((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: p : %d != (((mm1+1)/2+mm1+1)*jm1) = %d ", *p1->shape, (((mm1+1)/2+mm1+1)*jm1) );
    r = na_cast_object(r, NA_DFLOAT);
    GetNArray(r,r1);
    if ( *r1->shape != (((mm1+1)/2*2+3)*(mm1/2+1)) ) rb_raise(rb_eArgError, "invalid ary size: r : %d != (((mm1+1)/2*2+3)*(mm1/2+1)) = %d ", *r1->shape, (((mm1+1)/2*2+3)*(mm1/2+1)) );
    ia = na_cast_object(ia, NA_LINT);
    GetNArray(ia,ia1);
    if ( *ia1->shape != ((mm1+1)*(mm1+1)*4) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *ia1->shape );
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)*6) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)*6) = %d ", *a1->shape, ((mm1+1)*(mm1+1)*6) );
    q = na_cast_object(q, NA_DFLOAT);
    GetNArray(q,q1);
    if ( *q1->shape != (((mm1+1)/2+mm1+1)*jm1) ) rb_raise(rb_eArgError, "invalid ary size: q : %d != (((mm1+1)/2+mm1+1)*jm1) = %d ", *q1->shape, (((mm1+1)/2+mm1+1)*jm1) );
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape < 10*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d < 10*(jd1*im1) = %d ", *ws1->shape, 10*(jd1*im1) );
    ww = na_cast_object(ww, NA_DFLOAT);
    GetNArray(ww,ww1);
    if ( *ww1->shape < 10*(jd1*im1) ) rb_raise(rb_eArgError, "invalid ary size: ww : %d < 10*(jd1*im1) = %d ", *ww1->shape, 10*(jd1*im1) );

    spswhx_(&mm1,&im1,&id1,&jm1,&jd1,&omega1,&barphi1,&dnu1,&alpha1,&lev1,avt1->ptr,div1->ptr,phi1->ptr,davt1->ptr,ddiv1->ptr,dphi1->ptr,rn1->ptr,irm1->ptr,it1->ptr,t1->ptr,y1->ptr,ip1->ptr,p1->ptr,r1->ptr,ia1->ptr,a1->ptr,q1->ptr,ws1->ptr,ww1->ptr);



    return rb_ary_new3(3, davt, ddiv, dphi);
}

static VALUE
spswhi(self,mm,barphi,dnu,alpha,lev,dt)
    VALUE self,mm,barphi,dnu,alpha,lev,dt;
{
    int mm1;
    double barphi1;
    double dnu1;
    double alpha1;
    int lev1;
    double dt1;
    struct NARRAY *cl1;
    VALUE cl;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    barphi1 = NUM2DBL(barphi);
    dnu1 = NUM2DBL(dnu);
    alpha1 = NUM2DBL(alpha);
    lev1 = NUM2INT(lev);
    dt1 = NUM2DBL(dt);
    shape[0] = ((mm1+1)*(mm1+1)*5);
    cl = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(cl,cl1);

    spswhi_(&mm1,&barphi1,&dnu1,&alpha1,&lev1,&dt1,cl1->ptr);



    return cl;
}

static VALUE
p2init(self,jm,im)
    VALUE self,jm,im;
{
    int jm1;
    int im1;
    struct NARRAY *itj1;
    VALUE itj;
    struct NARRAY *tj1;
    VALUE tj;
    struct NARRAY *iti1;
    VALUE iti;
    struct NARRAY *ti1;
    VALUE ti;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    shape[0] = (5);
    itj = na_make_object( NA_LINT, rank, shape, cNArray );
    GetNArray(itj,itj1);
    shape[0] = (jm1*2);
    tj = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(tj,tj1);
    shape[0] = (5);
    iti = na_make_object( NA_LINT, rank, shape, cNArray );
    GetNArray(iti,iti1);
    shape[0] = (im1*2);
    ti = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(ti,ti1);

    p2init_(&jm1,&im1,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return rb_ary_new3(4, itj, tj, iti, ti);
}

static VALUE
p2s2ga(self,lm,km,jm,im,s,w,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,s,w,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    struct NARRAY *s1;
    struct NARRAY *g1;
    VALUE g;
    struct NARRAY *w1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    s = na_cast_object(s, NA_DFLOAT);
    GetNArray(s,s1);
    if ( *s1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: s : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *s1->shape, ((2*km1+1)*(2*lm1+1)) );
    shape[0] = (jm1*im1);
    g = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(g,g1);
    w = na_cast_object(w, NA_DFLOAT);
    GetNArray(w,w1);
    if ( *w1->shape != (jm1*im1) ) rb_raise(rb_eArgError, "invalid ary size: w : %d != (jm1*im1) = %d ", *w1->shape, (jm1*im1) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*2) = %d ", *tj1->shape, (jm1*2) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    p2s2ga_(&lm1,&km1,&jm1,&im1,s1->ptr,g1->ptr,w1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return g;
}

static VALUE
p2g2sa(self,lm,km,jm,im,g,w,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,g,w,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    struct NARRAY *g1;
    struct NARRAY *s1;
    VALUE s;
    struct NARRAY *w1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    g = na_cast_object(g, NA_DFLOAT);
    GetNArray(g,g1);
    if ( *g1->shape != (jm1*im1) ) rb_raise(rb_eArgError, "invalid ary size: g : %d != (jm1*im1) = %d ", *g1->shape, (jm1*im1) );
    shape[0] = ((2*km1+1)*(2*lm1+1));
    s = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(s,s1);
    w = na_cast_object(w, NA_DFLOAT);
    GetNArray(w,w1);
    if ( *w1->shape != (jm1*im1) ) rb_raise(rb_eArgError, "invalid ary size: w : %d != (jm1*im1) = %d ", *w1->shape, (jm1*im1) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*2) = %d ", *tj1->shape, (jm1*2) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    p2g2sa_(&lm1,&km1,&jm1,&im1,g1->ptr,s1->ptr,w1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return s;
}

static VALUE
p2ajbs(self,lm,km,jm,im,r,z,ws,wg,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,r,z,ws,wg,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    double r1;
    struct NARRAY *z1;
    struct NARRAY *dz1;
    VALUE dz;
    struct NARRAY *ws1;
    struct NARRAY *wg1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    r1 = NUM2DBL(r);
    z = na_cast_object(z, NA_DFLOAT);
    GetNArray(z,z1);
    if ( *z1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: z : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *z1->shape, ((2*km1+1)*(2*lm1+1)) );
    shape[0] = ((2*km1+1)*(2*lm1+1));
    dz = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(dz,dz1);
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *ws1->shape, ((2*km1+1)*(2*lm1+1)) );
    wg = na_cast_object(wg, NA_DFLOAT);
    GetNArray(wg,wg1);
    if ( *wg1->shape != (jm1*im1*3) ) rb_raise(rb_eArgError, "invalid ary size: wg : %d != (jm1*im1*3) = %d ", *wg1->shape, (jm1*im1*3) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*2) = %d ", *tj1->shape, (jm1*2) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    p2ajbs_(&lm1,&km1,&jm1,&im1,&r1,z1->ptr,dz1->ptr,ws1->ptr,wg1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return dz;
}

static VALUE
p2swnl(self,lm,km,jm,im,r,avt,div,phi,ws,wg,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,r,avt,div,phi,ws,wg,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    double r1;
    struct NARRAY *avt1;
    struct NARRAY *div1;
    struct NARRAY *phi1;
    struct NARRAY *davt1;
    VALUE davt;
    struct NARRAY *ddiv1;
    VALUE ddiv;
    struct NARRAY *dphi1;
    VALUE dphi;
    struct NARRAY *ws1;
    struct NARRAY *wg1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    r1 = NUM2DBL(r);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *avt1->shape, ((2*km1+1)*(2*lm1+1)) );
    div = na_cast_object(div, NA_DFLOAT);
    GetNArray(div,div1);
    if ( *div1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: div : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *div1->shape, ((2*km1+1)*(2*lm1+1)) );
    phi = na_cast_object(phi, NA_DFLOAT);
    GetNArray(phi,phi1);
    if ( *phi1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: phi : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *phi1->shape, ((2*km1+1)*(2*lm1+1)) );
    shape[0] = ((2*km1+1)*(2*lm1+1));
    davt = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(davt,davt1);
    shape[0] = ((2*km1+1)*(2*lm1+1));
    ddiv = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(ddiv,ddiv1);
    shape[0] = ((2*km1+1)*(2*lm1+1));
    dphi = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(dphi,dphi1);
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *ws1->shape, ((2*km1+1)*(2*lm1+1)) );
    wg = na_cast_object(wg, NA_DFLOAT);
    GetNArray(wg,wg1);
    if ( *wg1->shape != (jm1*im1*4) ) rb_raise(rb_eArgError, "invalid ary size: wg : %d != (jm1*im1*4) = %d ", *wg1->shape, (jm1*im1*4) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*2) = %d ", *tj1->shape, (jm1*2) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    p2swnl_(&lm1,&km1,&jm1,&im1,&r1,avt1->ptr,div1->ptr,phi1->ptr,davt1->ptr,ddiv1->ptr,dphi1->ptr,ws1->ptr,wg1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return rb_ary_new3(3, davt, ddiv, dphi);
}

static VALUE
p2swnn(self,lm,km,jm,im,r,barphi,f,avt,div,phi,ws,wg,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,r,barphi,f,avt,div,phi,ws,wg,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    double r1;
    double barphi1;
    double f1;
    struct NARRAY *avt1;
    struct NARRAY *div1;
    struct NARRAY *phi1;
    struct NARRAY *davt1;
    VALUE davt;
    struct NARRAY *ddiv1;
    VALUE ddiv;
    struct NARRAY *dphi1;
    VALUE dphi;
    struct NARRAY *ws1;
    struct NARRAY *wg1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    r1 = NUM2DBL(r);
    barphi1 = NUM2DBL(barphi);
    f1 = NUM2DBL(f);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *avt1->shape, ((2*km1+1)*(2*lm1+1)) );
    div = na_cast_object(div, NA_DFLOAT);
    GetNArray(div,div1);
    if ( *div1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: div : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *div1->shape, ((2*km1+1)*(2*lm1+1)) );
    phi = na_cast_object(phi, NA_DFLOAT);
    GetNArray(phi,phi1);
    if ( *phi1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: phi : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *phi1->shape, ((2*km1+1)*(2*lm1+1)) );
    shape[0] = ((2*km1+1)*(2*lm1+1));
    davt = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(davt,davt1);
    shape[0] = ((2*km1+1)*(2*lm1+1));
    ddiv = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(ddiv,ddiv1);
    shape[0] = ((2*km1+1)*(2*lm1+1));
    dphi = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(dphi,dphi1);
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *ws1->shape, ((2*km1+1)*(2*lm1+1)) );
    wg = na_cast_object(wg, NA_DFLOAT);
    GetNArray(wg,wg1);
    if ( *wg1->shape != (jm1*im1*4) ) rb_raise(rb_eArgError, "invalid ary size: wg : %d != (jm1*im1*4) = %d ", *wg1->shape, (jm1*im1*4) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*2) = %d ", *tj1->shape, (jm1*2) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    p2swnn_(&lm1,&km1,&jm1,&im1,&r1,&barphi1,&f1,avt1->ptr,div1->ptr,phi1->ptr,davt1->ptr,ddiv1->ptr,dphi1->ptr,ws1->ptr,wg1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return rb_ary_new3(3, davt, ddiv, dphi);
}

static VALUE
p2swck(self,lm,km,jm,im,r,avt,div,phi,ws,wg,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,r,avt,div,phi,ws,wg,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    double r1;
    struct NARRAY *avt1;
    struct NARRAY *div1;
    struct NARRAY *phi1;
    double aene1;
    VALUE aene;
    double aens1;
    VALUE aens;
    struct NARRAY *ws1;
    struct NARRAY *wg1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;



    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    r1 = NUM2DBL(r);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *avt1->shape, ((2*km1+1)*(2*lm1+1)) );
    div = na_cast_object(div, NA_DFLOAT);
    GetNArray(div,div1);
    if ( *div1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: div : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *div1->shape, ((2*km1+1)*(2*lm1+1)) );
    phi = na_cast_object(phi, NA_DFLOAT);
    GetNArray(phi,phi1);
    if ( *phi1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: phi : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *phi1->shape, ((2*km1+1)*(2*lm1+1)) );
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *ws1->shape, ((2*km1+1)*(2*lm1+1)) );
    wg = na_cast_object(wg, NA_DFLOAT);
    GetNArray(wg,wg1);
    if ( *wg1->shape != (jm1*im1*4) ) rb_raise(rb_eArgError, "invalid ary size: wg : %d != (jm1*im1*4) = %d ", *wg1->shape, (jm1*im1*4) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*2) = %d ", *tj1->shape, (jm1*2) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    p2swck_(&lm1,&km1,&jm1,&im1,&r1,avt1->ptr,div1->ptr,phi1->ptr,&aene1,&aens1,ws1->ptr,wg1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);


    aene = rb_float_new(aene1);
    aens = rb_float_new(aens1);

    return rb_ary_new3(2, aene, aens);
}

static VALUE
p2swbl(self,lm,km,jm,im,r,barphi,avt,ws,wg,itj,tj,iti,ti)
    VALUE self,lm,km,jm,im,r,barphi,avt,ws,wg,itj,tj,iti,ti;
{
    int lm1;
    int km1;
    int jm1;
    int im1;
    double r1;
    double barphi1;
    struct NARRAY *avt1;
    struct NARRAY *phi1;
    VALUE phi;
    struct NARRAY *ws1;
    struct NARRAY *wg1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    r1 = NUM2DBL(r);
    barphi1 = NUM2DBL(barphi);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *avt1->shape, ((2*km1+1)*(2*lm1+1)) );
    shape[0] = ((2*km1+1)*(2*lm1+1));
    phi = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(phi,phi1);
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape != ((2*km1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d != ((2*km1+1)*(2*lm1+1)) = %d ", *ws1->shape, ((2*km1+1)*(2*lm1+1)) );
    wg = na_cast_object(wg, NA_DFLOAT);
    GetNArray(wg,wg1);
    if ( *wg1->shape != (jm1*im1*4) ) rb_raise(rb_eArgError, "invalid ary size: wg : %d != (jm1*im1*4) = %d ", *wg1->shape, (jm1*im1*4) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*2) = %d ", *tj1->shape, (jm1*2) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    p2swbl_(&lm1,&km1,&jm1,&im1,&r1,&barphi1,avt1->ptr,phi1->ptr,ws1->ptr,wg1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return phi;
}

static VALUE
p3init(self,km,jm,im)
    VALUE self,km,jm,im;
{
    int km1;
    int jm1;
    int im1;
    struct NARRAY *itk1;
    VALUE itk;
    struct NARRAY *tk1;
    VALUE tk;
    struct NARRAY *itj1;
    VALUE itj;
    struct NARRAY *tj1;
    VALUE tj;
    struct NARRAY *iti1;
    VALUE iti;
    struct NARRAY *ti1;
    VALUE ti;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    shape[0] = (5);
    itk = na_make_object( NA_LINT, rank, shape, cNArray );
    GetNArray(itk,itk1);
    shape[0] = (km1*2);
    tk = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(tk,tk1);
    shape[0] = (5);
    itj = na_make_object( NA_LINT, rank, shape, cNArray );
    GetNArray(itj,itj1);
    shape[0] = (jm1*2);
    tj = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(tj,tj1);
    shape[0] = (5);
    iti = na_make_object( NA_LINT, rank, shape, cNArray );
    GetNArray(iti,iti1);
    shape[0] = (im1*2);
    ti = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(ti,ti1);

    p3init_(&km1,&jm1,&im1,itk1->ptr,tk1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return rb_ary_new3(6, itk, tk, itj, tj, iti, ti);
}

static VALUE
p3s2ga(self,nm,mm,lm,km,jm,im,s,w,itk,tk,itj,tj,iti,ti)
    VALUE self,nm,mm,lm,km,jm,im,s,w,itk,tk,itj,tj,iti,ti;
{
    int nm1;
    int mm1;
    int lm1;
    int km1;
    int jm1;
    int im1;
    struct NARRAY *s1;
    struct NARRAY *g1;
    VALUE g;
    struct NARRAY *w1;
    struct NARRAY *itk1;
    struct NARRAY *tk1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    nm1 = NUM2INT(nm);
    mm1 = NUM2INT(mm);
    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    s = na_cast_object(s, NA_DFLOAT);
    GetNArray(s,s1);
    if ( *s1->shape != ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: s : %d != ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)) = %d ", *s1->shape, ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)) );
    shape[0] = (km1*jm1*im1);
    g = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(g,g1);
    w = na_cast_object(w, NA_DFLOAT);
    GetNArray(w,w1);
    if ( *w1->shape != (km1*jm1*im1) ) rb_raise(rb_eArgError, "invalid ary size: w : %d != (km1*jm1*im1) = %d ", *w1->shape, (km1*jm1*im1) );
    itk = na_cast_object(itk, NA_LINT);
    GetNArray(itk,itk1);
    if ( *itk1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itk1->shape );
    tk = na_cast_object(tk, NA_DFLOAT);
    GetNArray(tk,tk1);
    if ( *tk1->shape != (km1*2) ) rb_raise(rb_eArgError, "invalid ary size: tk : %d != (km1*2) = %d ", *tk1->shape, (km1*2) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*2) = %d ", *tj1->shape, (jm1*2) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    p3s2ga_(&nm1,&mm1,&lm1,&km1,&jm1,&im1,s1->ptr,g1->ptr,w1->ptr,itk1->ptr,tk1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return g;
}

static VALUE
p3g2sa(self,nm,mm,lm,km,jm,im,g,w,itk,tk,itj,tj,iti,ti)
    VALUE self,nm,mm,lm,km,jm,im,g,w,itk,tk,itj,tj,iti,ti;
{
    int nm1;
    int mm1;
    int lm1;
    int km1;
    int jm1;
    int im1;
    struct NARRAY *g1;
    struct NARRAY *s1;
    VALUE s;
    struct NARRAY *w1;
    struct NARRAY *itk1;
    struct NARRAY *tk1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    nm1 = NUM2INT(nm);
    mm1 = NUM2INT(mm);
    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    g = na_cast_object(g, NA_DFLOAT);
    GetNArray(g,g1);
    if ( *g1->shape != (km1*jm1*im1) ) rb_raise(rb_eArgError, "invalid ary size: g : %d != (km1*jm1*im1) = %d ", *g1->shape, (km1*jm1*im1) );
    shape[0] = ((2*nm1+1)*(2*mm1+1)*(2*lm1+1));
    s = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(s,s1);
    w = na_cast_object(w, NA_DFLOAT);
    GetNArray(w,w1);
    if ( *w1->shape != (km1*jm1*im1) ) rb_raise(rb_eArgError, "invalid ary size: w : %d != (km1*jm1*im1) = %d ", *w1->shape, (km1*jm1*im1) );
    itk = na_cast_object(itk, NA_LINT);
    GetNArray(itk,itk1);
    if ( *itk1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itk1->shape );
    tk = na_cast_object(tk, NA_DFLOAT);
    GetNArray(tk,tk1);
    if ( *tk1->shape != (km1*2) ) rb_raise(rb_eArgError, "invalid ary size: tk : %d != (km1*2) = %d ", *tk1->shape, (km1*2) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*2) = %d ", *tj1->shape, (jm1*2) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    p3g2sa_(&nm1,&mm1,&lm1,&km1,&jm1,&im1,g1->ptr,s1->ptr,w1->ptr,itk1->ptr,tk1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return s;
}

static VALUE
p3elnl(self,nm,mm,lm,km,jm,im,z,ws,w,itk,tk,itj,tj,iti,ti)
    VALUE self,nm,mm,lm,km,jm,im,z,ws,w,itk,tk,itj,tj,iti,ti;
{
    int nm1;
    int mm1;
    int lm1;
    int km1;
    int jm1;
    int im1;
    struct NARRAY *z1;
    struct NARRAY *dz1;
    VALUE dz;
    struct NARRAY *ws1;
    struct NARRAY *w1;
    struct NARRAY *itk1;
    struct NARRAY *tk1;
    struct NARRAY *itj1;
    struct NARRAY *tj1;
    struct NARRAY *iti1;
    struct NARRAY *ti1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    nm1 = NUM2INT(nm);
    mm1 = NUM2INT(mm);
    lm1 = NUM2INT(lm);
    km1 = NUM2INT(km);
    jm1 = NUM2INT(jm);
    im1 = NUM2INT(im);
    z = na_cast_object(z, NA_DFLOAT);
    GetNArray(z,z1);
    if ( *z1->shape != ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: z : %d != ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)*2) = %d ", *z1->shape, ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)*2) );
    shape[0] = ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)*2);
    dz = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(dz,dz1);
    ws = na_cast_object(ws, NA_DFLOAT);
    GetNArray(ws,ws1);
    if ( *ws1->shape != ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: ws : %d != ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)) = %d ", *ws1->shape, ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)) );
    w = na_cast_object(w, NA_DFLOAT);
    GetNArray(w,w1);
    if ( *w1->shape != (km1*jm1*im1*4) ) rb_raise(rb_eArgError, "invalid ary size: w : %d != (km1*jm1*im1*4) = %d ", *w1->shape, (km1*jm1*im1*4) );
    itk = na_cast_object(itk, NA_LINT);
    GetNArray(itk,itk1);
    if ( *itk1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itk1->shape );
    tk = na_cast_object(tk, NA_DFLOAT);
    GetNArray(tk,tk1);
    if ( *tk1->shape != (km1*2) ) rb_raise(rb_eArgError, "invalid ary size: tk : %d != (km1*2) = %d ", *tk1->shape, (km1*2) );
    itj = na_cast_object(itj, NA_LINT);
    GetNArray(itj,itj1);
    if ( *itj1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *itj1->shape );
    tj = na_cast_object(tj, NA_DFLOAT);
    GetNArray(tj,tj1);
    if ( *tj1->shape != (jm1*2) ) rb_raise(rb_eArgError, "invalid ary size: tj : %d != (jm1*2) = %d ", *tj1->shape, (jm1*2) );
    iti = na_cast_object(iti, NA_LINT);
    GetNArray(iti,iti1);
    if ( *iti1->shape != (5) ) rb_raise(rb_eArgError, "invalid ary size: v(%d)", *iti1->shape );
    ti = na_cast_object(ti, NA_DFLOAT);
    GetNArray(ti,ti1);
    if ( *ti1->shape != (im1*2) ) rb_raise(rb_eArgError, "invalid ary size: ti : %d != (im1*2) = %d ", *ti1->shape, (im1*2) );

    p3elnl_(&nm1,&mm1,&lm1,&km1,&jm1,&im1,z1->ptr,dz1->ptr,ws1->ptr,w1->ptr,itk1->ptr,tk1->ptr,itj1->ptr,tj1->ptr,iti1->ptr,ti1->ptr);



    return dz;
}

static VALUE
p3cnsv(self,nm,mm,lm,z)
    VALUE self,nm,mm,lm,z;
{
    int nm1;
    int mm1;
    int lm1;
    struct NARRAY *z1;
    double e1;
    VALUE e;
    double h1;
    VALUE h;



    nm1 = NUM2INT(nm);
    mm1 = NUM2INT(mm);
    lm1 = NUM2INT(lm);
    z = na_cast_object(z, NA_DFLOAT);
    GetNArray(z,z1);
    if ( *z1->shape != ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: z : %d != ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)*2) = %d ", *z1->shape, ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)*2) );

    p3cnsv_(&nm1,&mm1,&lm1,z1->ptr,&e1,&h1);


    e = rb_float_new(e1);
    h = rb_float_new(h1);

    return rb_ary_new3(2, e, h);
}

static VALUE
p3espt(self,nm,mm,lm,kmax,z)
    VALUE self,nm,mm,lm,kmax,z;
{
    int nm1;
    int mm1;
    int lm1;
    int kmax1;
    struct NARRAY *z1;
    struct NARRAY *es1;
    VALUE es;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    nm1 = NUM2INT(nm);
    mm1 = NUM2INT(mm);
    lm1 = NUM2INT(lm);
    kmax1 = NUM2INT(kmax);
    z = na_cast_object(z, NA_DFLOAT);
    GetNArray(z,z1);
    if ( *z1->shape != ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: z : %d != ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)*2) = %d ", *z1->shape, ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)*2) );
    shape[0] = (kmax1);
    es = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(es,es1);

    p3espt_(&nm1,&mm1,&lm1,&kmax1,z1->ptr,es1->ptr);



    return es;
}

static VALUE
p3geto(self,nm,mm,lm,z,isw)
    VALUE self,nm,mm,lm,z,isw;
{
    int nm1;
    int mm1;
    int lm1;
    struct NARRAY *z1;
    struct NARRAY *o1;
    VALUE o;
    int isw1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    nm1 = NUM2INT(nm);
    mm1 = NUM2INT(mm);
    lm1 = NUM2INT(lm);
    z = na_cast_object(z, NA_DFLOAT);
    GetNArray(z,z1);
    if ( *z1->shape != ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: z : %d != ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)*2) = %d ", *z1->shape, ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)*2) );
    shape[0] = ((2*nm1+1)*(2*mm1+1)*(2*lm1+1));
    o = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(o,o1);
    isw1 = NUM2INT(isw);

    p3geto_(&nm1,&mm1,&lm1,z1->ptr,o1->ptr,&isw1);



    return o;
}

static VALUE
p3getu(self,nm,mm,lm,z,isw)
    VALUE self,nm,mm,lm,z,isw;
{
    int nm1;
    int mm1;
    int lm1;
    struct NARRAY *z1;
    struct NARRAY *u1;
    VALUE u;
    int isw1;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    nm1 = NUM2INT(nm);
    mm1 = NUM2INT(mm);
    lm1 = NUM2INT(lm);
    z = na_cast_object(z, NA_DFLOAT);
    GetNArray(z,z1);
    if ( *z1->shape != ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: z : %d != ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)*2) = %d ", *z1->shape, ((2*nm1+1)*(2*mm1+1)*(2*lm1+1)*2) );
    shape[0] = ((2*nm1+1)*(2*mm1+1)*(2*lm1+1));
    u = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(u,u1);
    isw1 = NUM2INT(isw);

    p3getu_(&nm1,&mm1,&lm1,z1->ptr,u1->ptr,&isw1);



    return u;
}

static VALUE
ndcp2a(self,mm,omg,psi)
    VALUE self,mm,omg,psi;
{
    int mm1;
    double omg1;
    struct NARRAY *psi1;
    struct NARRAY *avt1;
    VALUE avt;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    omg1 = NUM2DBL(omg);
    psi = na_cast_object(psi, NA_DFLOAT);
    GetNArray(psi,psi1);
    if ( *psi1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: psi : %d != ((mm1+1)*(mm1+1)) = %d ", *psi1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    avt = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(avt,avt1);

    ndcp2a_(&mm1,&omg1,psi1->ptr,avt1->ptr);



    return avt;
}

static VALUE
ndca2p(self,mm,omg,avt)
    VALUE self,mm,omg,avt;
{
    int mm1;
    double omg1;
    struct NARRAY *avt1;
    struct NARRAY *psi1;
    VALUE psi;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    omg1 = NUM2DBL(omg);
    avt = na_cast_object(avt, NA_DFLOAT);
    GetNArray(avt,avt1);
    if ( *avt1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: avt : %d != ((mm1+1)*(mm1+1)) = %d ", *avt1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    psi = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(psi,psi1);

    ndca2p_(&mm1,&omg1,avt1->ptr,psi1->ptr);



    return psi;
}

static VALUE
ndgeea(self,mm,psi)
    VALUE self,mm,psi;
{
    int mm1;
    struct NARRAY *psi1;
    double ene1;
    VALUE ene;



    mm1 = NUM2INT(mm);
    psi = na_cast_object(psi, NA_DFLOAT);
    GetNArray(psi,psi1);
    if ( *psi1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: psi : %d != ((mm1+1)*(mm1+1)) = %d ", *psi1->shape, ((mm1+1)*(mm1+1)) );

    ndgeea_(&mm1,psi1->ptr,&ene1);


    ene = rb_float_new(ene1);

    return ene;
}

static VALUE
ndgeez(self,mm,psi)
    VALUE self,mm,psi;
{
    int mm1;
    struct NARRAY *psi1;
    double ene1;
    VALUE ene;



    mm1 = NUM2INT(mm);
    psi = na_cast_object(psi, NA_DFLOAT);
    GetNArray(psi,psi1);
    if ( *psi1->shape != (mm1+1) ) rb_raise(rb_eArgError, "invalid ary size: psi : %d != (mm1+1) = %d ", *psi1->shape, (mm1+1) );

    ndgeez_(&mm1,psi1->ptr,&ene1);


    ene = rb_float_new(ene1);

    return ene;
}

static VALUE
ndgeew(self,mm,m,psi)
    VALUE self,mm,m,psi;
{
    int mm1;
    int m1;
    struct NARRAY *psi1;
    double ene1;
    VALUE ene;



    mm1 = NUM2INT(mm);
    m1 = NUM2INT(m);
    psi = na_cast_object(psi, NA_DFLOAT);
    GetNArray(psi,psi1);
    if ( *psi1->shape != ((mm1-m1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: psi : %d != ((mm1-m1+1)*2) = %d ", *psi1->shape, ((mm1-m1+1)*2) );

    ndgeew_(&mm1,&m1,psi1->ptr,&ene1);


    ene = rb_float_new(ene1);

    return ene;
}

static VALUE
ndgena(self,mm,psi)
    VALUE self,mm,psi;
{
    int mm1;
    struct NARRAY *psi1;
    double ens1;
    VALUE ens;



    mm1 = NUM2INT(mm);
    psi = na_cast_object(psi, NA_DFLOAT);
    GetNArray(psi,psi1);
    if ( *psi1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: psi : %d != ((mm1+1)*(mm1+1)) = %d ", *psi1->shape, ((mm1+1)*(mm1+1)) );

    ndgena_(&mm1,psi1->ptr,&ens1);


    ens = rb_float_new(ens1);

    return ens;
}

static VALUE
ndgenz(self,mm,psi)
    VALUE self,mm,psi;
{
    int mm1;
    struct NARRAY *psi1;
    double ens1;
    VALUE ens;



    mm1 = NUM2INT(mm);
    psi = na_cast_object(psi, NA_DFLOAT);
    GetNArray(psi,psi1);
    if ( *psi1->shape != (mm1+1) ) rb_raise(rb_eArgError, "invalid ary size: psi : %d != (mm1+1) = %d ", *psi1->shape, (mm1+1) );

    ndgenz_(&mm1,psi1->ptr,&ens1);


    ens = rb_float_new(ens1);

    return ens;
}

static VALUE
ndgenw(self,mm,m,psi)
    VALUE self,mm,m,psi;
{
    int mm1;
    int m1;
    struct NARRAY *psi1;
    double ens1;
    VALUE ens;



    mm1 = NUM2INT(mm);
    m1 = NUM2INT(m);
    psi = na_cast_object(psi, NA_DFLOAT);
    GetNArray(psi,psi1);
    if ( *psi1->shape != ((mm1-m1+1)*2) ) rb_raise(rb_eArgError, "invalid ary size: psi : %d != ((mm1-m1+1)*2) = %d ", *psi1->shape, ((mm1-m1+1)*2) );

    ndgenw_(&mm1,&m1,psi1->ptr,&ens1);


    ens = rb_float_new(ens1);

    return ens;
}

static VALUE
ndvis1(self,mm,a)
    VALUE self,mm,a;
{
    int mm1;
    struct NARRAY *a1;
    struct NARRAY *b1;
    VALUE b;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)) = %d ", *a1->shape, ((mm1+1)*(mm1+1)) );
    shape[0] = ((mm1+1)*(mm1+1));
    b = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(b,b1);

    ndvis1_(&mm1,a1->ptr,b1->ptr);



    return b;
}

static VALUE
nddisi(self,mm,lev,dtdnu)
    VALUE self,mm,lev,dtdnu;
{
    int mm1;
    int lev1;
    double dtdnu1;
    struct NARRAY *d1;
    VALUE d;

    int rank=1,*shape;
    shape = ALLOCA_N(int, rank);


    mm1 = NUM2INT(mm);
    lev1 = NUM2INT(lev);
    dtdnu1 = NUM2DBL(dtdnu);
    shape[0] = (mm1+1);
    d = na_make_object( NA_DFLOAT, rank, shape, cNArray );
    GetNArray(d,d1);

    nddisi_(&mm1,&lev1,&dtdnu1,d1->ptr);



    return d;
}

static VALUE
nddisa(self,mm,a,d)
    VALUE self,mm,a,d;
{
    int mm1;
    struct NARRAY *a1;
    struct NARRAY *d1;



    mm1 = NUM2INT(mm);
    a = na_cast_object(a, NA_DFLOAT);
    GetNArray(a,a1);
    if ( *a1->shape != ((mm1+1)*(mm1+1)) ) rb_raise(rb_eArgError, "invalid ary size: a : %d != ((mm1+1)*(mm1+1)) = %d ", *a1->shape, ((mm1+1)*(mm1+1)) );
    d = na_cast_object(d, NA_DFLOAT);
    GetNArray(d,d1);
    if ( *d1->shape != (mm1+1) ) rb_raise(rb_eArgError, "invalid ary size: d : %d != (mm1+1) = %d ", *d1->shape, (mm1+1) );

    nddisa_(&mm1,a1->ptr,d1->ptr);



    return a;
}

static VALUE
ndtv2a(self,omg,vrt)
    VALUE self,omg,vrt;
{
    double omg1;
    struct NARRAY *vrt1;



    omg1 = NUM2DBL(omg);
    vrt = na_cast_object(vrt, NA_DFLOAT);
    GetNArray(vrt,vrt1);
    if ( *vrt1->shape < 2 ) rb_raise(rb_eArgError, "invalid ary size: vrt : %d < 2 = %d ", *vrt1->shape, 2 );

    ndtv2a_(&omg1,vrt1->ptr);



    return vrt;
}

static VALUE
ndta2v(self,omg,vrt)
    VALUE self,omg,vrt;
{
    double omg1;
    struct NARRAY *vrt1;



    omg1 = NUM2DBL(omg);
    vrt = na_cast_object(vrt, NA_DFLOAT);
    GetNArray(vrt,vrt1);
    if ( *vrt1->shape < 2 ) rb_raise(rb_eArgError, "invalid ary size: vrt : %d < 2 = %d ", *vrt1->shape, 2 );

    ndta2v_(&omg1,vrt1->ptr);



    return vrt;
}


Init_ispack_raw()
{
    VALUE mISPACK = rb_define_module("ISPACK");
    rb_define_module_function(mISPACK,"aptime",aptime,0);
    rb_define_module_function(mISPACK,"stinit",stinit,3);
    rb_define_module_function(mISPACK,"ltinit",ltinit,2);
    rb_define_module_function(mISPACK,"stogrd",stogrd,3);
    rb_define_module_function(mISPACK,"ltogrd",ltogrd,2);
    rb_define_module_function(mISPACK,"stnm2l",stnm2l,3);
    rb_define_module_function(mISPACK,"stl2nm",stl2nm,2);
    rb_define_module_function(mISPACK,"stclfa",stclfa,2);
    rb_define_module_function(mISPACK,"ltclfz",ltclfz,2);
    rb_define_module_function(mISPACK,"ltclfw",ltclfw,3);
    rb_define_module_function(mISPACK,"stclba",stclba,2);
    rb_define_module_function(mISPACK,"ltclbz",ltclbz,2);
    rb_define_module_function(mISPACK,"ltclbw",ltclbw,3);
    rb_define_module_function(mISPACK,"sts2ga",sts2ga,9);
    rb_define_module_function(mISPACK,"lts2gz",lts2gz,7);
    rb_define_module_function(mISPACK,"lts2gw",lts2gw,8);
    rb_define_module_function(mISPACK,"sts2va",sts2va,9);
    rb_define_module_function(mISPACK,"lts2vz",lts2vz,7);
    rb_define_module_function(mISPACK,"lts2vw",lts2vw,8);
    rb_define_module_function(mISPACK,"stsrva",stsrva,9);
    rb_define_module_function(mISPACK,"ltsrvz",ltsrvz,7);
    rb_define_module_function(mISPACK,"ltsrvw",ltsrvw,8);
    rb_define_module_function(mISPACK,"stg2sa",stg2sa,9);
    rb_define_module_function(mISPACK,"ltg2sz",ltg2sz,6);
    rb_define_module_function(mISPACK,"ltg2sw",ltg2sw,7);
    rb_define_module_function(mISPACK,"stv2sa",stv2sa,10);
    rb_define_module_function(mISPACK,"ltv2sz",ltv2sz,6);
    rb_define_module_function(mISPACK,"ltv2sw",ltv2sw,8);
    rb_define_module_function(mISPACK,"stvrsa",stvrsa,10);
    rb_define_module_function(mISPACK,"ltvrsz",ltvrsz,6);
    rb_define_module_function(mISPACK,"ltvrsw",ltvrsw,8);
    rb_define_module_function(mISPACK,"stajba",stajba,10);
    rb_define_module_function(mISPACK,"sminit",sminit,4);
    rb_define_module_function(mISPACK,"smnm2l",smnm2l,3);
    rb_define_module_function(mISPACK,"sml2nm",sml2nm,2);
    rb_define_module_function(mISPACK,"smclap",smclap,4);
    rb_define_module_function(mISPACK,"smts2g",smts2g,13);
    rb_define_module_function(mISPACK,"smtg2s",smtg2s,13);
    rb_define_module_function(mISPACK,"smts2v",smts2v,14);
    rb_define_module_function(mISPACK,"smtv2s",smtv2s,14);
    rb_define_module_function(mISPACK,"smts1v",smts1v,13);
    rb_define_module_function(mISPACK,"smtv1s",smtv1s,14);
    rb_define_module_function(mISPACK,"snnm2l",snnm2l,2);
    rb_define_module_function(mISPACK,"snl2nm",snl2nm,1);
    rb_define_module_function(mISPACK,"sninit",sninit,3);
    rb_define_module_function(mISPACK,"snkini",snkini,6);
    rb_define_module_function(mISPACK,"snts2g",snts2g,19);
    rb_define_module_function(mISPACK,"sntg2s",sntg2s,19);
    rb_define_module_function(mISPACK,"soinit",soinit,1);
    rb_define_module_function(mISPACK,"sondnl",sondnl,18);
    rb_define_module_function(mISPACK,"c2init",c2init,2);
    rb_define_module_function(mISPACK,"c2s2ga",c2s2ga,10);
    rb_define_module_function(mISPACK,"c2s2gt",c2s2gt,3);
    rb_define_module_function(mISPACK,"c2g2sa",c2g2sa,11);
    rb_define_module_function(mISPACK,"c2g2st",c2g2st,3);
    rb_define_module_function(mISPACK,"c2ajcb",c2ajcb,12);
    rb_define_module_function(mISPACK,"c2ajc2",c2ajc2,13);
    rb_define_module_function(mISPACK,"c2ajbs",c2ajbs,12);
    rb_define_module_function(mISPACK,"c2ajb2",c2ajb2,13);
    rb_define_module_function(mISPACK,"c2swnl",c2swnl,14);
    rb_define_module_function(mISPACK,"c2swnn",c2swnn,14);
    rb_define_module_function(mISPACK,"c2swck",c2swck,14);
    rb_define_module_function(mISPACK,"c2swbl",c2swbl,14);
    rb_define_module_function(mISPACK,"fttzli",fttzli,3);
    rb_define_module_function(mISPACK,"fttzlm",fttzlm,6);
    rb_define_module_function(mISPACK,"fttzui",fttzui,3);
    rb_define_module_function(mISPACK,"fttzuf",fttzuf,6);
    rb_define_module_function(mISPACK,"fttzub",fttzub,6);
    rb_define_module_function(mISPACK,"fttrui",fttrui,3);
    rb_define_module_function(mISPACK,"fttruf",fttruf,6);
    rb_define_module_function(mISPACK,"fttrub",fttrub,6);
    rb_define_module_function(mISPACK,"fttcti",fttcti,3);
    rb_define_module_function(mISPACK,"fttctf",fttctf,6);
    rb_define_module_function(mISPACK,"fttctb",fttctb,6);
    rb_define_module_function(mISPACK,"fttsti",fttsti,3);
    rb_define_module_function(mISPACK,"fttstf",fttstf,6);
    rb_define_module_function(mISPACK,"fttstb",fttstb,6);
    rb_define_module_function(mISPACK,"fttcmi",fttcmi,3);
    rb_define_module_function(mISPACK,"fttcmf",fttcmf,6);
    rb_define_module_function(mISPACK,"fttcmb",fttcmb,6);
    rb_define_module_function(mISPACK,"fttsmi",fttsmi,3);
    rb_define_module_function(mISPACK,"fttsmf",fttsmf,6);
    rb_define_module_function(mISPACK,"fttsmb",fttsmb,6);
    rb_define_module_function(mISPACK,"n2init",n2init,2);
    rb_define_module_function(mISPACK,"n2s2ga",n2s2ga,10);
    rb_define_module_function(mISPACK,"n2g2sa",n2g2sa,10);
    rb_define_module_function(mISPACK,"n2ajbs",n2ajbs,11);
    rb_define_module_function(mISPACK,"n2swnl",n2swnl,13);
    rb_define_module_function(mISPACK,"n2swnn",n2swnn,15);
    rb_define_module_function(mISPACK,"n2swck",n2swck,13);
    rb_define_module_function(mISPACK,"n2swbl",n2swbl,12);
    rb_define_module_function(mISPACK,"spnjcb",spnjcb,21);
    rb_define_module_function(mISPACK,"spnini",spnini,1);
    rb_define_module_function(mISPACK,"spmini",spmini,1);
    rb_define_module_function(mISPACK,"spclap",spclap,3);
    rb_define_module_function(mISPACK,"spclam",spclam,3);
    rb_define_module_function(mISPACK,"spswnl",spswnl,24);
    rb_define_module_function(mISPACK,"spswck",spswck,21);
    rb_define_module_function(mISPACK,"spswnv",spswnv,25);
    rb_define_module_function(mISPACK,"spswli",spswli,5);
    rb_define_module_function(mISPACK,"spswlv",spswlv,5);
    rb_define_module_function(mISPACK,"spswcv",spswcv,21);
    rb_define_module_function(mISPACK,"spswcx",spswcx,21);
    rb_define_module_function(mISPACK,"spswnw",spswnw,25);
    rb_define_module_function(mISPACK,"spswnx",spswnx,25);
    rb_define_module_function(mISPACK,"spswhv",spswhv,26);
    rb_define_module_function(mISPACK,"spswhw",spswhw,26);
    rb_define_module_function(mISPACK,"spswhx",spswhx,26);
    rb_define_module_function(mISPACK,"spswhi",spswhi,6);
    rb_define_module_function(mISPACK,"p2init",p2init,2);
    rb_define_module_function(mISPACK,"p2s2ga",p2s2ga,10);
    rb_define_module_function(mISPACK,"p2g2sa",p2g2sa,10);
    rb_define_module_function(mISPACK,"p2ajbs",p2ajbs,12);
    rb_define_module_function(mISPACK,"p2swnl",p2swnl,14);
    rb_define_module_function(mISPACK,"p2swnn",p2swnn,16);
    rb_define_module_function(mISPACK,"p2swck",p2swck,14);
    rb_define_module_function(mISPACK,"p2swbl",p2swbl,13);
    rb_define_module_function(mISPACK,"p3init",p3init,3);
    rb_define_module_function(mISPACK,"p3s2ga",p3s2ga,14);
    rb_define_module_function(mISPACK,"p3g2sa",p3g2sa,14);
    rb_define_module_function(mISPACK,"p3elnl",p3elnl,15);
    rb_define_module_function(mISPACK,"p3cnsv",p3cnsv,4);
    rb_define_module_function(mISPACK,"p3espt",p3espt,5);
    rb_define_module_function(mISPACK,"p3geto",p3geto,5);
    rb_define_module_function(mISPACK,"p3getu",p3getu,5);
    rb_define_module_function(mISPACK,"ndcp2a",ndcp2a,3);
    rb_define_module_function(mISPACK,"ndca2p",ndca2p,3);
    rb_define_module_function(mISPACK,"ndgeea",ndgeea,2);
    rb_define_module_function(mISPACK,"ndgeez",ndgeez,2);
    rb_define_module_function(mISPACK,"ndgeew",ndgeew,3);
    rb_define_module_function(mISPACK,"ndgena",ndgena,2);
    rb_define_module_function(mISPACK,"ndgenz",ndgenz,2);
    rb_define_module_function(mISPACK,"ndgenw",ndgenw,3);
    rb_define_module_function(mISPACK,"ndvis1",ndvis1,2);
    rb_define_module_function(mISPACK,"nddisi",nddisi,3);
    rb_define_module_function(mISPACK,"nddisa",nddisa,3);
    rb_define_module_function(mISPACK,"ndtv2a",ndtv2a,2);
    rb_define_module_function(mISPACK,"ndta2v",ndta2v,2);
}
